searchData={"items":[{"type":"module","title":"GoogleApi.CloudAsset.V1","doc":"API client metadata for GoogleApi.CloudAsset.V1.","ref":"GoogleApi.CloudAsset.V1.html"},{"type":"function","title":"GoogleApi.CloudAsset.V1.discovery_revision/0","doc":"","ref":"GoogleApi.CloudAsset.V1.html#discovery_revision/0"},{"type":"module","title":"GoogleApi.CloudAsset.V1.Api.Assets","doc":"API calls for all endpoints tagged `Assets`.","ref":"GoogleApi.CloudAsset.V1.Api.Assets.html"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Api.Assets.cloudasset_assets_list/4","doc":"Lists assets with time and resource types and returns paged results in response.","ref":"GoogleApi.CloudAsset.V1.Api.Assets.html#cloudasset_assets_list/4"},{"type":"function","title":"Parameters - GoogleApi.CloudAsset.V1.Api.Assets.cloudasset_assets_list/4","doc":"*   `connection` (*type:* `GoogleApi.CloudAsset.V1.Connection.t`) - Connection to server\n*   `parent` (*type:* `String.t`) - Required. Name of the organization, folder, or project the assets belong to. Format: \"organizations/[organization-number]\" (such as \"organizations/123\"), \"projects/[project-id]\" (such as \"projects/my-project-id\"), \"projects/[project-number]\" (such as \"projects/12345\"), or \"folders/[folder-number]\" (such as \"folders/12345\").\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:assetTypes` (*type:* `list(String.t)`) - A list of asset types to take a snapshot for. For example: \"compute.googleapis.com/Disk\". Regular expression is also supported. For example: * \"compute.googleapis.com.*\" snapshots resources whose asset type starts with \"compute.googleapis.com\". * \".*Instance\" snapshots resources whose asset type ends with \"Instance\". * \".*Instance.*\" snapshots resources whose asset type contains \"Instance\". See [RE2](https://github.com/google/re2/wiki/Syntax) for all supported regular expression syntax. If the regular expression does not match any supported asset type, an INVALID_ARGUMENT error will be returned. If specified, only matching assets will be returned, otherwise, it will snapshot all asset types. See [Introduction to Cloud Asset Inventory](https://cloud.google.com/asset-inventory/docs/overview) for all supported asset types.\n    *   `:contentType` (*type:* `String.t`) - Asset content type. If not specified, no content but the asset name will be returned.\n    *   `:pageSize` (*type:* `integer()`) - The maximum number of assets to be returned in a single response. Default is 100, minimum is 1, and maximum is 1000.\n    *   `:pageToken` (*type:* `String.t`) - The `next_page_token` returned from the previous `ListAssetsResponse`, or unspecified for the first `ListAssetsRequest`. It is a continuation of a prior `ListAssets` call, and the API should return the next page of assets.\n    *   `:readTime` (*type:* `DateTime.t`) - Timestamp to take an asset snapshot. This can only be set to a timestamp between the current time and the current time minus 35 days (inclusive). If not specified, the current time will be used. Due to delays in resource data collection and indexing, there is a volatile window during which running the same query may get different results.\n    *   `:relationshipTypes` (*type:* `list(String.t)`) - A list of relationship types to output, for example: `INSTANCE_TO_INSTANCEGROUP`. This field should only be specified if content_type=RELATIONSHIP. * If specified: it snapshots specified relationships. It returns an error if any of the [relationship_types] doesn't belong to the supported relationship types of the [asset_types] or if any of the [asset_types] doesn't belong to the source types of the [relationship_types]. * Otherwise: it snapshots the supported relationships for all [asset_types] or returns an error if any of the [asset_types] has no relationship support. An unspecified asset types field means all supported asset_types. See [Introduction to Cloud Asset Inventory](https://cloud.google.com/asset-inventory/docs/overview) for all supported asset types and relationship types.\n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.CloudAsset.V1.Api.Assets.html#cloudasset_assets_list/4-parameters"},{"type":"function","title":"Returns - GoogleApi.CloudAsset.V1.Api.Assets.cloudasset_assets_list/4","doc":"*   `{:ok, %GoogleApi.CloudAsset.V1.Model.ListAssetsResponse{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.CloudAsset.V1.Api.Assets.html#cloudasset_assets_list/4-returns"},{"type":"module","title":"GoogleApi.CloudAsset.V1.Api.EffectiveIamPolicies","doc":"API calls for all endpoints tagged `EffectiveIamPolicies`.","ref":"GoogleApi.CloudAsset.V1.Api.EffectiveIamPolicies.html"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Api.EffectiveIamPolicies.cloudasset_effective_iam_policies_batch_get/4","doc":"Gets effective IAM policies for a batch of resources.","ref":"GoogleApi.CloudAsset.V1.Api.EffectiveIamPolicies.html#cloudasset_effective_iam_policies_batch_get/4"},{"type":"function","title":"Parameters - GoogleApi.CloudAsset.V1.Api.EffectiveIamPolicies.cloudasset_effective_iam_policies_batch_get/4","doc":"*   `connection` (*type:* `GoogleApi.CloudAsset.V1.Connection.t`) - Connection to server\n*   `scope` (*type:* `String.t`) - Required. Only IAM policies on or below the scope will be returned. This can only be an organization number (such as \"organizations/123\"), a folder number (such as \"folders/123\"), a project ID (such as \"projects/my-project-id\"), or a project number (such as \"projects/12345\"). To know how to get organization ID, visit [here ](https://cloud.google.com/resource-manager/docs/creating-managing-organization#retrieving_your_organization_id). To know how to get folder or project ID, visit [here ](https://cloud.google.com/resource-manager/docs/creating-managing-folders#viewing_or_listing_folders_and_projects).\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:names` (*type:* `list(String.t)`) - Required. The names refer to the [full_resource_names] (https://cloud.google.com/asset-inventory/docs/resource-name-format) of the asset types [supported by search APIs](https://cloud.google.com/asset-inventory/docs/supported-asset-types). A maximum of 20 resources' effective policies can be retrieved in a batch.\n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.CloudAsset.V1.Api.EffectiveIamPolicies.html#cloudasset_effective_iam_policies_batch_get/4-parameters"},{"type":"function","title":"Returns - GoogleApi.CloudAsset.V1.Api.EffectiveIamPolicies.cloudasset_effective_iam_policies_batch_get/4","doc":"*   `{:ok, %GoogleApi.CloudAsset.V1.Model.BatchGetEffectiveIamPoliciesResponse{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.CloudAsset.V1.Api.EffectiveIamPolicies.html#cloudasset_effective_iam_policies_batch_get/4-returns"},{"type":"module","title":"GoogleApi.CloudAsset.V1.Api.Feeds","doc":"API calls for all endpoints tagged `Feeds`.","ref":"GoogleApi.CloudAsset.V1.Api.Feeds.html"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Api.Feeds.cloudasset_feeds_create/4","doc":"Creates a feed in a parent project/folder/organization to listen to its asset updates.","ref":"GoogleApi.CloudAsset.V1.Api.Feeds.html#cloudasset_feeds_create/4"},{"type":"function","title":"Parameters - GoogleApi.CloudAsset.V1.Api.Feeds.cloudasset_feeds_create/4","doc":"*   `connection` (*type:* `GoogleApi.CloudAsset.V1.Connection.t`) - Connection to server\n*   `parent` (*type:* `String.t`) - Required. The name of the project/folder/organization where this feed should be created in. It can only be an organization number (such as \"organizations/123\"), a folder number (such as \"folders/123\"), a project ID (such as \"projects/my-project-id\"), or a project number (such as \"projects/12345\").\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:body` (*type:* `GoogleApi.CloudAsset.V1.Model.CreateFeedRequest.t`) - \n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.CloudAsset.V1.Api.Feeds.html#cloudasset_feeds_create/4-parameters"},{"type":"function","title":"Returns - GoogleApi.CloudAsset.V1.Api.Feeds.cloudasset_feeds_create/4","doc":"*   `{:ok, %GoogleApi.CloudAsset.V1.Model.Feed{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.CloudAsset.V1.Api.Feeds.html#cloudasset_feeds_create/4-returns"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Api.Feeds.cloudasset_feeds_delete/4","doc":"Deletes an asset feed.","ref":"GoogleApi.CloudAsset.V1.Api.Feeds.html#cloudasset_feeds_delete/4"},{"type":"function","title":"Parameters - GoogleApi.CloudAsset.V1.Api.Feeds.cloudasset_feeds_delete/4","doc":"*   `connection` (*type:* `GoogleApi.CloudAsset.V1.Connection.t`) - Connection to server\n*   `name` (*type:* `String.t`) - Required. The name of the feed and it must be in the format of: projects/project_number/feeds/feed_id folders/folder_number/feeds/feed_id organizations/organization_number/feeds/feed_id\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.CloudAsset.V1.Api.Feeds.html#cloudasset_feeds_delete/4-parameters"},{"type":"function","title":"Returns - GoogleApi.CloudAsset.V1.Api.Feeds.cloudasset_feeds_delete/4","doc":"*   `{:ok, %GoogleApi.CloudAsset.V1.Model.Empty{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.CloudAsset.V1.Api.Feeds.html#cloudasset_feeds_delete/4-returns"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Api.Feeds.cloudasset_feeds_get/4","doc":"Gets details about an asset feed.","ref":"GoogleApi.CloudAsset.V1.Api.Feeds.html#cloudasset_feeds_get/4"},{"type":"function","title":"Parameters - GoogleApi.CloudAsset.V1.Api.Feeds.cloudasset_feeds_get/4","doc":"*   `connection` (*type:* `GoogleApi.CloudAsset.V1.Connection.t`) - Connection to server\n*   `name` (*type:* `String.t`) - Required. The name of the Feed and it must be in the format of: projects/project_number/feeds/feed_id folders/folder_number/feeds/feed_id organizations/organization_number/feeds/feed_id\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.CloudAsset.V1.Api.Feeds.html#cloudasset_feeds_get/4-parameters"},{"type":"function","title":"Returns - GoogleApi.CloudAsset.V1.Api.Feeds.cloudasset_feeds_get/4","doc":"*   `{:ok, %GoogleApi.CloudAsset.V1.Model.Feed{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.CloudAsset.V1.Api.Feeds.html#cloudasset_feeds_get/4-returns"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Api.Feeds.cloudasset_feeds_list/4","doc":"Lists all asset feeds in a parent project/folder/organization.","ref":"GoogleApi.CloudAsset.V1.Api.Feeds.html#cloudasset_feeds_list/4"},{"type":"function","title":"Parameters - GoogleApi.CloudAsset.V1.Api.Feeds.cloudasset_feeds_list/4","doc":"*   `connection` (*type:* `GoogleApi.CloudAsset.V1.Connection.t`) - Connection to server\n*   `parent` (*type:* `String.t`) - Required. The parent project/folder/organization whose feeds are to be listed. It can only be using project/folder/organization number (such as \"folders/12345\")\", or a project ID (such as \"projects/my-project-id\").\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.CloudAsset.V1.Api.Feeds.html#cloudasset_feeds_list/4-parameters"},{"type":"function","title":"Returns - GoogleApi.CloudAsset.V1.Api.Feeds.cloudasset_feeds_list/4","doc":"*   `{:ok, %GoogleApi.CloudAsset.V1.Model.ListFeedsResponse{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.CloudAsset.V1.Api.Feeds.html#cloudasset_feeds_list/4-returns"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Api.Feeds.cloudasset_feeds_patch/4","doc":"Updates an asset feed configuration.","ref":"GoogleApi.CloudAsset.V1.Api.Feeds.html#cloudasset_feeds_patch/4"},{"type":"function","title":"Parameters - GoogleApi.CloudAsset.V1.Api.Feeds.cloudasset_feeds_patch/4","doc":"*   `connection` (*type:* `GoogleApi.CloudAsset.V1.Connection.t`) - Connection to server\n*   `name` (*type:* `String.t`) - Required. The format will be projects/{project_number}/feeds/{client-assigned_feed_identifier} or folders/{folder_number}/feeds/{client-assigned_feed_identifier} or organizations/{organization_number}/feeds/{client-assigned_feed_identifier} The client-assigned feed identifier must be unique within the parent project/folder/organization.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:body` (*type:* `GoogleApi.CloudAsset.V1.Model.UpdateFeedRequest.t`) - \n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.CloudAsset.V1.Api.Feeds.html#cloudasset_feeds_patch/4-parameters"},{"type":"function","title":"Returns - GoogleApi.CloudAsset.V1.Api.Feeds.cloudasset_feeds_patch/4","doc":"*   `{:ok, %GoogleApi.CloudAsset.V1.Model.Feed{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.CloudAsset.V1.Api.Feeds.html#cloudasset_feeds_patch/4-returns"},{"type":"module","title":"GoogleApi.CloudAsset.V1.Api.Operations","doc":"API calls for all endpoints tagged `Operations`.","ref":"GoogleApi.CloudAsset.V1.Api.Operations.html"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Api.Operations.cloudasset_operations_get/4","doc":"Gets the latest state of a long-running operation. Clients can use this method to poll the operation result at intervals as recommended by the API service.","ref":"GoogleApi.CloudAsset.V1.Api.Operations.html#cloudasset_operations_get/4"},{"type":"function","title":"Parameters - GoogleApi.CloudAsset.V1.Api.Operations.cloudasset_operations_get/4","doc":"*   `connection` (*type:* `GoogleApi.CloudAsset.V1.Connection.t`) - Connection to server\n*   `name` (*type:* `String.t`) - The name of the operation resource.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.CloudAsset.V1.Api.Operations.html#cloudasset_operations_get/4-parameters"},{"type":"function","title":"Returns - GoogleApi.CloudAsset.V1.Api.Operations.cloudasset_operations_get/4","doc":"*   `{:ok, %GoogleApi.CloudAsset.V1.Model.Operation{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.CloudAsset.V1.Api.Operations.html#cloudasset_operations_get/4-returns"},{"type":"module","title":"GoogleApi.CloudAsset.V1.Api.SavedQueries","doc":"API calls for all endpoints tagged `SavedQueries`.","ref":"GoogleApi.CloudAsset.V1.Api.SavedQueries.html"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Api.SavedQueries.cloudasset_saved_queries_create/4","doc":"Creates a saved query in a parent project/folder/organization.","ref":"GoogleApi.CloudAsset.V1.Api.SavedQueries.html#cloudasset_saved_queries_create/4"},{"type":"function","title":"Parameters - GoogleApi.CloudAsset.V1.Api.SavedQueries.cloudasset_saved_queries_create/4","doc":"*   `connection` (*type:* `GoogleApi.CloudAsset.V1.Connection.t`) - Connection to server\n*   `parent` (*type:* `String.t`) - Required. The name of the project/folder/organization where this saved_query should be created in. It can only be an organization number (such as \"organizations/123\"), a folder number (such as \"folders/123\"), a project ID (such as \"projects/my-project-id\"), or a project number (such as \"projects/12345\").\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:savedQueryId` (*type:* `String.t`) - Required. The ID to use for the saved query, which must be unique in the specified parent. It will become the final component of the saved query's resource name. This value should be 4-63 characters, and valid characters are `a-z-`. Notice that this field is required in the saved query creation, and the `name` field of the `saved_query` will be ignored.\n    *   `:body` (*type:* `GoogleApi.CloudAsset.V1.Model.SavedQuery.t`) - \n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.CloudAsset.V1.Api.SavedQueries.html#cloudasset_saved_queries_create/4-parameters"},{"type":"function","title":"Returns - GoogleApi.CloudAsset.V1.Api.SavedQueries.cloudasset_saved_queries_create/4","doc":"*   `{:ok, %GoogleApi.CloudAsset.V1.Model.SavedQuery{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.CloudAsset.V1.Api.SavedQueries.html#cloudasset_saved_queries_create/4-returns"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Api.SavedQueries.cloudasset_saved_queries_delete/4","doc":"Deletes a saved query.","ref":"GoogleApi.CloudAsset.V1.Api.SavedQueries.html#cloudasset_saved_queries_delete/4"},{"type":"function","title":"Parameters - GoogleApi.CloudAsset.V1.Api.SavedQueries.cloudasset_saved_queries_delete/4","doc":"*   `connection` (*type:* `GoogleApi.CloudAsset.V1.Connection.t`) - Connection to server\n*   `name` (*type:* `String.t`) - Required. The name of the saved query to delete. It must be in the format of: * projects/project_number/savedQueries/saved_query_id * folders/folder_number/savedQueries/saved_query_id * organizations/organization_number/savedQueries/saved_query_id\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.CloudAsset.V1.Api.SavedQueries.html#cloudasset_saved_queries_delete/4-parameters"},{"type":"function","title":"Returns - GoogleApi.CloudAsset.V1.Api.SavedQueries.cloudasset_saved_queries_delete/4","doc":"*   `{:ok, %GoogleApi.CloudAsset.V1.Model.Empty{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.CloudAsset.V1.Api.SavedQueries.html#cloudasset_saved_queries_delete/4-returns"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Api.SavedQueries.cloudasset_saved_queries_get/4","doc":"Gets details about a saved query.","ref":"GoogleApi.CloudAsset.V1.Api.SavedQueries.html#cloudasset_saved_queries_get/4"},{"type":"function","title":"Parameters - GoogleApi.CloudAsset.V1.Api.SavedQueries.cloudasset_saved_queries_get/4","doc":"*   `connection` (*type:* `GoogleApi.CloudAsset.V1.Connection.t`) - Connection to server\n*   `name` (*type:* `String.t`) - Required. The name of the saved query and it must be in the format of: * projects/project_number/savedQueries/saved_query_id * folders/folder_number/savedQueries/saved_query_id * organizations/organization_number/savedQueries/saved_query_id\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.CloudAsset.V1.Api.SavedQueries.html#cloudasset_saved_queries_get/4-parameters"},{"type":"function","title":"Returns - GoogleApi.CloudAsset.V1.Api.SavedQueries.cloudasset_saved_queries_get/4","doc":"*   `{:ok, %GoogleApi.CloudAsset.V1.Model.SavedQuery{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.CloudAsset.V1.Api.SavedQueries.html#cloudasset_saved_queries_get/4-returns"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Api.SavedQueries.cloudasset_saved_queries_list/4","doc":"Lists all saved queries in a parent project/folder/organization.","ref":"GoogleApi.CloudAsset.V1.Api.SavedQueries.html#cloudasset_saved_queries_list/4"},{"type":"function","title":"Parameters - GoogleApi.CloudAsset.V1.Api.SavedQueries.cloudasset_saved_queries_list/4","doc":"*   `connection` (*type:* `GoogleApi.CloudAsset.V1.Connection.t`) - Connection to server\n*   `parent` (*type:* `String.t`) - Required. The parent project/folder/organization whose savedQueries are to be listed. It can only be using project/folder/organization number (such as \"folders/12345\")\", or a project ID (such as \"projects/my-project-id\").\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:filter` (*type:* `String.t`) - Optional. The expression to filter resources. The expression is a list of zero or more restrictions combined via logical operators `AND` and `OR`. When `AND` and `OR` are both used in the expression, parentheses must be appropriately used to group the combinations. The expression may also contain regular expressions. See https://google.aip.dev/160 for more information on the grammar.\n    *   `:pageSize` (*type:* `integer()`) - Optional. The maximum number of saved queries to return per page. The service may return fewer than this value. If unspecified, at most 50 will be returned. The maximum value is 1000; values above 1000 will be coerced to 1000.\n    *   `:pageToken` (*type:* `String.t`) - Optional. A page token, received from a previous `ListSavedQueries` call. Provide this to retrieve the subsequent page. When paginating, all other parameters provided to `ListSavedQueries` must match the call that provided the page token.\n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.CloudAsset.V1.Api.SavedQueries.html#cloudasset_saved_queries_list/4-parameters"},{"type":"function","title":"Returns - GoogleApi.CloudAsset.V1.Api.SavedQueries.cloudasset_saved_queries_list/4","doc":"*   `{:ok, %GoogleApi.CloudAsset.V1.Model.ListSavedQueriesResponse{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.CloudAsset.V1.Api.SavedQueries.html#cloudasset_saved_queries_list/4-returns"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Api.SavedQueries.cloudasset_saved_queries_patch/4","doc":"Updates a saved query.","ref":"GoogleApi.CloudAsset.V1.Api.SavedQueries.html#cloudasset_saved_queries_patch/4"},{"type":"function","title":"Parameters - GoogleApi.CloudAsset.V1.Api.SavedQueries.cloudasset_saved_queries_patch/4","doc":"*   `connection` (*type:* `GoogleApi.CloudAsset.V1.Connection.t`) - Connection to server\n*   `name` (*type:* `String.t`) - The resource name of the saved query. The format must be: * projects/project_number/savedQueries/saved_query_id * folders/folder_number/savedQueries/saved_query_id * organizations/organization_number/savedQueries/saved_query_id\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:updateMask` (*type:* `String.t`) - Required. The list of fields to update.\n    *   `:body` (*type:* `GoogleApi.CloudAsset.V1.Model.SavedQuery.t`) - \n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.CloudAsset.V1.Api.SavedQueries.html#cloudasset_saved_queries_patch/4-parameters"},{"type":"function","title":"Returns - GoogleApi.CloudAsset.V1.Api.SavedQueries.cloudasset_saved_queries_patch/4","doc":"*   `{:ok, %GoogleApi.CloudAsset.V1.Model.SavedQuery{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.CloudAsset.V1.Api.SavedQueries.html#cloudasset_saved_queries_patch/4-returns"},{"type":"module","title":"GoogleApi.CloudAsset.V1.Api.V1","doc":"API calls for all endpoints tagged `V1`.","ref":"GoogleApi.CloudAsset.V1.Api.V1.html"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Api.V1.cloudasset_analyze_iam_policy/4","doc":"Analyzes IAM policies to answer which identities have what accesses on which resources.","ref":"GoogleApi.CloudAsset.V1.Api.V1.html#cloudasset_analyze_iam_policy/4"},{"type":"function","title":"Parameters - GoogleApi.CloudAsset.V1.Api.V1.cloudasset_analyze_iam_policy/4","doc":"*   `connection` (*type:* `GoogleApi.CloudAsset.V1.Connection.t`) - Connection to server\n*   `scope` (*type:* `String.t`) - Required. The relative name of the root asset. Only resources and IAM policies within the scope will be analyzed. This can only be an organization number (such as \"organizations/123\"), a folder number (such as \"folders/123\"), a project ID (such as \"projects/my-project-id\"), or a project number (such as \"projects/12345\"). To know how to get organization ID, visit [here ](https://cloud.google.com/resource-manager/docs/creating-managing-organization#retrieving_your_organization_id). To know how to get folder or project ID, visit [here ](https://cloud.google.com/resource-manager/docs/creating-managing-folders#viewing_or_listing_folders_and_projects).\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:\"analysisQuery.accessSelector.permissions\"` (*type:* `list(String.t)`) - Optional. The permissions to appear in result.\n    *   `:\"analysisQuery.accessSelector.roles\"` (*type:* `list(String.t)`) - Optional. The roles to appear in result.\n    *   `:\"analysisQuery.conditionContext.accessTime\"` (*type:* `DateTime.t`) - The hypothetical access timestamp to evaluate IAM conditions. Note that this value must not be earlier than the current time; otherwise, an INVALID_ARGUMENT error will be returned.\n    *   `:\"analysisQuery.identitySelector.identity\"` (*type:* `String.t`) - Required. The identity appear in the form of principals in [IAM policy binding](https://cloud.google.com/iam/reference/rest/v1/Binding). The examples of supported forms are: \"user:mike@example.com\", \"group:admins@example.com\", \"domain:google.com\", \"serviceAccount:my-project-id@appspot.gserviceaccount.com\". Notice that wildcard characters (such as * and ?) are not supported. You must give a specific identity.\n    *   `:\"analysisQuery.options.analyzeServiceAccountImpersonation\"` (*type:* `boolean()`) - Optional. If true, the response will include access analysis from identities to resources via service account impersonation. This is a very expensive operation, because many derived queries will be executed. We highly recommend you use AssetService.AnalyzeIamPolicyLongrunning RPC instead. For example, if the request analyzes for which resources user A has permission P, and there's an IAM policy states user A has iam.serviceAccounts.getAccessToken permission to a service account SA, and there's another IAM policy states service account SA has permission P to a Google Cloud folder F, then user A potentially has access to the Google Cloud folder F. And those advanced analysis results will be included in AnalyzeIamPolicyResponse.service_account_impersonation_analysis. Another example, if the request analyzes for who has permission P to a Google Cloud folder F, and there's an IAM policy states user A has iam.serviceAccounts.actAs permission to a service account SA, and there's another IAM policy states service account SA has permission P to the Google Cloud folder F, then user A potentially has access to the Google Cloud folder F. And those advanced analysis results will be included in AnalyzeIamPolicyResponse.service_account_impersonation_analysis. Only the following permissions are considered in this analysis: * `iam.serviceAccounts.actAs` * `iam.serviceAccounts.signBlob` * `iam.serviceAccounts.signJwt` * `iam.serviceAccounts.getAccessToken` * `iam.serviceAccounts.getOpenIdToken` * `iam.serviceAccounts.implicitDelegation` Default is false.\n    *   `:\"analysisQuery.options.expandGroups\"` (*type:* `boolean()`) - Optional. If true, the identities section of the result will expand any Google groups appearing in an IAM policy binding. If IamPolicyAnalysisQuery.identity_selector is specified, the identity in the result will be determined by the selector, and this flag is not allowed to set. If true, the default max expansion per group is 1000 for AssetService.AnalyzeIamPolicy][]. Default is false.\n    *   `:\"analysisQuery.options.expandResources\"` (*type:* `boolean()`) - Optional. If true and IamPolicyAnalysisQuery.resource_selector is not specified, the resource section of the result will expand any resource attached to an IAM policy to include resources lower in the resource hierarchy. For example, if the request analyzes for which resources user A has permission P, and the results include an IAM policy with P on a Google Cloud folder, the results will also include resources in that folder with permission P. If true and IamPolicyAnalysisQuery.resource_selector is specified, the resource section of the result will expand the specified resource to include resources lower in the resource hierarchy. Only project or lower resources are supported. Folder and organization resources cannot be used together with this option. For example, if the request analyzes for which users have permission P on a Google Cloud project with this option enabled, the results will include all users who have permission P on that project or any lower resource. If true, the default max expansion per resource is 1000 for AssetService.AnalyzeIamPolicy][] and 100000 for AssetService.AnalyzeIamPolicyLongrunning][]. Default is false.\n    *   `:\"analysisQuery.options.expandRoles\"` (*type:* `boolean()`) - Optional. If true, the access section of result will expand any roles appearing in IAM policy bindings to include their permissions. If IamPolicyAnalysisQuery.access_selector is specified, the access section of the result will be determined by the selector, and this flag is not allowed to set. Default is false.\n    *   `:\"analysisQuery.options.outputGroupEdges\"` (*type:* `boolean()`) - Optional. If true, the result will output the relevant membership relationships between groups and other groups, and between groups and principals. Default is false.\n    *   `:\"analysisQuery.options.outputResourceEdges\"` (*type:* `boolean()`) - Optional. If true, the result will output the relevant parent/child relationships between resources. Default is false.\n    *   `:\"analysisQuery.resourceSelector.fullResourceName\"` (*type:* `String.t`) - Required. The [full resource name] (https://cloud.google.com/asset-inventory/docs/resource-name-format) of a resource of [supported resource types](https://cloud.google.com/asset-inventory/docs/supported-asset-types#analyzable_asset_types).\n    *   `:executionTimeout` (*type:* `String.t`) - Optional. Amount of time executable has to complete. See JSON representation of [Duration](https://developers.google.com/protocol-buffers/docs/proto3#json). If this field is set with a value less than the RPC deadline, and the execution of your query hasn't finished in the specified execution timeout, you will get a response with partial result. Otherwise, your query's execution will continue until the RPC deadline. If it's not finished until then, you will get a DEADLINE_EXCEEDED error. Default is empty.\n    *   `:savedAnalysisQuery` (*type:* `String.t`) - Optional. The name of a saved query, which must be in the format of: * projects/project_number/savedQueries/saved_query_id * folders/folder_number/savedQueries/saved_query_id * organizations/organization_number/savedQueries/saved_query_id If both `analysis_query` and `saved_analysis_query` are provided, they will be merged together with the `saved_analysis_query` as base and the `analysis_query` as overrides. For more details of the merge behavior, refer to the [MergeFrom](https://developers.google.com/protocol-buffers/docs/reference/cpp/google.protobuf.message#Message.MergeFrom.details) page. Note that you cannot override primitive fields with default value, such as 0 or empty string, etc., because we use proto3, which doesn't support field presence yet.\n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.CloudAsset.V1.Api.V1.html#cloudasset_analyze_iam_policy/4-parameters"},{"type":"function","title":"Returns - GoogleApi.CloudAsset.V1.Api.V1.cloudasset_analyze_iam_policy/4","doc":"*   `{:ok, %GoogleApi.CloudAsset.V1.Model.AnalyzeIamPolicyResponse{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.CloudAsset.V1.Api.V1.html#cloudasset_analyze_iam_policy/4-returns"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Api.V1.cloudasset_analyze_iam_policy_longrunning/4","doc":"Analyzes IAM policies asynchronously to answer which identities have what accesses on which resources, and writes the analysis results to a Google Cloud Storage or a BigQuery destination. For Cloud Storage destination, the output format is the JSON format that represents a AnalyzeIamPolicyResponse. This method implements the google.longrunning.Operation, which allows you to track the operation status. We recommend intervals of at least 2 seconds with exponential backoff retry to poll the operation result. The metadata contains the metadata for the long-running operation.","ref":"GoogleApi.CloudAsset.V1.Api.V1.html#cloudasset_analyze_iam_policy_longrunning/4"},{"type":"function","title":"Parameters - GoogleApi.CloudAsset.V1.Api.V1.cloudasset_analyze_iam_policy_longrunning/4","doc":"*   `connection` (*type:* `GoogleApi.CloudAsset.V1.Connection.t`) - Connection to server\n*   `scope` (*type:* `String.t`) - Required. The relative name of the root asset. Only resources and IAM policies within the scope will be analyzed. This can only be an organization number (such as \"organizations/123\"), a folder number (such as \"folders/123\"), a project ID (such as \"projects/my-project-id\"), or a project number (such as \"projects/12345\"). To know how to get organization ID, visit [here ](https://cloud.google.com/resource-manager/docs/creating-managing-organization#retrieving_your_organization_id). To know how to get folder or project ID, visit [here ](https://cloud.google.com/resource-manager/docs/creating-managing-folders#viewing_or_listing_folders_and_projects).\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:body` (*type:* `GoogleApi.CloudAsset.V1.Model.AnalyzeIamPolicyLongrunningRequest.t`) - \n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.CloudAsset.V1.Api.V1.html#cloudasset_analyze_iam_policy_longrunning/4-parameters"},{"type":"function","title":"Returns - GoogleApi.CloudAsset.V1.Api.V1.cloudasset_analyze_iam_policy_longrunning/4","doc":"*   `{:ok, %GoogleApi.CloudAsset.V1.Model.Operation{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.CloudAsset.V1.Api.V1.html#cloudasset_analyze_iam_policy_longrunning/4-returns"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Api.V1.cloudasset_analyze_move/4","doc":"Analyze moving a resource to a specified destination without kicking off the actual move. The analysis is best effort depending on the user's permissions of viewing different hierarchical policies and configurations. The policies and configuration are subject to change before the actual resource migration takes place.","ref":"GoogleApi.CloudAsset.V1.Api.V1.html#cloudasset_analyze_move/4"},{"type":"function","title":"Parameters - GoogleApi.CloudAsset.V1.Api.V1.cloudasset_analyze_move/4","doc":"*   `connection` (*type:* `GoogleApi.CloudAsset.V1.Connection.t`) - Connection to server\n*   `resource` (*type:* `String.t`) - Required. Name of the resource to perform the analysis against. Only Google Cloud projects are supported as of today. Hence, this can only be a project ID (such as \"projects/my-project-id\") or a project number (such as \"projects/12345\").\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:destinationParent` (*type:* `String.t`) - Required. Name of the Google Cloud folder or organization to reparent the target resource. The analysis will be performed against hypothetically moving the resource to this specified desitination parent. This can only be a folder number (such as \"folders/123\") or an organization number (such as \"organizations/123\").\n    *   `:view` (*type:* `String.t`) - Analysis view indicating what information should be included in the analysis response. If unspecified, the default view is FULL.\n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.CloudAsset.V1.Api.V1.html#cloudasset_analyze_move/4-parameters"},{"type":"function","title":"Returns - GoogleApi.CloudAsset.V1.Api.V1.cloudasset_analyze_move/4","doc":"*   `{:ok, %GoogleApi.CloudAsset.V1.Model.AnalyzeMoveResponse{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.CloudAsset.V1.Api.V1.html#cloudasset_analyze_move/4-returns"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Api.V1.cloudasset_analyze_org_policies/4","doc":"Analyzes organization policies under a scope.","ref":"GoogleApi.CloudAsset.V1.Api.V1.html#cloudasset_analyze_org_policies/4"},{"type":"function","title":"Parameters - GoogleApi.CloudAsset.V1.Api.V1.cloudasset_analyze_org_policies/4","doc":"*   `connection` (*type:* `GoogleApi.CloudAsset.V1.Connection.t`) - Connection to server\n*   `scope` (*type:* `String.t`) - Required. The organization to scope the request. Only organization policies within the scope will be analyzed. * organizations/{ORGANIZATION_NUMBER} (e.g., \"organizations/123456\")\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:constraint` (*type:* `String.t`) - Required. The name of the constraint to analyze organization policies for. The response only contains analyzed organization policies for the provided constraint.\n    *   `:filter` (*type:* `String.t`) - The expression to filter AnalyzeOrgPoliciesResponse.org_policy_results. Filtering is currently available for bare literal values and the following fields: * consolidated_policy.attached_resource * consolidated_policy.rules.enforce When filtering by a specific field, the only supported operator is `=`. For example, filtering by consolidated_policy.attached_resource=\"//cloudresourcemanager.googleapis.com/folders/001\" will return all the Organization Policy results attached to \"folders/001\".\n    *   `:pageSize` (*type:* `integer()`) - The maximum number of items to return per page. If unspecified, AnalyzeOrgPoliciesResponse.org_policy_results will contain 20 items with a maximum of 200.\n    *   `:pageToken` (*type:* `String.t`) - The pagination token to retrieve the next page.\n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.CloudAsset.V1.Api.V1.html#cloudasset_analyze_org_policies/4-parameters"},{"type":"function","title":"Returns - GoogleApi.CloudAsset.V1.Api.V1.cloudasset_analyze_org_policies/4","doc":"*   `{:ok, %GoogleApi.CloudAsset.V1.Model.AnalyzeOrgPoliciesResponse{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.CloudAsset.V1.Api.V1.html#cloudasset_analyze_org_policies/4-returns"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Api.V1.cloudasset_analyze_org_policy_governed_assets/4","doc":"Analyzes organization policies governed assets (Google Cloud resources or policies) under a scope. This RPC supports custom constraints and the following canned constraints: * constraints/ainotebooks.accessMode * constraints/ainotebooks.disableFileDownloads * constraints/ainotebooks.disableRootAccess * constraints/ainotebooks.disableTerminal * constraints/ainotebooks.environmentOptions * constraints/ainotebooks.requireAutoUpgradeSchedule * constraints/ainotebooks.restrictVpcNetworks * constraints/compute.disableGuestAttributesAccess * constraints/compute.disableInstanceDataAccessApis * constraints/compute.disableNestedVirtualization * constraints/compute.disableSerialPortAccess * constraints/compute.disableSerialPortLogging * constraints/compute.disableVpcExternalIpv6 * constraints/compute.requireOsLogin * constraints/compute.requireShieldedVm * constraints/compute.restrictLoadBalancerCreationForTypes * constraints/compute.restrictProtocolForwardingCreationForTypes * constraints/compute.restrictXpnProjectLienRemoval * constraints/compute.setNewProjectDefaultToZonalDNSOnly * constraints/compute.skipDefaultNetworkCreation * constraints/compute.trustedImageProjects * constraints/compute.vmCanIpForward * constraints/compute.vmExternalIpAccess * constraints/gcp.detailedAuditLoggingMode * constraints/gcp.resourceLocations * constraints/iam.allowedPolicyMemberDomains * constraints/iam.automaticIamGrantsForDefaultServiceAccounts * constraints/iam.disableServiceAccountCreation * constraints/iam.disableServiceAccountKeyCreation * constraints/iam.disableServiceAccountKeyUpload * constraints/iam.restrictCrossProjectServiceAccountLienRemoval * constraints/iam.serviceAccountKeyExpiryHours * constraints/resourcemanager.accessBoundaries * constraints/resourcemanager.allowedExportDestinations * constraints/sql.restrictAuthorizedNetworks * constraints/sql.restrictNoncompliantDiagnosticDataAccess * constraints/sql.restrictNoncompliantResourceCreation * constraints/sql.restrictPublicIp * constraints/storage.publicAccessPrevention * constraints/storage.restrictAuthTypes * constraints/storage.uniformBucketLevelAccess This RPC only returns either resources of types [supported by search APIs](https://cloud.google.com/asset-inventory/docs/supported-asset-types) or IAM policies.","ref":"GoogleApi.CloudAsset.V1.Api.V1.html#cloudasset_analyze_org_policy_governed_assets/4"},{"type":"function","title":"Parameters - GoogleApi.CloudAsset.V1.Api.V1.cloudasset_analyze_org_policy_governed_assets/4","doc":"*   `connection` (*type:* `GoogleApi.CloudAsset.V1.Connection.t`) - Connection to server\n*   `scope` (*type:* `String.t`) - Required. The organization to scope the request. Only organization policies within the scope will be analyzed. The output assets will also be limited to the ones governed by those in-scope organization policies. * organizations/{ORGANIZATION_NUMBER} (e.g., \"organizations/123456\")\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:constraint` (*type:* `String.t`) - Required. The name of the constraint to analyze governed assets for. The analysis only contains analyzed organization policies for the provided constraint.\n    *   `:filter` (*type:* `String.t`) - The expression to filter AnalyzeOrgPolicyGovernedAssetsResponse.governed_assets. For governed resources, filtering is currently available for bare literal values and the following fields: * governed_resource.project * governed_resource.folders * consolidated_policy.rules.enforce When filtering by `governed_resource.project` or `consolidated_policy.rules.enforce`, the only supported operator is `=`. When filtering by `governed_resource.folders`, the supported operators are `=` and `:`. For example, filtering by `governed_resource.project=\"projects/12345678\"` will return all the governed resources under \"projects/12345678\", including the project itself if applicable. For governed IAM policies, filtering is currently available for bare literal values and the following fields: * governed_iam_policy.project * governed_iam_policy.folders * consolidated_policy.rules.enforce When filtering by `governed_iam_policy.project` or `consolidated_policy.rules.enforce`, the only supported operator is `=`. When filtering by `governed_iam_policy.folders`, the supported operators are `=` and `:`. For example, filtering by `governed_iam_policy.folders:\"folders/12345678\"` will return all the governed IAM policies under \"folders/001\".\n    *   `:pageSize` (*type:* `integer()`) - The maximum number of items to return per page. If unspecified, AnalyzeOrgPolicyGovernedAssetsResponse.governed_assets will contain 100 items with a maximum of 200.\n    *   `:pageToken` (*type:* `String.t`) - The pagination token to retrieve the next page.\n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.CloudAsset.V1.Api.V1.html#cloudasset_analyze_org_policy_governed_assets/4-parameters"},{"type":"function","title":"Returns - GoogleApi.CloudAsset.V1.Api.V1.cloudasset_analyze_org_policy_governed_assets/4","doc":"*   `{:ok, %GoogleApi.CloudAsset.V1.Model.AnalyzeOrgPolicyGovernedAssetsResponse{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.CloudAsset.V1.Api.V1.html#cloudasset_analyze_org_policy_governed_assets/4-returns"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Api.V1.cloudasset_analyze_org_policy_governed_containers/4","doc":"Analyzes organization policies governed containers (projects, folders or organization) under a scope.","ref":"GoogleApi.CloudAsset.V1.Api.V1.html#cloudasset_analyze_org_policy_governed_containers/4"},{"type":"function","title":"Parameters - GoogleApi.CloudAsset.V1.Api.V1.cloudasset_analyze_org_policy_governed_containers/4","doc":"*   `connection` (*type:* `GoogleApi.CloudAsset.V1.Connection.t`) - Connection to server\n*   `scope` (*type:* `String.t`) - Required. The organization to scope the request. Only organization policies within the scope will be analyzed. The output containers will also be limited to the ones governed by those in-scope organization policies. * organizations/{ORGANIZATION_NUMBER} (e.g., \"organizations/123456\")\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:constraint` (*type:* `String.t`) - Required. The name of the constraint to analyze governed containers for. The analysis only contains organization policies for the provided constraint.\n    *   `:filter` (*type:* `String.t`) - The expression to filter AnalyzeOrgPolicyGovernedContainersResponse.governed_containers. Filtering is currently available for bare literal values and the following fields: * parent * consolidated_policy.rules.enforce When filtering by a specific field, the only supported operator is `=`. For example, filtering by parent=\"//cloudresourcemanager.googleapis.com/folders/001\" will return all the containers under \"folders/001\".\n    *   `:pageSize` (*type:* `integer()`) - The maximum number of items to return per page. If unspecified, AnalyzeOrgPolicyGovernedContainersResponse.governed_containers will contain 100 items with a maximum of 200.\n    *   `:pageToken` (*type:* `String.t`) - The pagination token to retrieve the next page.\n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.CloudAsset.V1.Api.V1.html#cloudasset_analyze_org_policy_governed_containers/4-parameters"},{"type":"function","title":"Returns - GoogleApi.CloudAsset.V1.Api.V1.cloudasset_analyze_org_policy_governed_containers/4","doc":"*   `{:ok, %GoogleApi.CloudAsset.V1.Model.AnalyzeOrgPolicyGovernedContainersResponse{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.CloudAsset.V1.Api.V1.html#cloudasset_analyze_org_policy_governed_containers/4-returns"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Api.V1.cloudasset_batch_get_assets_history/4","doc":"Batch gets the update history of assets that overlap a time window. For IAM_POLICY content, this API outputs history when the asset and its attached IAM POLICY both exist. This can create gaps in the output history. Otherwise, this API outputs history with asset in both non-delete or deleted status. If a specified asset does not exist, this API returns an INVALID_ARGUMENT error.","ref":"GoogleApi.CloudAsset.V1.Api.V1.html#cloudasset_batch_get_assets_history/4"},{"type":"function","title":"Parameters - GoogleApi.CloudAsset.V1.Api.V1.cloudasset_batch_get_assets_history/4","doc":"*   `connection` (*type:* `GoogleApi.CloudAsset.V1.Connection.t`) - Connection to server\n*   `parent` (*type:* `String.t`) - Required. The relative name of the root asset. It can only be an organization number (such as \"organizations/123\"), a project ID (such as \"projects/my-project-id\")\", or a project number (such as \"projects/12345\").\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:assetNames` (*type:* `list(String.t)`) - A list of the full names of the assets. See: https://cloud.google.com/asset-inventory/docs/resource-name-format Example: `//compute.googleapis.com/projects/my_project_123/zones/zone1/instances/instance1`. The request becomes a no-op if the asset name list is empty, and the max size of the asset name list is 100 in one request.\n    *   `:contentType` (*type:* `String.t`) - Optional. The content type.\n    *   `:\"readTimeWindow.endTime\"` (*type:* `DateTime.t`) - End time of the time window (inclusive). If not specified, the current timestamp is used instead.\n    *   `:\"readTimeWindow.startTime\"` (*type:* `DateTime.t`) - Start time of the time window (exclusive).\n    *   `:relationshipTypes` (*type:* `list(String.t)`) - Optional. A list of relationship types to output, for example: `INSTANCE_TO_INSTANCEGROUP`. This field should only be specified if content_type=RELATIONSHIP. * If specified: it outputs specified relationships' history on the [asset_names]. It returns an error if any of the [relationship_types] doesn't belong to the supported relationship types of the [asset_names] or if any of the [asset_names]'s types doesn't belong to the source types of the [relationship_types]. * Otherwise: it outputs the supported relationships' history on the [asset_names] or returns an error if any of the [asset_names]'s types has no relationship support. See [Introduction to Cloud Asset Inventory](https://cloud.google.com/asset-inventory/docs/overview) for all supported asset types and relationship types.\n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.CloudAsset.V1.Api.V1.html#cloudasset_batch_get_assets_history/4-parameters"},{"type":"function","title":"Returns - GoogleApi.CloudAsset.V1.Api.V1.cloudasset_batch_get_assets_history/4","doc":"*   `{:ok, %GoogleApi.CloudAsset.V1.Model.BatchGetAssetsHistoryResponse{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.CloudAsset.V1.Api.V1.html#cloudasset_batch_get_assets_history/4-returns"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Api.V1.cloudasset_export_assets/4","doc":"Exports assets with time and resource types to a given Cloud Storage location/BigQuery table. For Cloud Storage location destinations, the output format is newline-delimited JSON. Each line represents a google.cloud.asset.v1.Asset in the JSON format; for BigQuery table destinations, the output table stores the fields in asset Protobuf as columns. This API implements the google.longrunning.Operation API, which allows you to keep track of the export. We recommend intervals of at least 2 seconds with exponential retry to poll the export operation result. For regular-size resource parent, the export operation usually finishes within 5 minutes.","ref":"GoogleApi.CloudAsset.V1.Api.V1.html#cloudasset_export_assets/4"},{"type":"function","title":"Parameters - GoogleApi.CloudAsset.V1.Api.V1.cloudasset_export_assets/4","doc":"*   `connection` (*type:* `GoogleApi.CloudAsset.V1.Connection.t`) - Connection to server\n*   `parent` (*type:* `String.t`) - Required. The relative name of the root asset. This can only be an organization number (such as \"organizations/123\"), a project ID (such as \"projects/my-project-id\"), or a project number (such as \"projects/12345\"), or a folder number (such as \"folders/123\").\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:body` (*type:* `GoogleApi.CloudAsset.V1.Model.ExportAssetsRequest.t`) - \n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.CloudAsset.V1.Api.V1.html#cloudasset_export_assets/4-parameters"},{"type":"function","title":"Returns - GoogleApi.CloudAsset.V1.Api.V1.cloudasset_export_assets/4","doc":"*   `{:ok, %GoogleApi.CloudAsset.V1.Model.Operation{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.CloudAsset.V1.Api.V1.html#cloudasset_export_assets/4-returns"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Api.V1.cloudasset_query_assets/4","doc":"Issue a job that queries assets using a SQL statement compatible with [BigQuery SQL](https://cloud.google.com/bigquery/docs/introduction-sql). If the query execution finishes within timeout and there's no pagination, the full query results will be returned in the `QueryAssetsResponse`. Otherwise, full query results can be obtained by issuing extra requests with the `job_reference` from the a previous `QueryAssets` call. Note, the query result has approximately 10 GB limitation enforced by [BigQuery](https://cloud.google.com/bigquery/docs/best-practices-performance-output). Queries return larger results will result in errors.","ref":"GoogleApi.CloudAsset.V1.Api.V1.html#cloudasset_query_assets/4"},{"type":"function","title":"Parameters - GoogleApi.CloudAsset.V1.Api.V1.cloudasset_query_assets/4","doc":"*   `connection` (*type:* `GoogleApi.CloudAsset.V1.Connection.t`) - Connection to server\n*   `parent` (*type:* `String.t`) - Required. The relative name of the root asset. This can only be an organization number (such as \"organizations/123\"), a project ID (such as \"projects/my-project-id\"), or a project number (such as \"projects/12345\"), or a folder number (such as \"folders/123\"). Only assets belonging to the `parent` will be returned.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:body` (*type:* `GoogleApi.CloudAsset.V1.Model.QueryAssetsRequest.t`) - \n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.CloudAsset.V1.Api.V1.html#cloudasset_query_assets/4-parameters"},{"type":"function","title":"Returns - GoogleApi.CloudAsset.V1.Api.V1.cloudasset_query_assets/4","doc":"*   `{:ok, %GoogleApi.CloudAsset.V1.Model.QueryAssetsResponse{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.CloudAsset.V1.Api.V1.html#cloudasset_query_assets/4-returns"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Api.V1.cloudasset_search_all_iam_policies/4","doc":"Searches all IAM policies within the specified scope, such as a project, folder, or organization. The caller must be granted the `cloudasset.assets.searchAllIamPolicies` permission on the desired scope, otherwise the request will be rejected.","ref":"GoogleApi.CloudAsset.V1.Api.V1.html#cloudasset_search_all_iam_policies/4"},{"type":"function","title":"Parameters - GoogleApi.CloudAsset.V1.Api.V1.cloudasset_search_all_iam_policies/4","doc":"*   `connection` (*type:* `GoogleApi.CloudAsset.V1.Connection.t`) - Connection to server\n*   `scope` (*type:* `String.t`) - Required. A scope can be a project, a folder, or an organization. The search is limited to the IAM policies within the `scope`. The caller must be granted the [`cloudasset.assets.searchAllIamPolicies`](https://cloud.google.com/asset-inventory/docs/access-control#required_permissions) permission on the desired scope. The allowed values are: * projects/{PROJECT_ID} (e.g., \"projects/foo-bar\") * projects/{PROJECT_NUMBER} (e.g., \"projects/12345678\") * folders/{FOLDER_NUMBER} (e.g., \"folders/1234567\") * organizations/{ORGANIZATION_NUMBER} (e.g., \"organizations/123456\")\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:assetTypes` (*type:* `list(String.t)`) - Optional. A list of asset types that the IAM policies are attached to. If empty, it will search the IAM policies that are attached to all the asset types [supported by search APIs](https://cloud.google.com/asset-inventory/docs/supported-asset-types) Regular expressions are also supported. For example: * \"compute.googleapis.com.*\" snapshots IAM policies attached to asset type starts with \"compute.googleapis.com\". * \".*Instance\" snapshots IAM policies attached to asset type ends with \"Instance\". * \".*Instance.*\" snapshots IAM policies attached to asset type contains \"Instance\". See [RE2](https://github.com/google/re2/wiki/Syntax) for all supported regular expression syntax. If the regular expression does not match any supported asset type, an INVALID_ARGUMENT error will be returned.\n    *   `:orderBy` (*type:* `String.t`) - Optional. A comma-separated list of fields specifying the sorting order of the results. The default order is ascending. Add \" DESC\" after the field name to indicate descending order. Redundant space characters are ignored. Example: \"assetType DESC, resource\". Only singular primitive fields in the response are sortable: * resource * assetType * project All the other fields such as repeated fields (e.g., `folders`) and non-primitive fields (e.g., `policy`) are not supported.\n    *   `:pageSize` (*type:* `integer()`) - Optional. The page size for search result pagination. Page size is capped at 500 even if a larger value is given. If set to zero or a negative value, server will pick an appropriate default. Returned results may be fewer than requested. When this happens, there could be more results as long as `next_page_token` is returned.\n    *   `:pageToken` (*type:* `String.t`) - Optional. If present, retrieve the next batch of results from the preceding call to this method. `page_token` must be the value of `next_page_token` from the previous response. The values of all other method parameters must be identical to those in the previous call.\n    *   `:query` (*type:* `String.t`) - Optional. The query statement. See [how to construct a query](https://cloud.google.com/asset-inventory/docs/searching-iam-policies#how_to_construct_a_query) for more information. If not specified or empty, it will search all the IAM policies within the specified `scope`. Note that the query string is compared against each IAM policy binding, including its principals, roles, and IAM conditions. The returned IAM policies will only contain the bindings that match your query. To learn more about the IAM policy structure, see the [IAM policy documentation](https://cloud.google.com/iam/help/allow-policies/structure). Examples: * `policy:amy@gmail.com` to find IAM policy bindings that specify user \"amy@gmail.com\". * `policy:roles/compute.admin` to find IAM policy bindings that specify the Compute Admin role. * `policy:comp*` to find IAM policy bindings that contain \"comp\" as a prefix of any word in the binding. * `policy.role.permissions:storage.buckets.update` to find IAM policy bindings that specify a role containing \"storage.buckets.update\" permission. Note that if callers don't have `iam.roles.get` access to a role's included permissions, policy bindings that specify this role will be dropped from the search results. * `policy.role.permissions:upd*` to find IAM policy bindings that specify a role containing \"upd\" as a prefix of any word in the role permission. Note that if callers don't have `iam.roles.get` access to a role's included permissions, policy bindings that specify this role will be dropped from the search results. * `resource:organizations/123456` to find IAM policy bindings that are set on \"organizations/123456\". * `resource=//cloudresourcemanager.googleapis.com/projects/myproject` to find IAM policy bindings that are set on the project named \"myproject\". * `Important` to find IAM policy bindings that contain \"Important\" as a word in any of the searchable fields (except for the included permissions). * `resource:(instance1 OR instance2) policy:amy` to find IAM policy bindings that are set on resources \"instance1\" or \"instance2\" and also specify user \"amy\". * `roles:roles/compute.admin` to find IAM policy bindings that specify the Compute Admin role. * `memberTypes:user` to find IAM policy bindings that contain the principal type \"user\".\n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.CloudAsset.V1.Api.V1.html#cloudasset_search_all_iam_policies/4-parameters"},{"type":"function","title":"Returns - GoogleApi.CloudAsset.V1.Api.V1.cloudasset_search_all_iam_policies/4","doc":"*   `{:ok, %GoogleApi.CloudAsset.V1.Model.SearchAllIamPoliciesResponse{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.CloudAsset.V1.Api.V1.html#cloudasset_search_all_iam_policies/4-returns"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Api.V1.cloudasset_search_all_resources/4","doc":"Searches all Google Cloud resources within the specified scope, such as a project, folder, or organization. The caller must be granted the `cloudasset.assets.searchAllResources` permission on the desired scope, otherwise the request will be rejected.","ref":"GoogleApi.CloudAsset.V1.Api.V1.html#cloudasset_search_all_resources/4"},{"type":"function","title":"Parameters - GoogleApi.CloudAsset.V1.Api.V1.cloudasset_search_all_resources/4","doc":"*   `connection` (*type:* `GoogleApi.CloudAsset.V1.Connection.t`) - Connection to server\n*   `scope` (*type:* `String.t`) - Required. A scope can be a project, a folder, or an organization. The search is limited to the resources within the `scope`. The caller must be granted the [`cloudasset.assets.searchAllResources`](https://cloud.google.com/asset-inventory/docs/access-control#required_permissions) permission on the desired scope. The allowed values are: * projects/{PROJECT_ID} (e.g., \"projects/foo-bar\") * projects/{PROJECT_NUMBER} (e.g., \"projects/12345678\") * folders/{FOLDER_NUMBER} (e.g., \"folders/1234567\") * organizations/{ORGANIZATION_NUMBER} (e.g., \"organizations/123456\")\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:assetTypes` (*type:* `list(String.t)`) - Optional. A list of asset types that this request searches for. If empty, it will search all the asset types [supported by search APIs](https://cloud.google.com/asset-inventory/docs/supported-asset-types). Regular expressions are also supported. For example: * \"compute.googleapis.com.*\" snapshots resources whose asset type starts with \"compute.googleapis.com\". * \".*Instance\" snapshots resources whose asset type ends with \"Instance\". * \".*Instance.*\" snapshots resources whose asset type contains \"Instance\". See [RE2](https://github.com/google/re2/wiki/Syntax) for all supported regular expression syntax. If the regular expression does not match any supported asset type, an INVALID_ARGUMENT error will be returned.\n    *   `:orderBy` (*type:* `String.t`) - Optional. A comma-separated list of fields specifying the sorting order of the results. The default order is ascending. Add \" DESC\" after the field name to indicate descending order. Redundant space characters are ignored. Example: \"location DESC, name\". Only the following fields in the response are sortable: * name * assetType * project * displayName * description * location * createTime * updateTime * state * parentFullResourceName * parentAssetType\n    *   `:pageSize` (*type:* `integer()`) - Optional. The page size for search result pagination. Page size is capped at 500 even if a larger value is given. If set to zero or a negative value, server will pick an appropriate default. Returned results may be fewer than requested. When this happens, there could be more results as long as `next_page_token` is returned.\n    *   `:pageToken` (*type:* `String.t`) - Optional. If present, then retrieve the next batch of results from the preceding call to this method. `page_token` must be the value of `next_page_token` from the previous response. The values of all other method parameters, must be identical to those in the previous call.\n    *   `:query` (*type:* `String.t`) - Optional. The query statement. See [how to construct a query](https://cloud.google.com/asset-inventory/docs/searching-resources#how_to_construct_a_query) for more information. If not specified or empty, it will search all the resources within the specified `scope`. Examples: * `name:Important` to find Google Cloud resources whose name contains `Important` as a word. * `name=Important` to find the Google Cloud resource whose name is exactly `Important`. * `displayName:Impor*` to find Google Cloud resources whose display name contains `Impor` as a prefix of any word in the field. * `location:us-west*` to find Google Cloud resources whose location contains both `us` and `west` as prefixes. * `labels:prod` to find Google Cloud resources whose labels contain `prod` as a key or value. * `labels.env:prod` to find Google Cloud resources that have a label `env` and its value is `prod`. * `labels.env:*` to find Google Cloud resources that have a label `env`. * `tagKeys:env` to find Google Cloud resources that have directly attached tags where the [`TagKey.namespacedName`](https://cloud.google.com/resource-manager/reference/rest/v3/tagKeys#resource:-tagkey) contains `env`. * `tagValues:prod*` to find Google Cloud resources that have directly attached tags where the [`TagValue.namespacedName`](https://cloud.google.com/resource-manager/reference/rest/v3/tagValues#resource:-tagvalue) contains a word prefixed by `prod`. * `tagValueIds=tagValues/123` to find Google Cloud resources that have directly attached tags where the [`TagValue.name`](https://cloud.google.com/resource-manager/reference/rest/v3/tagValues#resource:-tagvalue) is exactly `tagValues/123`. * `effectiveTagKeys:env` to find Google Cloud resources that have directly attached or inherited tags where the [`TagKey.namespacedName`](https://cloud.google.com/resource-manager/reference/rest/v3/tagKeys#resource:-tagkey) contains `env`. * `effectiveTagValues:prod*` to find Google Cloud resources that have directly attached or inherited tags where the [`TagValue.namespacedName`](https://cloud.google.com/resource-manager/reference/rest/v3/tagValues#resource:-tagvalue) contains a word prefixed by `prod`. * `effectiveTagValueIds=tagValues/123` to find Google Cloud resources that have directly attached or inherited tags where the [`TagValue.name`](https://cloud.google.com/resource-manager/reference/rest/v3/tagValues#resource:-tagvalue) is exactly `tagValues/123`. * `kmsKey:key` to find Google Cloud resources encrypted with a customer-managed encryption key whose name contains `key` as a word. This field is deprecated. Use the `kmsKeys` field to retrieve Cloud KMS key information. * `kmsKeys:key` to find Google Cloud resources encrypted with customer-managed encryption keys whose name contains the word `key`. * `relationships:instance-group-1` to find Google Cloud resources that have relationships with `instance-group-1` in the related resource name. * `relationships:INSTANCE_TO_INSTANCEGROUP` to find Compute Engine instances that have relationships of type `INSTANCE_TO_INSTANCEGROUP`. * `relationships.INSTANCE_TO_INSTANCEGROUP:instance-group-1` to find Compute Engine instances that have relationships with `instance-group-1` in the Compute Engine instance group resource name, for relationship type `INSTANCE_TO_INSTANCEGROUP`. * `sccSecurityMarks.key=value` to find Cloud resources that are attached with security marks whose key is `key` and value is `value`. * `sccSecurityMarks.key:*` to find Cloud resources that are attached with security marks whose key is `key`. * `state:ACTIVE` to find Google Cloud resources whose state contains `ACTIVE` as a word. * `NOT state:ACTIVE` to find Google Cloud resources whose state doesn't contain `ACTIVE` as a word. * `createTime<1609459200` to find Google Cloud resources that were created before `2021-01-01 00:00:00 UTC`. `1609459200` is the epoch timestamp of `2021-01-01 00:00:00 UTC` in seconds. * `updateTime>1609459200` to find Google Cloud resources that were updated after `2021-01-01 00:00:00 UTC`. `1609459200` is the epoch timestamp of `2021-01-01 00:00:00 UTC` in seconds. * `Important` to find Google Cloud resources that contain `Important` as a word in any of the searchable fields. * `Impor*` to find Google Cloud resources that contain `Impor` as a prefix of any word in any of the searchable fields. * `Important location:(us-west1 OR global)` to find Google Cloud resources that contain `Important` as a word in any of the searchable fields and are also located in the `us-west1` region or the `global` location.\n    *   `:readMask` (*type:* `String.t`) - Optional. A comma-separated list of fields that you want returned in the results. The following fields are returned by default if not specified: * `name` * `assetType` * `project` * `folders` * `organization` * `displayName` * `description` * `location` * `labels` * `tags` * `effectiveTags` * `networkTags` * `kmsKeys` * `createTime` * `updateTime` * `state` * `additionalAttributes` * `parentFullResourceName` * `parentAssetType` Some fields of large size, such as `versionedResources`, `attachedResources`, `effectiveTags` etc., are not returned by default, but you can specify them in the `read_mask` parameter if you want to include them. If `\"*\"` is specified, all [available fields](https://cloud.google.com/asset-inventory/docs/reference/rest/v1/TopLevel/searchAllResources#resourcesearchresult) are returned. Examples: `\"name,location\"`, `\"name,versionedResources\"`, `\"*\"`. Any invalid field path will trigger INVALID_ARGUMENT error.\n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.CloudAsset.V1.Api.V1.html#cloudasset_search_all_resources/4-parameters"},{"type":"function","title":"Returns - GoogleApi.CloudAsset.V1.Api.V1.cloudasset_search_all_resources/4","doc":"*   `{:ok, %GoogleApi.CloudAsset.V1.Model.SearchAllResourcesResponse{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.CloudAsset.V1.Api.V1.html#cloudasset_search_all_resources/4-returns"},{"type":"module","title":"GoogleApi.CloudAsset.V1.Connection","doc":"Handle Tesla connections for GoogleApi.CloudAsset.V1.","ref":"GoogleApi.CloudAsset.V1.Connection.html"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Connection.delete/3","doc":"Perform a DELETE request.\n\nSee `request/1` or `request/2` for options definition.\n\n    delete(\"/users\")\n    delete(\"/users\", query: [scope: \"admin\"])\n    delete(client, \"/users\")\n    delete(client, \"/users\", query: [scope: \"admin\"])\n    delete(client, \"/users\", body: %{name: \"Jon\"})","ref":"GoogleApi.CloudAsset.V1.Connection.html#delete/3"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Connection.delete!/3","doc":"Perform a DELETE request.\n\nSee `request!/1` or `request!/2` for options definition.\n\n    delete!(\"/users\")\n    delete!(\"/users\", query: [scope: \"admin\"])\n    delete!(client, \"/users\")\n    delete!(client, \"/users\", query: [scope: \"admin\"])\n    delete!(client, \"/users\", body: %{name: \"Jon\"})","ref":"GoogleApi.CloudAsset.V1.Connection.html#delete!/3"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Connection.execute/2","doc":"Execute a request on this connection","ref":"GoogleApi.CloudAsset.V1.Connection.html#execute/2"},{"type":"function","title":"Returns - GoogleApi.CloudAsset.V1.Connection.execute/2","doc":"*   `{:ok, Tesla.Env.t}` - If the call was successful\n*   `{:error, reason}` - If the call failed","ref":"GoogleApi.CloudAsset.V1.Connection.html#execute/2-returns"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Connection.get/3","doc":"Perform a GET request.\n\nSee `request/1` or `request/2` for options definition.\n\n    get(\"/users\")\n    get(\"/users\", query: [scope: \"admin\"])\n    get(client, \"/users\")\n    get(client, \"/users\", query: [scope: \"admin\"])\n    get(client, \"/users\", body: %{name: \"Jon\"})","ref":"GoogleApi.CloudAsset.V1.Connection.html#get/3"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Connection.get!/3","doc":"Perform a GET request.\n\nSee `request!/1` or `request!/2` for options definition.\n\n    get!(\"/users\")\n    get!(\"/users\", query: [scope: \"admin\"])\n    get!(client, \"/users\")\n    get!(client, \"/users\", query: [scope: \"admin\"])\n    get!(client, \"/users\", body: %{name: \"Jon\"})","ref":"GoogleApi.CloudAsset.V1.Connection.html#get!/3"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Connection.head/3","doc":"Perform a HEAD request.\n\nSee `request/1` or `request/2` for options definition.\n\n    head(\"/users\")\n    head(\"/users\", query: [scope: \"admin\"])\n    head(client, \"/users\")\n    head(client, \"/users\", query: [scope: \"admin\"])\n    head(client, \"/users\", body: %{name: \"Jon\"})","ref":"GoogleApi.CloudAsset.V1.Connection.html#head/3"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Connection.head!/3","doc":"Perform a HEAD request.\n\nSee `request!/1` or `request!/2` for options definition.\n\n    head!(\"/users\")\n    head!(\"/users\", query: [scope: \"admin\"])\n    head!(client, \"/users\")\n    head!(client, \"/users\", query: [scope: \"admin\"])\n    head!(client, \"/users\", body: %{name: \"Jon\"})","ref":"GoogleApi.CloudAsset.V1.Connection.html#head!/3"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Connection.new/0","doc":"Configure an authless client connection","ref":"GoogleApi.CloudAsset.V1.Connection.html#new/0"},{"type":"function","title":"Returns - GoogleApi.CloudAsset.V1.Connection.new/0","doc":"*   `Tesla.Env.client`","ref":"GoogleApi.CloudAsset.V1.Connection.html#new/0-returns"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Connection.new/1","doc":"Configure a client connection using a function which yields a Bearer token.","ref":"GoogleApi.CloudAsset.V1.Connection.html#new/1"},{"type":"function","title":"Parameters - GoogleApi.CloudAsset.V1.Connection.new/1","doc":"*   `token_fetcher` (*type:* `list(String.t()) -> String.t()`) - Callback\n    which provides an OAuth2 token given a list of scopes","ref":"GoogleApi.CloudAsset.V1.Connection.html#new/1-parameters"},{"type":"function","title":"Returns - GoogleApi.CloudAsset.V1.Connection.new/1","doc":"*   `Tesla.Env.client`","ref":"GoogleApi.CloudAsset.V1.Connection.html#new/1-returns"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Connection.options/3","doc":"Perform a OPTIONS request.\n\nSee `request/1` or `request/2` for options definition.\n\n    options(\"/users\")\n    options(\"/users\", query: [scope: \"admin\"])\n    options(client, \"/users\")\n    options(client, \"/users\", query: [scope: \"admin\"])\n    options(client, \"/users\", body: %{name: \"Jon\"})","ref":"GoogleApi.CloudAsset.V1.Connection.html#options/3"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Connection.options!/3","doc":"Perform a OPTIONS request.\n\nSee `request!/1` or `request!/2` for options definition.\n\n    options!(\"/users\")\n    options!(\"/users\", query: [scope: \"admin\"])\n    options!(client, \"/users\")\n    options!(client, \"/users\", query: [scope: \"admin\"])\n    options!(client, \"/users\", body: %{name: \"Jon\"})","ref":"GoogleApi.CloudAsset.V1.Connection.html#options!/3"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Connection.patch/4","doc":"Perform a PATCH request.\n\nSee `request/1` or `request/2` for options definition.\n\n    patch(\"/users\", %{name: \"Jon\"})\n    patch(\"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])\n    patch(client, \"/users\", %{name: \"Jon\"})\n    patch(client, \"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])","ref":"GoogleApi.CloudAsset.V1.Connection.html#patch/4"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Connection.patch!/4","doc":"Perform a PATCH request.\n\nSee `request!/1` or `request!/2` for options definition.\n\n    patch!(\"/users\", %{name: \"Jon\"})\n    patch!(\"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])\n    patch!(client, \"/users\", %{name: \"Jon\"})\n    patch!(client, \"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])","ref":"GoogleApi.CloudAsset.V1.Connection.html#patch!/4"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Connection.post/4","doc":"Perform a POST request.\n\nSee `request/1` or `request/2` for options definition.\n\n    post(\"/users\", %{name: \"Jon\"})\n    post(\"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])\n    post(client, \"/users\", %{name: \"Jon\"})\n    post(client, \"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])","ref":"GoogleApi.CloudAsset.V1.Connection.html#post/4"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Connection.post!/4","doc":"Perform a POST request.\n\nSee `request!/1` or `request!/2` for options definition.\n\n    post!(\"/users\", %{name: \"Jon\"})\n    post!(\"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])\n    post!(client, \"/users\", %{name: \"Jon\"})\n    post!(client, \"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])","ref":"GoogleApi.CloudAsset.V1.Connection.html#post!/4"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Connection.put/4","doc":"Perform a PUT request.\n\nSee `request/1` or `request/2` for options definition.\n\n    put(\"/users\", %{name: \"Jon\"})\n    put(\"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])\n    put(client, \"/users\", %{name: \"Jon\"})\n    put(client, \"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])","ref":"GoogleApi.CloudAsset.V1.Connection.html#put/4"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Connection.put!/4","doc":"Perform a PUT request.\n\nSee `request!/1` or `request!/2` for options definition.\n\n    put!(\"/users\", %{name: \"Jon\"})\n    put!(\"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])\n    put!(client, \"/users\", %{name: \"Jon\"})\n    put!(client, \"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])","ref":"GoogleApi.CloudAsset.V1.Connection.html#put!/4"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Connection.request/2","doc":"Perform a request.","ref":"GoogleApi.CloudAsset.V1.Connection.html#request/2"},{"type":"function","title":"Options - GoogleApi.CloudAsset.V1.Connection.request/2","doc":"- `:method` - the request method, one of [`:head`, `:get`, `:delete`, `:trace`, `:options`, `:post`, `:put`, `:patch`]\n- `:url` - either full url e.g. \"http://example.com/some/path\" or just \"/some/path\" if using `Tesla.Middleware.BaseUrl`\n- `:query` - a keyword list of query params, e.g. `[page: 1, per_page: 100]`\n- `:headers` - a keyworld list of headers, e.g. `[{\"content-type\", \"text/plain\"}]`\n- `:body` - depends on used middleware:\n    - by default it can be a binary\n    - if using e.g. JSON encoding middleware it can be a nested map\n    - if adapter supports it it can be a Stream with any of the above\n- `:opts` - custom, per-request middleware or adapter options","ref":"GoogleApi.CloudAsset.V1.Connection.html#request/2-options"},{"type":"function","title":"Examples - GoogleApi.CloudAsset.V1.Connection.request/2","doc":"ExampleApi.request(method: :get, url: \"/users/path\")\n\n    # use shortcut methods\n    ExampleApi.get(\"/users/1\")\n    ExampleApi.post(client, \"/users\", %{name: \"Jon\"})","ref":"GoogleApi.CloudAsset.V1.Connection.html#request/2-examples"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Connection.request!/2","doc":"Perform request and raise in case of error.\n\nThis is similar to `request/2` behaviour from Tesla 0.x\n\nSee `request/2` for list of available options.","ref":"GoogleApi.CloudAsset.V1.Connection.html#request!/2"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Connection.trace/3","doc":"Perform a TRACE request.\n\nSee `request/1` or `request/2` for options definition.\n\n    trace(\"/users\")\n    trace(\"/users\", query: [scope: \"admin\"])\n    trace(client, \"/users\")\n    trace(client, \"/users\", query: [scope: \"admin\"])\n    trace(client, \"/users\", body: %{name: \"Jon\"})","ref":"GoogleApi.CloudAsset.V1.Connection.html#trace/3"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Connection.trace!/3","doc":"Perform a TRACE request.\n\nSee `request!/1` or `request!/2` for options definition.\n\n    trace!(\"/users\")\n    trace!(\"/users\", query: [scope: \"admin\"])\n    trace!(client, \"/users\")\n    trace!(client, \"/users\", query: [scope: \"admin\"])\n    trace!(client, \"/users\", body: %{name: \"Jon\"})","ref":"GoogleApi.CloudAsset.V1.Connection.html#trace!/3"},{"type":"type","title":"GoogleApi.CloudAsset.V1.Connection.option/0","doc":"Options that may be passed to a request function. See `request/2` for detailed descriptions.","ref":"GoogleApi.CloudAsset.V1.Connection.html#t:option/0"},{"type":"type","title":"GoogleApi.CloudAsset.V1.Connection.t/0","doc":"","ref":"GoogleApi.CloudAsset.V1.Connection.html#t:t/0"},{"type":"module","title":"GoogleApi.CloudAsset.V1.Model.AccessSelector","doc":"Specifies roles and/or permissions to analyze, to determine both the identities possessing them and the resources they control. If multiple values are specified, results will include roles or permissions matching any of them. The total number of roles and permissions should be equal or less than 10.","ref":"GoogleApi.CloudAsset.V1.Model.AccessSelector.html"},{"type":"module","title":"Attributes - GoogleApi.CloudAsset.V1.Model.AccessSelector","doc":"*   `permissions` (*type:* `list(String.t)`, *default:* `nil`) - Optional. The permissions to appear in result.\n*   `roles` (*type:* `list(String.t)`, *default:* `nil`) - Optional. The roles to appear in result.","ref":"GoogleApi.CloudAsset.V1.Model.AccessSelector.html#module-attributes"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Model.AccessSelector.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.CloudAsset.V1.Model.AccessSelector.html#decode/2"},{"type":"type","title":"GoogleApi.CloudAsset.V1.Model.AccessSelector.t/0","doc":"","ref":"GoogleApi.CloudAsset.V1.Model.AccessSelector.html#t:t/0"},{"type":"module","title":"GoogleApi.CloudAsset.V1.Model.AnalyzeIamPolicyLongrunningMetadata","doc":"Represents the metadata of the longrunning operation for the AnalyzeIamPolicyLongrunning RPC.","ref":"GoogleApi.CloudAsset.V1.Model.AnalyzeIamPolicyLongrunningMetadata.html"},{"type":"module","title":"Attributes - GoogleApi.CloudAsset.V1.Model.AnalyzeIamPolicyLongrunningMetadata","doc":"*   `createTime` (*type:* `DateTime.t`, *default:* `nil`) - Output only. The time the operation was created.","ref":"GoogleApi.CloudAsset.V1.Model.AnalyzeIamPolicyLongrunningMetadata.html#module-attributes"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Model.AnalyzeIamPolicyLongrunningMetadata.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.CloudAsset.V1.Model.AnalyzeIamPolicyLongrunningMetadata.html#decode/2"},{"type":"type","title":"GoogleApi.CloudAsset.V1.Model.AnalyzeIamPolicyLongrunningMetadata.t/0","doc":"","ref":"GoogleApi.CloudAsset.V1.Model.AnalyzeIamPolicyLongrunningMetadata.html#t:t/0"},{"type":"module","title":"GoogleApi.CloudAsset.V1.Model.AnalyzeIamPolicyLongrunningRequest","doc":"A request message for AssetService.AnalyzeIamPolicyLongrunning.","ref":"GoogleApi.CloudAsset.V1.Model.AnalyzeIamPolicyLongrunningRequest.html"},{"type":"module","title":"Attributes - GoogleApi.CloudAsset.V1.Model.AnalyzeIamPolicyLongrunningRequest","doc":"*   `analysisQuery` (*type:* `GoogleApi.CloudAsset.V1.Model.IamPolicyAnalysisQuery.t`, *default:* `nil`) - Required. The request query.\n*   `outputConfig` (*type:* `GoogleApi.CloudAsset.V1.Model.IamPolicyAnalysisOutputConfig.t`, *default:* `nil`) - Required. Output configuration indicating where the results will be output to.\n*   `savedAnalysisQuery` (*type:* `String.t`, *default:* `nil`) - Optional. The name of a saved query, which must be in the format of: * projects/project_number/savedQueries/saved_query_id * folders/folder_number/savedQueries/saved_query_id * organizations/organization_number/savedQueries/saved_query_id If both `analysis_query` and `saved_analysis_query` are provided, they will be merged together with the `saved_analysis_query` as base and the `analysis_query` as overrides. For more details of the merge behavior, refer to the [MergeFrom](https://developers.google.com/protocol-buffers/docs/reference/cpp/google.protobuf.message#Message.MergeFrom.details) doc. Note that you cannot override primitive fields with default value, such as 0 or empty string, etc., because we use proto3, which doesn't support field presence yet.","ref":"GoogleApi.CloudAsset.V1.Model.AnalyzeIamPolicyLongrunningRequest.html#module-attributes"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Model.AnalyzeIamPolicyLongrunningRequest.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.CloudAsset.V1.Model.AnalyzeIamPolicyLongrunningRequest.html#decode/2"},{"type":"type","title":"GoogleApi.CloudAsset.V1.Model.AnalyzeIamPolicyLongrunningRequest.t/0","doc":"","ref":"GoogleApi.CloudAsset.V1.Model.AnalyzeIamPolicyLongrunningRequest.html#t:t/0"},{"type":"module","title":"GoogleApi.CloudAsset.V1.Model.AnalyzeIamPolicyLongrunningResponse","doc":"A response message for AssetService.AnalyzeIamPolicyLongrunning.","ref":"GoogleApi.CloudAsset.V1.Model.AnalyzeIamPolicyLongrunningResponse.html"},{"type":"module","title":"Attributes - GoogleApi.CloudAsset.V1.Model.AnalyzeIamPolicyLongrunningResponse","doc":"","ref":"GoogleApi.CloudAsset.V1.Model.AnalyzeIamPolicyLongrunningResponse.html#module-attributes"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Model.AnalyzeIamPolicyLongrunningResponse.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.CloudAsset.V1.Model.AnalyzeIamPolicyLongrunningResponse.html#decode/2"},{"type":"type","title":"GoogleApi.CloudAsset.V1.Model.AnalyzeIamPolicyLongrunningResponse.t/0","doc":"","ref":"GoogleApi.CloudAsset.V1.Model.AnalyzeIamPolicyLongrunningResponse.html#t:t/0"},{"type":"module","title":"GoogleApi.CloudAsset.V1.Model.AnalyzeIamPolicyResponse","doc":"A response message for AssetService.AnalyzeIamPolicy.","ref":"GoogleApi.CloudAsset.V1.Model.AnalyzeIamPolicyResponse.html"},{"type":"module","title":"Attributes - GoogleApi.CloudAsset.V1.Model.AnalyzeIamPolicyResponse","doc":"*   `fullyExplored` (*type:* `boolean()`, *default:* `nil`) - Represents whether all entries in the main_analysis and service_account_impersonation_analysis have been fully explored to answer the query in the request.\n*   `mainAnalysis` (*type:* `GoogleApi.CloudAsset.V1.Model.IamPolicyAnalysis.t`, *default:* `nil`) - The main analysis that matches the original request.\n*   `serviceAccountImpersonationAnalysis` (*type:* `list(GoogleApi.CloudAsset.V1.Model.IamPolicyAnalysis.t)`, *default:* `nil`) - The service account impersonation analysis if AnalyzeIamPolicyRequest.analyze_service_account_impersonation is enabled.","ref":"GoogleApi.CloudAsset.V1.Model.AnalyzeIamPolicyResponse.html#module-attributes"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Model.AnalyzeIamPolicyResponse.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.CloudAsset.V1.Model.AnalyzeIamPolicyResponse.html#decode/2"},{"type":"type","title":"GoogleApi.CloudAsset.V1.Model.AnalyzeIamPolicyResponse.t/0","doc":"","ref":"GoogleApi.CloudAsset.V1.Model.AnalyzeIamPolicyResponse.html#t:t/0"},{"type":"module","title":"GoogleApi.CloudAsset.V1.Model.AnalyzeMoveResponse","doc":"The response message for resource move analysis.","ref":"GoogleApi.CloudAsset.V1.Model.AnalyzeMoveResponse.html"},{"type":"module","title":"Attributes - GoogleApi.CloudAsset.V1.Model.AnalyzeMoveResponse","doc":"*   `moveAnalysis` (*type:* `list(GoogleApi.CloudAsset.V1.Model.MoveAnalysis.t)`, *default:* `nil`) - The list of analyses returned from performing the intended resource move analysis. The analysis is grouped by different Google Cloud services.","ref":"GoogleApi.CloudAsset.V1.Model.AnalyzeMoveResponse.html#module-attributes"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Model.AnalyzeMoveResponse.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.CloudAsset.V1.Model.AnalyzeMoveResponse.html#decode/2"},{"type":"type","title":"GoogleApi.CloudAsset.V1.Model.AnalyzeMoveResponse.t/0","doc":"","ref":"GoogleApi.CloudAsset.V1.Model.AnalyzeMoveResponse.html#t:t/0"},{"type":"module","title":"GoogleApi.CloudAsset.V1.Model.AnalyzeOrgPoliciesResponse","doc":"The response message for AssetService.AnalyzeOrgPolicies.","ref":"GoogleApi.CloudAsset.V1.Model.AnalyzeOrgPoliciesResponse.html"},{"type":"module","title":"Attributes - GoogleApi.CloudAsset.V1.Model.AnalyzeOrgPoliciesResponse","doc":"*   `constraint` (*type:* `GoogleApi.CloudAsset.V1.Model.AnalyzerOrgPolicyConstraint.t`, *default:* `nil`) - The definition of the constraint in the request.\n*   `nextPageToken` (*type:* `String.t`, *default:* `nil`) - The page token to fetch the next page for AnalyzeOrgPoliciesResponse.org_policy_results.\n*   `orgPolicyResults` (*type:* `list(GoogleApi.CloudAsset.V1.Model.OrgPolicyResult.t)`, *default:* `nil`) - The organization policies under the AnalyzeOrgPoliciesRequest.scope with the AnalyzeOrgPoliciesRequest.constraint.","ref":"GoogleApi.CloudAsset.V1.Model.AnalyzeOrgPoliciesResponse.html#module-attributes"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Model.AnalyzeOrgPoliciesResponse.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.CloudAsset.V1.Model.AnalyzeOrgPoliciesResponse.html#decode/2"},{"type":"type","title":"GoogleApi.CloudAsset.V1.Model.AnalyzeOrgPoliciesResponse.t/0","doc":"","ref":"GoogleApi.CloudAsset.V1.Model.AnalyzeOrgPoliciesResponse.html#t:t/0"},{"type":"module","title":"GoogleApi.CloudAsset.V1.Model.AnalyzeOrgPolicyGovernedAssetsResponse","doc":"The response message for AssetService.AnalyzeOrgPolicyGovernedAssets.","ref":"GoogleApi.CloudAsset.V1.Model.AnalyzeOrgPolicyGovernedAssetsResponse.html"},{"type":"module","title":"Attributes - GoogleApi.CloudAsset.V1.Model.AnalyzeOrgPolicyGovernedAssetsResponse","doc":"*   `constraint` (*type:* `GoogleApi.CloudAsset.V1.Model.AnalyzerOrgPolicyConstraint.t`, *default:* `nil`) - The definition of the constraint in the request.\n*   `governedAssets` (*type:* `list(GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1AnalyzeOrgPolicyGovernedAssetsResponseGovernedAsset.t)`, *default:* `nil`) - The list of the analyzed governed assets.\n*   `nextPageToken` (*type:* `String.t`, *default:* `nil`) - The page token to fetch the next page for AnalyzeOrgPolicyGovernedAssetsResponse.governed_assets.","ref":"GoogleApi.CloudAsset.V1.Model.AnalyzeOrgPolicyGovernedAssetsResponse.html#module-attributes"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Model.AnalyzeOrgPolicyGovernedAssetsResponse.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.CloudAsset.V1.Model.AnalyzeOrgPolicyGovernedAssetsResponse.html#decode/2"},{"type":"type","title":"GoogleApi.CloudAsset.V1.Model.AnalyzeOrgPolicyGovernedAssetsResponse.t/0","doc":"","ref":"GoogleApi.CloudAsset.V1.Model.AnalyzeOrgPolicyGovernedAssetsResponse.html#t:t/0"},{"type":"module","title":"GoogleApi.CloudAsset.V1.Model.AnalyzeOrgPolicyGovernedContainersResponse","doc":"The response message for AssetService.AnalyzeOrgPolicyGovernedContainers.","ref":"GoogleApi.CloudAsset.V1.Model.AnalyzeOrgPolicyGovernedContainersResponse.html"},{"type":"module","title":"Attributes - GoogleApi.CloudAsset.V1.Model.AnalyzeOrgPolicyGovernedContainersResponse","doc":"*   `constraint` (*type:* `GoogleApi.CloudAsset.V1.Model.AnalyzerOrgPolicyConstraint.t`, *default:* `nil`) - The definition of the constraint in the request.\n*   `governedContainers` (*type:* `list(GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1GovernedContainer.t)`, *default:* `nil`) - The list of the analyzed governed containers.\n*   `nextPageToken` (*type:* `String.t`, *default:* `nil`) - The page token to fetch the next page for AnalyzeOrgPolicyGovernedContainersResponse.governed_containers.","ref":"GoogleApi.CloudAsset.V1.Model.AnalyzeOrgPolicyGovernedContainersResponse.html#module-attributes"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Model.AnalyzeOrgPolicyGovernedContainersResponse.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.CloudAsset.V1.Model.AnalyzeOrgPolicyGovernedContainersResponse.html#decode/2"},{"type":"type","title":"GoogleApi.CloudAsset.V1.Model.AnalyzeOrgPolicyGovernedContainersResponse.t/0","doc":"","ref":"GoogleApi.CloudAsset.V1.Model.AnalyzeOrgPolicyGovernedContainersResponse.html#t:t/0"},{"type":"module","title":"GoogleApi.CloudAsset.V1.Model.AnalyzerOrgPolicy","doc":"This organization policy message is a modified version of the one defined in the Organization Policy system. This message contains several fields defined in the original organization policy with some new fields for analysis purpose.","ref":"GoogleApi.CloudAsset.V1.Model.AnalyzerOrgPolicy.html"},{"type":"module","title":"Attributes - GoogleApi.CloudAsset.V1.Model.AnalyzerOrgPolicy","doc":"*   `appliedResource` (*type:* `String.t`, *default:* `nil`) - The [full resource name] (https://cloud.google.com/asset-inventory/docs/resource-name-format) of an organization/folder/project resource where this organization policy applies to. For any user defined org policies, this field has the same value as the [attached_resource] field. Only for default policy, this field has the different value.\n*   `attachedResource` (*type:* `String.t`, *default:* `nil`) - The [full resource name] (https://cloud.google.com/asset-inventory/docs/resource-name-format) of an organization/folder/project resource where this organization policy is set. Notice that some type of constraints are defined with default policy. This field will be empty for them.\n*   `inheritFromParent` (*type:* `boolean()`, *default:* `nil`) - If `inherit_from_parent` is true, Rules set higher up in the hierarchy (up to the closest root) are inherited and present in the effective policy. If it is false, then no rules are inherited, and this policy becomes the effective root for evaluation.\n*   `reset` (*type:* `boolean()`, *default:* `nil`) - Ignores policies set above this resource and restores the default behavior of the constraint at this resource. This field can be set in policies for either list or boolean constraints. If set, `rules` must be empty and `inherit_from_parent` must be set to false.\n*   `rules` (*type:* `list(GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1Rule.t)`, *default:* `nil`) - List of rules for this organization policy.","ref":"GoogleApi.CloudAsset.V1.Model.AnalyzerOrgPolicy.html#module-attributes"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Model.AnalyzerOrgPolicy.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.CloudAsset.V1.Model.AnalyzerOrgPolicy.html#decode/2"},{"type":"type","title":"GoogleApi.CloudAsset.V1.Model.AnalyzerOrgPolicy.t/0","doc":"","ref":"GoogleApi.CloudAsset.V1.Model.AnalyzerOrgPolicy.html#t:t/0"},{"type":"module","title":"GoogleApi.CloudAsset.V1.Model.AnalyzerOrgPolicyConstraint","doc":"The organization policy constraint definition.","ref":"GoogleApi.CloudAsset.V1.Model.AnalyzerOrgPolicyConstraint.html"},{"type":"module","title":"Attributes - GoogleApi.CloudAsset.V1.Model.AnalyzerOrgPolicyConstraint","doc":"*   `customConstraint` (*type:* `GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1CustomConstraint.t`, *default:* `nil`) - The definition of the custom constraint.\n*   `googleDefinedConstraint` (*type:* `GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1Constraint.t`, *default:* `nil`) - The definition of the canned constraint defined by Google.","ref":"GoogleApi.CloudAsset.V1.Model.AnalyzerOrgPolicyConstraint.html#module-attributes"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Model.AnalyzerOrgPolicyConstraint.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.CloudAsset.V1.Model.AnalyzerOrgPolicyConstraint.html#decode/2"},{"type":"type","title":"GoogleApi.CloudAsset.V1.Model.AnalyzerOrgPolicyConstraint.t/0","doc":"","ref":"GoogleApi.CloudAsset.V1.Model.AnalyzerOrgPolicyConstraint.html#t:t/0"},{"type":"module","title":"GoogleApi.CloudAsset.V1.Model.Asset","doc":"An asset in Google Cloud. An asset can be any resource in the Google Cloud [resource hierarchy](https://cloud.google.com/resource-manager/docs/cloud-platform-resource-hierarchy), a resource outside the Google Cloud resource hierarchy (such as Google Kubernetes Engine clusters and objects), or a policy (e.g. IAM policy), or a relationship (e.g. an INSTANCE_TO_INSTANCEGROUP relationship). See [Supported asset types](https://cloud.google.com/asset-inventory/docs/supported-asset-types) for more information.","ref":"GoogleApi.CloudAsset.V1.Model.Asset.html"},{"type":"module","title":"Attributes - GoogleApi.CloudAsset.V1.Model.Asset","doc":"*   `accessLevel` (*type:* `GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1AccessLevel.t`, *default:* `nil`) - Also refer to the [access level user guide](https://cloud.google.com/access-context-manager/docs/overview#access-levels).\n*   `accessPolicy` (*type:* `GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1AccessPolicy.t`, *default:* `nil`) - Also refer to the [access policy user guide](https://cloud.google.com/access-context-manager/docs/overview#access-policies).\n*   `ancestors` (*type:* `list(String.t)`, *default:* `nil`) - The ancestry path of an asset in Google Cloud [resource hierarchy](https://cloud.google.com/resource-manager/docs/cloud-platform-resource-hierarchy), represented as a list of relative resource names. An ancestry path starts with the closest ancestor in the hierarchy and ends at root. If the asset is a project, folder, or organization, the ancestry path starts from the asset itself. Example: `[\"projects/123456789\", \"folders/5432\", \"organizations/1234\"]`\n*   `assetType` (*type:* `String.t`, *default:* `nil`) - The type of the asset. Example: `compute.googleapis.com/Disk` See [Supported asset types](https://cloud.google.com/asset-inventory/docs/supported-asset-types) for more information.\n*   `iamPolicy` (*type:* `GoogleApi.CloudAsset.V1.Model.Policy.t`, *default:* `nil`) - A representation of the IAM policy set on a Google Cloud resource. There can be a maximum of one IAM policy set on any given resource. In addition, IAM policies inherit their granted access scope from any policies set on parent resources in the resource hierarchy. Therefore, the effectively policy is the union of both the policy set on this resource and each policy set on all of the resource's ancestry resource levels in the hierarchy. See [this topic](https://cloud.google.com/iam/help/allow-policies/inheritance) for more information.\n*   `name` (*type:* `String.t`, *default:* `nil`) - The full name of the asset. Example: `//compute.googleapis.com/projects/my_project_123/zones/zone1/instances/instance1` See [Resource names](https://cloud.google.com/apis/design/resource_names#full_resource_name) for more information.\n*   `orgPolicy` (*type:* `list(GoogleApi.CloudAsset.V1.Model.GoogleCloudOrgpolicyV1Policy.t)`, *default:* `nil`) - A representation of an [organization policy](https://cloud.google.com/resource-manager/docs/organization-policy/overview#organization_policy). There can be more than one organization policy with different constraints set on a given resource.\n*   `osInventory` (*type:* `GoogleApi.CloudAsset.V1.Model.Inventory.t`, *default:* `nil`) - A representation of runtime OS Inventory information. See [this topic](https://cloud.google.com/compute/docs/instances/os-inventory-management) for more information.\n*   `relatedAsset` (*type:* `GoogleApi.CloudAsset.V1.Model.RelatedAsset.t`, *default:* `nil`) - One related asset of the current asset.\n*   `relatedAssets` (*type:* `GoogleApi.CloudAsset.V1.Model.RelatedAssets.t`, *default:* `nil`) - DEPRECATED. This field only presents for the purpose of backward-compatibility. The server will never generate responses with this field. The related assets of the asset of one relationship type. One asset only represents one type of relationship.\n*   `resource` (*type:* `GoogleApi.CloudAsset.V1.Model.Resource.t`, *default:* `nil`) - A representation of the resource.\n*   `servicePerimeter` (*type:* `GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1ServicePerimeter.t`, *default:* `nil`) - Also refer to the [service perimeter user guide](https://cloud.google.com/vpc-service-controls/docs/overview).\n*   `updateTime` (*type:* `DateTime.t`, *default:* `nil`) - The last update timestamp of an asset. update_time is updated when create/update/delete operation is performed.","ref":"GoogleApi.CloudAsset.V1.Model.Asset.html#module-attributes"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Model.Asset.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.CloudAsset.V1.Model.Asset.html#decode/2"},{"type":"type","title":"GoogleApi.CloudAsset.V1.Model.Asset.t/0","doc":"","ref":"GoogleApi.CloudAsset.V1.Model.Asset.html#t:t/0"},{"type":"module","title":"GoogleApi.CloudAsset.V1.Model.AttachedResource","doc":"Attached resource representation, which is defined by the corresponding service provider. It represents an attached resource's payload.","ref":"GoogleApi.CloudAsset.V1.Model.AttachedResource.html"},{"type":"module","title":"Attributes - GoogleApi.CloudAsset.V1.Model.AttachedResource","doc":"*   `assetType` (*type:* `String.t`, *default:* `nil`) - The type of this attached resource. Example: `osconfig.googleapis.com/Inventory` You can find the supported attached asset types of each resource in this table: `https://cloud.google.com/asset-inventory/docs/supported-asset-types`\n*   `versionedResources` (*type:* `list(GoogleApi.CloudAsset.V1.Model.VersionedResource.t)`, *default:* `nil`) - Versioned resource representations of this attached resource. This is repeated because there could be multiple versions of the attached resource representations during version migration.","ref":"GoogleApi.CloudAsset.V1.Model.AttachedResource.html#module-attributes"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Model.AttachedResource.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.CloudAsset.V1.Model.AttachedResource.html#decode/2"},{"type":"type","title":"GoogleApi.CloudAsset.V1.Model.AttachedResource.t/0","doc":"","ref":"GoogleApi.CloudAsset.V1.Model.AttachedResource.html#t:t/0"},{"type":"module","title":"GoogleApi.CloudAsset.V1.Model.AuditConfig","doc":"Specifies the audit configuration for a service. The configuration determines which permission types are logged, and what identities, if any, are exempted from logging. An AuditConfig must have one or more AuditLogConfigs. If there are AuditConfigs for both `allServices` and a specific service, the union of the two AuditConfigs is used for that service: the log_types specified in each AuditConfig are enabled, and the exempted_members in each AuditLogConfig are exempted. Example Policy with multiple AuditConfigs: { \"audit_configs\": [ { \"service\": \"allServices\", \"audit_log_configs\": [ { \"log_type\": \"DATA_READ\", \"exempted_members\": [ \"user:jose@example.com\" ] }, { \"log_type\": \"DATA_WRITE\" }, { \"log_type\": \"ADMIN_READ\" } ] }, { \"service\": \"sampleservice.googleapis.com\", \"audit_log_configs\": [ { \"log_type\": \"DATA_READ\" }, { \"log_type\": \"DATA_WRITE\", \"exempted_members\": [ \"user:aliya@example.com\" ] } ] } ] } For sampleservice, this policy enables DATA_READ, DATA_WRITE and ADMIN_READ logging. It also exempts `jose@example.com` from DATA_READ logging, and `aliya@example.com` from DATA_WRITE logging.","ref":"GoogleApi.CloudAsset.V1.Model.AuditConfig.html"},{"type":"module","title":"Attributes - GoogleApi.CloudAsset.V1.Model.AuditConfig","doc":"*   `auditLogConfigs` (*type:* `list(GoogleApi.CloudAsset.V1.Model.AuditLogConfig.t)`, *default:* `nil`) - The configuration for logging of each type of permission.\n*   `service` (*type:* `String.t`, *default:* `nil`) - Specifies a service that will be enabled for audit logging. For example, `storage.googleapis.com`, `cloudsql.googleapis.com`. `allServices` is a special value that covers all services.","ref":"GoogleApi.CloudAsset.V1.Model.AuditConfig.html#module-attributes"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Model.AuditConfig.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.CloudAsset.V1.Model.AuditConfig.html#decode/2"},{"type":"type","title":"GoogleApi.CloudAsset.V1.Model.AuditConfig.t/0","doc":"","ref":"GoogleApi.CloudAsset.V1.Model.AuditConfig.html#t:t/0"},{"type":"module","title":"GoogleApi.CloudAsset.V1.Model.AuditLogConfig","doc":"Provides the configuration for logging a type of permissions. Example: { \"audit_log_configs\": [ { \"log_type\": \"DATA_READ\", \"exempted_members\": [ \"user:jose@example.com\" ] }, { \"log_type\": \"DATA_WRITE\" } ] } This enables 'DATA_READ' and 'DATA_WRITE' logging, while exempting jose@example.com from DATA_READ logging.","ref":"GoogleApi.CloudAsset.V1.Model.AuditLogConfig.html"},{"type":"module","title":"Attributes - GoogleApi.CloudAsset.V1.Model.AuditLogConfig","doc":"*   `exemptedMembers` (*type:* `list(String.t)`, *default:* `nil`) - Specifies the identities that do not cause logging for this type of permission. Follows the same format of Binding.members.\n*   `logType` (*type:* `String.t`, *default:* `nil`) - The log type that this config enables.","ref":"GoogleApi.CloudAsset.V1.Model.AuditLogConfig.html#module-attributes"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Model.AuditLogConfig.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.CloudAsset.V1.Model.AuditLogConfig.html#decode/2"},{"type":"type","title":"GoogleApi.CloudAsset.V1.Model.AuditLogConfig.t/0","doc":"","ref":"GoogleApi.CloudAsset.V1.Model.AuditLogConfig.html#t:t/0"},{"type":"module","title":"GoogleApi.CloudAsset.V1.Model.BatchGetAssetsHistoryResponse","doc":"Batch get assets history response.","ref":"GoogleApi.CloudAsset.V1.Model.BatchGetAssetsHistoryResponse.html"},{"type":"module","title":"Attributes - GoogleApi.CloudAsset.V1.Model.BatchGetAssetsHistoryResponse","doc":"*   `assets` (*type:* `list(GoogleApi.CloudAsset.V1.Model.TemporalAsset.t)`, *default:* `nil`) - A list of assets with valid time windows.","ref":"GoogleApi.CloudAsset.V1.Model.BatchGetAssetsHistoryResponse.html#module-attributes"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Model.BatchGetAssetsHistoryResponse.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.CloudAsset.V1.Model.BatchGetAssetsHistoryResponse.html#decode/2"},{"type":"type","title":"GoogleApi.CloudAsset.V1.Model.BatchGetAssetsHistoryResponse.t/0","doc":"","ref":"GoogleApi.CloudAsset.V1.Model.BatchGetAssetsHistoryResponse.html#t:t/0"},{"type":"module","title":"GoogleApi.CloudAsset.V1.Model.BatchGetEffectiveIamPoliciesResponse","doc":"A response message for AssetService.BatchGetEffectiveIamPolicies.","ref":"GoogleApi.CloudAsset.V1.Model.BatchGetEffectiveIamPoliciesResponse.html"},{"type":"module","title":"Attributes - GoogleApi.CloudAsset.V1.Model.BatchGetEffectiveIamPoliciesResponse","doc":"*   `policyResults` (*type:* `list(GoogleApi.CloudAsset.V1.Model.EffectiveIamPolicy.t)`, *default:* `nil`) - The effective policies for a batch of resources. Note that the results order is the same as the order of BatchGetEffectiveIamPoliciesRequest.names. When a resource does not have any effective IAM policies, its corresponding policy_result will contain empty EffectiveIamPolicy.policies.","ref":"GoogleApi.CloudAsset.V1.Model.BatchGetEffectiveIamPoliciesResponse.html#module-attributes"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Model.BatchGetEffectiveIamPoliciesResponse.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.CloudAsset.V1.Model.BatchGetEffectiveIamPoliciesResponse.html#decode/2"},{"type":"type","title":"GoogleApi.CloudAsset.V1.Model.BatchGetEffectiveIamPoliciesResponse.t/0","doc":"","ref":"GoogleApi.CloudAsset.V1.Model.BatchGetEffectiveIamPoliciesResponse.html#t:t/0"},{"type":"module","title":"GoogleApi.CloudAsset.V1.Model.BigQueryDestination","doc":"A BigQuery destination for exporting assets to.","ref":"GoogleApi.CloudAsset.V1.Model.BigQueryDestination.html"},{"type":"module","title":"Attributes - GoogleApi.CloudAsset.V1.Model.BigQueryDestination","doc":"*   `dataset` (*type:* `String.t`, *default:* `nil`) - Required. The BigQuery dataset in format \"projects/projectId/datasets/datasetId\", to which the snapshot result should be exported. If this dataset does not exist, the export call returns an INVALID_ARGUMENT error. Setting the `contentType` for `exportAssets` determines the [schema](/asset-inventory/docs/exporting-to-bigquery#bigquery-schema) of the BigQuery table. Setting `separateTablesPerAssetType` to `TRUE` also influences the schema.\n*   `force` (*type:* `boolean()`, *default:* `nil`) - If the destination table already exists and this flag is `TRUE`, the table will be overwritten by the contents of assets snapshot. If the flag is `FALSE` or unset and the destination table already exists, the export call returns an INVALID_ARGUMEMT error.\n*   `partitionSpec` (*type:* `GoogleApi.CloudAsset.V1.Model.PartitionSpec.t`, *default:* `nil`) - [partition_spec] determines whether to export to partitioned table(s) and how to partition the data. If [partition_spec] is unset or [partition_spec.partition_key] is unset or `PARTITION_KEY_UNSPECIFIED`, the snapshot results will be exported to non-partitioned table(s). [force] will decide whether to overwrite existing table(s). If [partition_spec] is specified. First, the snapshot results will be written to partitioned table(s) with two additional timestamp columns, readTime and requestTime, one of which will be the partition key. Secondly, in the case when any destination table already exists, it will first try to update existing table's schema as necessary by appending additional columns. Then, if [force] is `TRUE`, the corresponding partition will be overwritten by the snapshot results (data in different partitions will remain intact); if [force] is unset or `FALSE`, it will append the data. An error will be returned if the schema update or data appension fails.\n*   `separateTablesPerAssetType` (*type:* `boolean()`, *default:* `nil`) - If this flag is `TRUE`, the snapshot results will be written to one or multiple tables, each of which contains results of one asset type. The [force] and [partition_spec] fields will apply to each of them. Field [table] will be concatenated with \"_\" and the asset type names (see https://cloud.google.com/asset-inventory/docs/supported-asset-types for supported asset types) to construct per-asset-type table names, in which all non-alphanumeric characters like \".\" and \"/\" will be substituted by \"_\". Example: if field [table] is \"mytable\" and snapshot results contain \"storage.googleapis.com/Bucket\" assets, the corresponding table name will be \"mytable_storage_googleapis_com_Bucket\". If any of these tables does not exist, a new table with the concatenated name will be created. When [content_type] in the ExportAssetsRequest is `RESOURCE`, the schema of each table will include RECORD-type columns mapped to the nested fields in the Asset.resource.data field of that asset type (up to the 15 nested level BigQuery supports (https://cloud.google.com/bigquery/docs/nested-repeated#limitations)). The fields in >15 nested levels will be stored in JSON format string as a child column of its parent RECORD column. If error occurs when exporting to any table, the whole export call will return an error but the export results that already succeed will persist. Example: if exporting to table_type_A succeeds when exporting to table_type_B fails during one export call, the results in table_type_A will persist and there will not be partial results persisting in a table.\n*   `table` (*type:* `String.t`, *default:* `nil`) - Required. The BigQuery table to which the snapshot result should be written. If this table does not exist, a new table with the given name will be created.","ref":"GoogleApi.CloudAsset.V1.Model.BigQueryDestination.html#module-attributes"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Model.BigQueryDestination.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.CloudAsset.V1.Model.BigQueryDestination.html#decode/2"},{"type":"type","title":"GoogleApi.CloudAsset.V1.Model.BigQueryDestination.t/0","doc":"","ref":"GoogleApi.CloudAsset.V1.Model.BigQueryDestination.html#t:t/0"},{"type":"module","title":"GoogleApi.CloudAsset.V1.Model.Binding","doc":"Associates `members`, or principals, with a `role`.","ref":"GoogleApi.CloudAsset.V1.Model.Binding.html"},{"type":"module","title":"Attributes - GoogleApi.CloudAsset.V1.Model.Binding","doc":"*   `condition` (*type:* `GoogleApi.CloudAsset.V1.Model.Expr.t`, *default:* `nil`) - The condition that is associated with this binding. If the condition evaluates to `true`, then this binding applies to the current request. If the condition evaluates to `false`, then this binding does not apply to the current request. However, a different role binding might grant the same role to one or more of the principals in this binding. To learn which resources support conditions in their IAM policies, see the [IAM documentation](https://cloud.google.com/iam/help/conditions/resource-policies).\n*   `members` (*type:* `list(String.t)`, *default:* `nil`) - Specifies the principals requesting access for a Google Cloud resource. `members` can have the following values: * `allUsers`: A special identifier that represents anyone who is on the internet; with or without a Google account. * `allAuthenticatedUsers`: A special identifier that represents anyone who is authenticated with a Google account or a service account. Does not include identities that come from external identity providers (IdPs) through identity federation. * `user:{emailid}`: An email address that represents a specific Google account. For example, `alice@example.com` . * `serviceAccount:{emailid}`: An email address that represents a Google service account. For example, `my-other-app@appspot.gserviceaccount.com`. * `serviceAccount:{projectid}.svc.id.goog[{namespace}/{kubernetes-sa}]`: An identifier for a [Kubernetes service account](https://cloud.google.com/kubernetes-engine/docs/how-to/kubernetes-service-accounts). For example, `my-project.svc.id.goog[my-namespace/my-kubernetes-sa]`. * `group:{emailid}`: An email address that represents a Google group. For example, `admins@example.com`. * `domain:{domain}`: The G Suite domain (primary) that represents all the users of that domain. For example, `google.com` or `example.com`. * `principal://iam.googleapis.com/locations/global/workforcePools/{pool_id}/subject/{subject_attribute_value}`: A single identity in a workforce identity pool. * `principalSet://iam.googleapis.com/locations/global/workforcePools/{pool_id}/group/{group_id}`: All workforce identities in a group. * `principalSet://iam.googleapis.com/locations/global/workforcePools/{pool_id}/attribute.{attribute_name}/{attribute_value}`: All workforce identities with a specific attribute value. * `principalSet://iam.googleapis.com/locations/global/workforcePools/{pool_id}/*`: All identities in a workforce identity pool. * `principal://iam.googleapis.com/projects/{project_number}/locations/global/workloadIdentityPools/{pool_id}/subject/{subject_attribute_value}`: A single identity in a workload identity pool. * `principalSet://iam.googleapis.com/projects/{project_number}/locations/global/workloadIdentityPools/{pool_id}/group/{group_id}`: A workload identity pool group. * `principalSet://iam.googleapis.com/projects/{project_number}/locations/global/workloadIdentityPools/{pool_id}/attribute.{attribute_name}/{attribute_value}`: All identities in a workload identity pool with a certain attribute. * `principalSet://iam.googleapis.com/projects/{project_number}/locations/global/workloadIdentityPools/{pool_id}/*`: All identities in a workload identity pool. * `deleted:user:{emailid}?uid={uniqueid}`: An email address (plus unique identifier) representing a user that has been recently deleted. For example, `alice@example.com?uid=123456789012345678901`. If the user is recovered, this value reverts to `user:{emailid}` and the recovered user retains the role in the binding. * `deleted:serviceAccount:{emailid}?uid={uniqueid}`: An email address (plus unique identifier) representing a service account that has been recently deleted. For example, `my-other-app@appspot.gserviceaccount.com?uid=123456789012345678901`. If the service account is undeleted, this value reverts to `serviceAccount:{emailid}` and the undeleted service account retains the role in the binding. * `deleted:group:{emailid}?uid={uniqueid}`: An email address (plus unique identifier) representing a Google group that has been recently deleted. For example, `admins@example.com?uid=123456789012345678901`. If the group is recovered, this value reverts to `group:{emailid}` and the recovered group retains the role in the binding. * `deleted:principal://iam.googleapis.com/locations/global/workforcePools/{pool_id}/subject/{subject_attribute_value}`: Deleted single identity in a workforce identity pool. For example, `deleted:principal://iam.googleapis.com/locations/global/workforcePools/my-pool-id/subject/my-subject-attribute-value`.\n*   `role` (*type:* `String.t`, *default:* `nil`) - Role that is assigned to the list of `members`, or principals. For example, `roles/viewer`, `roles/editor`, or `roles/owner`. For an overview of the IAM roles and permissions, see the [IAM documentation](https://cloud.google.com/iam/docs/roles-overview). For a list of the available pre-defined roles, see [here](https://cloud.google.com/iam/docs/understanding-roles).","ref":"GoogleApi.CloudAsset.V1.Model.Binding.html#module-attributes"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Model.Binding.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.CloudAsset.V1.Model.Binding.html#decode/2"},{"type":"type","title":"GoogleApi.CloudAsset.V1.Model.Binding.t/0","doc":"","ref":"GoogleApi.CloudAsset.V1.Model.Binding.html#t:t/0"},{"type":"module","title":"GoogleApi.CloudAsset.V1.Model.ConditionContext","doc":"The IAM conditions context.","ref":"GoogleApi.CloudAsset.V1.Model.ConditionContext.html"},{"type":"module","title":"Attributes - GoogleApi.CloudAsset.V1.Model.ConditionContext","doc":"*   `accessTime` (*type:* `DateTime.t`, *default:* `nil`) - The hypothetical access timestamp to evaluate IAM conditions. Note that this value must not be earlier than the current time; otherwise, an INVALID_ARGUMENT error will be returned.","ref":"GoogleApi.CloudAsset.V1.Model.ConditionContext.html#module-attributes"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Model.ConditionContext.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.CloudAsset.V1.Model.ConditionContext.html#decode/2"},{"type":"type","title":"GoogleApi.CloudAsset.V1.Model.ConditionContext.t/0","doc":"","ref":"GoogleApi.CloudAsset.V1.Model.ConditionContext.html#t:t/0"},{"type":"module","title":"GoogleApi.CloudAsset.V1.Model.ConditionEvaluation","doc":"The condition evaluation.","ref":"GoogleApi.CloudAsset.V1.Model.ConditionEvaluation.html"},{"type":"module","title":"Attributes - GoogleApi.CloudAsset.V1.Model.ConditionEvaluation","doc":"*   `evaluationValue` (*type:* `String.t`, *default:* `nil`) - The evaluation result.","ref":"GoogleApi.CloudAsset.V1.Model.ConditionEvaluation.html#module-attributes"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Model.ConditionEvaluation.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.CloudAsset.V1.Model.ConditionEvaluation.html#decode/2"},{"type":"type","title":"GoogleApi.CloudAsset.V1.Model.ConditionEvaluation.t/0","doc":"","ref":"GoogleApi.CloudAsset.V1.Model.ConditionEvaluation.html#t:t/0"},{"type":"module","title":"GoogleApi.CloudAsset.V1.Model.CreateFeedRequest","doc":"Create asset feed request.","ref":"GoogleApi.CloudAsset.V1.Model.CreateFeedRequest.html"},{"type":"module","title":"Attributes - GoogleApi.CloudAsset.V1.Model.CreateFeedRequest","doc":"*   `feed` (*type:* `GoogleApi.CloudAsset.V1.Model.Feed.t`, *default:* `nil`) - Required. The feed details. The field `name` must be empty and it will be generated in the format of: projects/project_number/feeds/feed_id folders/folder_number/feeds/feed_id organizations/organization_number/feeds/feed_id\n*   `feedId` (*type:* `String.t`, *default:* `nil`) - Required. This is the client-assigned asset feed identifier and it needs to be unique under a specific parent project/folder/organization.","ref":"GoogleApi.CloudAsset.V1.Model.CreateFeedRequest.html#module-attributes"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Model.CreateFeedRequest.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.CloudAsset.V1.Model.CreateFeedRequest.html#decode/2"},{"type":"type","title":"GoogleApi.CloudAsset.V1.Model.CreateFeedRequest.t/0","doc":"","ref":"GoogleApi.CloudAsset.V1.Model.CreateFeedRequest.html#t:t/0"},{"type":"module","title":"GoogleApi.CloudAsset.V1.Model.Date","doc":"Represents a whole or partial calendar date, such as a birthday. The time of day and time zone are either specified elsewhere or are insignificant. The date is relative to the Gregorian Calendar. This can represent one of the following: * A full date, with non-zero year, month, and day values. * A month and day, with a zero year (for example, an anniversary). * A year on its own, with a zero month and a zero day. * A year and month, with a zero day (for example, a credit card expiration date). Related types: * google.type.TimeOfDay * google.type.DateTime * google.protobuf.Timestamp","ref":"GoogleApi.CloudAsset.V1.Model.Date.html"},{"type":"module","title":"Attributes - GoogleApi.CloudAsset.V1.Model.Date","doc":"*   `day` (*type:* `integer()`, *default:* `nil`) - Day of a month. Must be from 1 to 31 and valid for the year and month, or 0 to specify a year by itself or a year and month where the day isn't significant.\n*   `month` (*type:* `integer()`, *default:* `nil`) - Month of a year. Must be from 1 to 12, or 0 to specify a year without a month and day.\n*   `year` (*type:* `integer()`, *default:* `nil`) - Year of the date. Must be from 1 to 9999, or 0 to specify a date without a year.","ref":"GoogleApi.CloudAsset.V1.Model.Date.html#module-attributes"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Model.Date.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.CloudAsset.V1.Model.Date.html#decode/2"},{"type":"type","title":"GoogleApi.CloudAsset.V1.Model.Date.t/0","doc":"","ref":"GoogleApi.CloudAsset.V1.Model.Date.html#t:t/0"},{"type":"module","title":"GoogleApi.CloudAsset.V1.Model.EffectiveIamPolicy","doc":"The effective IAM policies on one resource.","ref":"GoogleApi.CloudAsset.V1.Model.EffectiveIamPolicy.html"},{"type":"module","title":"Attributes - GoogleApi.CloudAsset.V1.Model.EffectiveIamPolicy","doc":"*   `fullResourceName` (*type:* `String.t`, *default:* `nil`) - The [full_resource_name] (https://cloud.google.com/asset-inventory/docs/resource-name-format) for which the policies are computed. This is one of the BatchGetEffectiveIamPoliciesRequest.names the caller provides in the request.\n*   `policies` (*type:* `list(GoogleApi.CloudAsset.V1.Model.PolicyInfo.t)`, *default:* `nil`) - The effective policies for the full_resource_name. These policies include the policy set on the full_resource_name and those set on its parents and ancestors up to the BatchGetEffectiveIamPoliciesRequest.scope. Note that these policies are not filtered according to the resource type of the full_resource_name. These policies are hierarchically ordered by PolicyInfo.attached_resource starting from full_resource_name itself to its parents and ancestors, such that policies[i]'s PolicyInfo.attached_resource is the child of policies[i+1]'s PolicyInfo.attached_resource, if policies[i+1] exists.","ref":"GoogleApi.CloudAsset.V1.Model.EffectiveIamPolicy.html#module-attributes"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Model.EffectiveIamPolicy.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.CloudAsset.V1.Model.EffectiveIamPolicy.html#decode/2"},{"type":"type","title":"GoogleApi.CloudAsset.V1.Model.EffectiveIamPolicy.t/0","doc":"","ref":"GoogleApi.CloudAsset.V1.Model.EffectiveIamPolicy.html#t:t/0"},{"type":"module","title":"GoogleApi.CloudAsset.V1.Model.EffectiveTagDetails","doc":"The effective tags and the ancestor resources from which they were inherited.","ref":"GoogleApi.CloudAsset.V1.Model.EffectiveTagDetails.html"},{"type":"module","title":"Attributes - GoogleApi.CloudAsset.V1.Model.EffectiveTagDetails","doc":"*   `attachedResource` (*type:* `String.t`, *default:* `nil`) - The [full resource name](https://cloud.google.com/asset-inventory/docs/resource-name-format) of the ancestor from which an effective_tag is inherited, according to [tag inheritance](https://cloud.google.com/resource-manager/docs/tags/tags-overview#inheritance).\n*   `effectiveTags` (*type:* `list(GoogleApi.CloudAsset.V1.Model.Tag.t)`, *default:* `nil`) - The effective tags inherited from the attached_resource. Note that tags with the same key but different values may attach to resources at a different hierarchy levels. The lower hierarchy tag value will overwrite the higher hierarchy tag value of the same tag key. In this case, the tag value at the higher hierarchy level will be removed. For more information, see [tag inheritance](https://cloud.google.com/resource-manager/docs/tags/tags-overview#inheritance).","ref":"GoogleApi.CloudAsset.V1.Model.EffectiveTagDetails.html#module-attributes"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Model.EffectiveTagDetails.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.CloudAsset.V1.Model.EffectiveTagDetails.html#decode/2"},{"type":"type","title":"GoogleApi.CloudAsset.V1.Model.EffectiveTagDetails.t/0","doc":"","ref":"GoogleApi.CloudAsset.V1.Model.EffectiveTagDetails.html#t:t/0"},{"type":"module","title":"GoogleApi.CloudAsset.V1.Model.Empty","doc":"A generic empty message that you can re-use to avoid defining duplicated empty messages in your APIs. A typical example is to use it as the request or the response type of an API method. For instance: service Foo { rpc Bar(google.protobuf.Empty) returns (google.protobuf.Empty); }","ref":"GoogleApi.CloudAsset.V1.Model.Empty.html"},{"type":"module","title":"Attributes - GoogleApi.CloudAsset.V1.Model.Empty","doc":"","ref":"GoogleApi.CloudAsset.V1.Model.Empty.html#module-attributes"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Model.Empty.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.CloudAsset.V1.Model.Empty.html#decode/2"},{"type":"type","title":"GoogleApi.CloudAsset.V1.Model.Empty.t/0","doc":"","ref":"GoogleApi.CloudAsset.V1.Model.Empty.html#t:t/0"},{"type":"module","title":"GoogleApi.CloudAsset.V1.Model.Explanation","doc":"Explanation about the IAM policy search result.","ref":"GoogleApi.CloudAsset.V1.Model.Explanation.html"},{"type":"module","title":"Attributes - GoogleApi.CloudAsset.V1.Model.Explanation","doc":"*   `matchedPermissions` (*type:* `%{optional(String.t) => GoogleApi.CloudAsset.V1.Model.Permissions.t}`, *default:* `nil`) - The map from roles to their included permissions that match the permission query (i.e., a query containing `policy.role.permissions:`). Example: if query `policy.role.permissions:compute.disk.get` matches a policy binding that contains owner role, the matched_permissions will be `{\"roles/owner\": [\"compute.disk.get\"]}`. The roles can also be found in the returned `policy` bindings. Note that the map is populated only for requests with permission queries.","ref":"GoogleApi.CloudAsset.V1.Model.Explanation.html#module-attributes"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Model.Explanation.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.CloudAsset.V1.Model.Explanation.html#decode/2"},{"type":"type","title":"GoogleApi.CloudAsset.V1.Model.Explanation.t/0","doc":"","ref":"GoogleApi.CloudAsset.V1.Model.Explanation.html#t:t/0"},{"type":"module","title":"GoogleApi.CloudAsset.V1.Model.ExportAssetsRequest","doc":"Export asset request.","ref":"GoogleApi.CloudAsset.V1.Model.ExportAssetsRequest.html"},{"type":"module","title":"Attributes - GoogleApi.CloudAsset.V1.Model.ExportAssetsRequest","doc":"*   `assetTypes` (*type:* `list(String.t)`, *default:* `nil`) - A list of asset types to take a snapshot for. For example: \"compute.googleapis.com/Disk\". Regular expressions are also supported. For example: * \"compute.googleapis.com.*\" snapshots resources whose asset type starts with \"compute.googleapis.com\". * \".*Instance\" snapshots resources whose asset type ends with \"Instance\". * \".*Instance.*\" snapshots resources whose asset type contains \"Instance\". See [RE2](https://github.com/google/re2/wiki/Syntax) for all supported regular expression syntax. If the regular expression does not match any supported asset type, an INVALID_ARGUMENT error will be returned. If specified, only matching assets will be returned, otherwise, it will snapshot all asset types. See [Introduction to Cloud Asset Inventory](https://cloud.google.com/asset-inventory/docs/overview) for all supported asset types.\n*   `contentType` (*type:* `String.t`, *default:* `nil`) - Asset content type. If not specified, no content but the asset name will be returned.\n*   `outputConfig` (*type:* `GoogleApi.CloudAsset.V1.Model.OutputConfig.t`, *default:* `nil`) - Required. Output configuration indicating where the results will be output to.\n*   `readTime` (*type:* `DateTime.t`, *default:* `nil`) - Timestamp to take an asset snapshot. This can only be set to a timestamp between the current time and the current time minus 35 days (inclusive). If not specified, the current time will be used. Due to delays in resource data collection and indexing, there is a volatile window during which running the same query may get different results.\n*   `relationshipTypes` (*type:* `list(String.t)`, *default:* `nil`) - A list of relationship types to export, for example: `INSTANCE_TO_INSTANCEGROUP`. This field should only be specified if content_type=RELATIONSHIP. * If specified: it snapshots specified relationships. It returns an error if any of the [relationship_types] doesn't belong to the supported relationship types of the [asset_types] or if any of the [asset_types] doesn't belong to the source types of the [relationship_types]. * Otherwise: it snapshots the supported relationships for all [asset_types] or returns an error if any of the [asset_types] has no relationship support. An unspecified asset types field means all supported asset_types. See [Introduction to Cloud Asset Inventory](https://cloud.google.com/asset-inventory/docs/overview) for all supported asset types and relationship types.","ref":"GoogleApi.CloudAsset.V1.Model.ExportAssetsRequest.html#module-attributes"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Model.ExportAssetsRequest.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.CloudAsset.V1.Model.ExportAssetsRequest.html#decode/2"},{"type":"type","title":"GoogleApi.CloudAsset.V1.Model.ExportAssetsRequest.t/0","doc":"","ref":"GoogleApi.CloudAsset.V1.Model.ExportAssetsRequest.html#t:t/0"},{"type":"module","title":"GoogleApi.CloudAsset.V1.Model.Expr","doc":"Represents a textual expression in the Common Expression Language (CEL) syntax. CEL is a C-like expression language. The syntax and semantics of CEL are documented at https://github.com/google/cel-spec. Example (Comparison): title: \"Summary size limit\" description: \"Determines if a summary is less than 100 chars\" expression: \"document.summary.size() < 100\" Example (Equality): title: \"Requestor is owner\" description: \"Determines if requestor is the document owner\" expression: \"document.owner == request.auth.claims.email\" Example (Logic): title: \"Public documents\" description: \"Determine whether the document should be publicly visible\" expression: \"document.type != 'private' && document.type != 'internal'\" Example (Data Manipulation): title: \"Notification string\" description: \"Create a notification string with a timestamp.\" expression: \"'New message received at ' + string(document.create_time)\" The exact variables and functions that may be referenced within an expression are determined by the service that evaluates it. See the service documentation for additional information.","ref":"GoogleApi.CloudAsset.V1.Model.Expr.html"},{"type":"module","title":"Attributes - GoogleApi.CloudAsset.V1.Model.Expr","doc":"*   `description` (*type:* `String.t`, *default:* `nil`) - Optional. Description of the expression. This is a longer text which describes the expression, e.g. when hovered over it in a UI.\n*   `expression` (*type:* `String.t`, *default:* `nil`) - Textual representation of an expression in Common Expression Language syntax.\n*   `location` (*type:* `String.t`, *default:* `nil`) - Optional. String indicating the location of the expression for error reporting, e.g. a file name and a position in the file.\n*   `title` (*type:* `String.t`, *default:* `nil`) - Optional. Title for the expression, i.e. a short string describing its purpose. This can be used e.g. in UIs which allow to enter the expression.","ref":"GoogleApi.CloudAsset.V1.Model.Expr.html#module-attributes"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Model.Expr.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.CloudAsset.V1.Model.Expr.html#decode/2"},{"type":"type","title":"GoogleApi.CloudAsset.V1.Model.Expr.t/0","doc":"","ref":"GoogleApi.CloudAsset.V1.Model.Expr.html#t:t/0"},{"type":"module","title":"GoogleApi.CloudAsset.V1.Model.Feed","doc":"An asset feed used to export asset updates to a destinations. An asset feed filter controls what updates are exported. The asset feed must be created within a project, organization, or folder. Supported destinations are: Pub/Sub topics.","ref":"GoogleApi.CloudAsset.V1.Model.Feed.html"},{"type":"module","title":"Attributes - GoogleApi.CloudAsset.V1.Model.Feed","doc":"*   `assetNames` (*type:* `list(String.t)`, *default:* `nil`) - A list of the full names of the assets to receive updates. You must specify either or both of asset_names and asset_types. Only asset updates matching specified asset_names or asset_types are exported to the feed. Example: `//compute.googleapis.com/projects/my_project_123/zones/zone1/instances/instance1`. For a list of the full names for supported asset types, see [Resource name format](/asset-inventory/docs/resource-name-format).\n*   `assetTypes` (*type:* `list(String.t)`, *default:* `nil`) - A list of types of the assets to receive updates. You must specify either or both of asset_names and asset_types. Only asset updates matching specified asset_names or asset_types are exported to the feed. Example: `\"compute.googleapis.com/Disk\"` For a list of all supported asset types, see [Supported asset types](/asset-inventory/docs/supported-asset-types).\n*   `condition` (*type:* `GoogleApi.CloudAsset.V1.Model.Expr.t`, *default:* `nil`) - A condition which determines whether an asset update should be published. If specified, an asset will be returned only when the expression evaluates to true. When set, `expression` field in the `Expr` must be a valid [CEL expression] (https://github.com/google/cel-spec) on a TemporalAsset with name `temporal_asset`. Example: a Feed with expression (\"temporal_asset.deleted == true\") will only publish Asset deletions. Other fields of `Expr` are optional. See our [user guide](https://cloud.google.com/asset-inventory/docs/monitoring-asset-changes-with-condition) for detailed instructions.\n*   `contentType` (*type:* `String.t`, *default:* `nil`) - Asset content type. If not specified, no content but the asset name and type will be returned.\n*   `feedOutputConfig` (*type:* `GoogleApi.CloudAsset.V1.Model.FeedOutputConfig.t`, *default:* `nil`) - Required. Feed output configuration defining where the asset updates are published to.\n*   `name` (*type:* `String.t`, *default:* `nil`) - Required. The format will be projects/{project_number}/feeds/{client-assigned_feed_identifier} or folders/{folder_number}/feeds/{client-assigned_feed_identifier} or organizations/{organization_number}/feeds/{client-assigned_feed_identifier} The client-assigned feed identifier must be unique within the parent project/folder/organization.\n*   `relationshipTypes` (*type:* `list(String.t)`, *default:* `nil`) - A list of relationship types to output, for example: `INSTANCE_TO_INSTANCEGROUP`. This field should only be specified if content_type=RELATIONSHIP. * If specified: it outputs specified relationship updates on the [asset_names] or the [asset_types]. It returns an error if any of the [relationship_types] doesn't belong to the supported relationship types of the [asset_names] or [asset_types], or any of the [asset_names] or the [asset_types] doesn't belong to the source types of the [relationship_types]. * Otherwise: it outputs the supported relationships of the types of [asset_names] and [asset_types] or returns an error if any of the [asset_names] or the [asset_types] has no replationship support. See [Introduction to Cloud Asset Inventory](https://cloud.google.com/asset-inventory/docs/overview) for all supported asset types and relationship types.","ref":"GoogleApi.CloudAsset.V1.Model.Feed.html#module-attributes"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Model.Feed.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.CloudAsset.V1.Model.Feed.html#decode/2"},{"type":"type","title":"GoogleApi.CloudAsset.V1.Model.Feed.t/0","doc":"","ref":"GoogleApi.CloudAsset.V1.Model.Feed.html#t:t/0"},{"type":"module","title":"GoogleApi.CloudAsset.V1.Model.FeedOutputConfig","doc":"Output configuration for asset feed destination.","ref":"GoogleApi.CloudAsset.V1.Model.FeedOutputConfig.html"},{"type":"module","title":"Attributes - GoogleApi.CloudAsset.V1.Model.FeedOutputConfig","doc":"*   `pubsubDestination` (*type:* `GoogleApi.CloudAsset.V1.Model.PubsubDestination.t`, *default:* `nil`) - Destination on Pub/Sub.","ref":"GoogleApi.CloudAsset.V1.Model.FeedOutputConfig.html#module-attributes"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Model.FeedOutputConfig.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.CloudAsset.V1.Model.FeedOutputConfig.html#decode/2"},{"type":"type","title":"GoogleApi.CloudAsset.V1.Model.FeedOutputConfig.t/0","doc":"","ref":"GoogleApi.CloudAsset.V1.Model.FeedOutputConfig.html#t:t/0"},{"type":"module","title":"GoogleApi.CloudAsset.V1.Model.GcsDestination","doc":"A Cloud Storage location.","ref":"GoogleApi.CloudAsset.V1.Model.GcsDestination.html"},{"type":"module","title":"Attributes - GoogleApi.CloudAsset.V1.Model.GcsDestination","doc":"*   `uri` (*type:* `String.t`, *default:* `nil`) - The URI of the Cloud Storage object. It's the same URI that is used by gsutil. Example: \"gs://bucket_name/object_name\". See [Viewing and Editing Object Metadata](https://cloud.google.com/storage/docs/viewing-editing-metadata) for more information. If the specified Cloud Storage object already exists and there is no [hold](https://cloud.google.com/storage/docs/object-holds), it will be overwritten with the exported result.\n*   `uriPrefix` (*type:* `String.t`, *default:* `nil`) - The URI prefix of all generated Cloud Storage objects. Example: \"gs://bucket_name/object_name_prefix\". Each object URI is in format: \"gs://bucket_name/object_name_prefix// and only contains assets for that type. starts from 0. Example: \"gs://bucket_name/object_name_prefix/compute.googleapis.com/Disk/0\" is the first shard of output objects containing all compute.googleapis.com/Disk assets. An INVALID_ARGUMENT error will be returned if file with the same name \"gs://bucket_name/object_name_prefix\" already exists.","ref":"GoogleApi.CloudAsset.V1.Model.GcsDestination.html#module-attributes"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Model.GcsDestination.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.CloudAsset.V1.Model.GcsDestination.html#decode/2"},{"type":"type","title":"GoogleApi.CloudAsset.V1.Model.GcsDestination.t/0","doc":"","ref":"GoogleApi.CloudAsset.V1.Model.GcsDestination.html#t:t/0"},{"type":"module","title":"GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1Access","doc":"An IAM role or permission under analysis.","ref":"GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1Access.html"},{"type":"module","title":"Attributes - GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1Access","doc":"*   `analysisState` (*type:* `GoogleApi.CloudAsset.V1.Model.IamPolicyAnalysisState.t`, *default:* `nil`) - The analysis state of this access.\n*   `permission` (*type:* `String.t`, *default:* `nil`) - The permission.\n*   `role` (*type:* `String.t`, *default:* `nil`) - The role.","ref":"GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1Access.html#module-attributes"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1Access.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1Access.html#decode/2"},{"type":"type","title":"GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1Access.t/0","doc":"","ref":"GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1Access.html#t:t/0"},{"type":"module","title":"GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1AccessControlList","doc":"An access control list, derived from the above IAM policy binding, which contains a set of resources and accesses. May include one item from each set to compose an access control entry. NOTICE that there could be multiple access control lists for one IAM policy binding. The access control lists are created based on resource and access combinations. For example, assume we have the following cases in one IAM policy binding: - Permission P1 and P2 apply to resource R1 and R2; - Permission P3 applies to resource R2 and R3; This will result in the following access control lists: - AccessControlList 1: [R1, R2], [P1, P2] - AccessControlList 2: [R2, R3], [P3]","ref":"GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1AccessControlList.html"},{"type":"module","title":"Attributes - GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1AccessControlList","doc":"*   `accesses` (*type:* `list(GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1Access.t)`, *default:* `nil`) - The accesses that match one of the following conditions: - The access_selector, if it is specified in request; - Otherwise, access specifiers reachable from the policy binding's role.\n*   `conditionEvaluation` (*type:* `GoogleApi.CloudAsset.V1.Model.ConditionEvaluation.t`, *default:* `nil`) - Condition evaluation for this AccessControlList, if there is a condition defined in the above IAM policy binding.\n*   `resourceEdges` (*type:* `list(GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1Edge.t)`, *default:* `nil`) - Resource edges of the graph starting from the policy attached resource to any descendant resources. The Edge.source_node contains the full resource name of a parent resource and Edge.target_node contains the full resource name of a child resource. This field is present only if the output_resource_edges option is enabled in request.\n*   `resources` (*type:* `list(GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1Resource.t)`, *default:* `nil`) - The resources that match one of the following conditions: - The resource_selector, if it is specified in request; - Otherwise, resources reachable from the policy attached resource.","ref":"GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1AccessControlList.html#module-attributes"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1AccessControlList.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1AccessControlList.html#decode/2"},{"type":"type","title":"GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1AccessControlList.t/0","doc":"","ref":"GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1AccessControlList.html#t:t/0"},{"type":"module","title":"GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1AnalyzeOrgPolicyGovernedAssetsResponseGovernedAsset","doc":"Represents a Google Cloud asset(resource or IAM policy) governed by the organization policies of the AnalyzeOrgPolicyGovernedAssetsRequest.constraint.","ref":"GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1AnalyzeOrgPolicyGovernedAssetsResponseGovernedAsset.html"},{"type":"module","title":"Attributes - GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1AnalyzeOrgPolicyGovernedAssetsResponseGovernedAsset","doc":"*   `consolidatedPolicy` (*type:* `GoogleApi.CloudAsset.V1.Model.AnalyzerOrgPolicy.t`, *default:* `nil`) - The consolidated policy for the analyzed asset. The consolidated policy is computed by merging and evaluating AnalyzeOrgPolicyGovernedAssetsResponse.GovernedAsset.policy_bundle. The evaluation will respect the organization policy [hierarchy rules](https://cloud.google.com/resource-manager/docs/organization-policy/understanding-hierarchy).\n*   `governedIamPolicy` (*type:* `GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1AnalyzeOrgPolicyGovernedAssetsResponseGovernedIamPolicy.t`, *default:* `nil`) - An IAM policy governed by the organization policies of the AnalyzeOrgPolicyGovernedAssetsRequest.constraint.\n*   `governedResource` (*type:* `GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1AnalyzeOrgPolicyGovernedAssetsResponseGovernedResource.t`, *default:* `nil`) - A Google Cloud resource governed by the organization policies of the AnalyzeOrgPolicyGovernedAssetsRequest.constraint.\n*   `policyBundle` (*type:* `list(GoogleApi.CloudAsset.V1.Model.AnalyzerOrgPolicy.t)`, *default:* `nil`) - The ordered list of all organization policies from the AnalyzeOrgPoliciesResponse.OrgPolicyResult.consolidated_policy.attached_resource to the scope specified in the request. If the constraint is defined with default policy, it will also appear in the list.","ref":"GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1AnalyzeOrgPolicyGovernedAssetsResponseGovernedAsset.html#module-attributes"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1AnalyzeOrgPolicyGovernedAssetsResponseGovernedAsset.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1AnalyzeOrgPolicyGovernedAssetsResponseGovernedAsset.html#decode/2"},{"type":"type","title":"GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1AnalyzeOrgPolicyGovernedAssetsResponseGovernedAsset.t/0","doc":"","ref":"GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1AnalyzeOrgPolicyGovernedAssetsResponseGovernedAsset.html#t:t/0"},{"type":"module","title":"GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1AnalyzeOrgPolicyGovernedAssetsResponseGovernedIamPolicy","doc":"The IAM policies governed by the organization policies of the AnalyzeOrgPolicyGovernedAssetsRequest.constraint.","ref":"GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1AnalyzeOrgPolicyGovernedAssetsResponseGovernedIamPolicy.html"},{"type":"module","title":"Attributes - GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1AnalyzeOrgPolicyGovernedAssetsResponseGovernedIamPolicy","doc":"*   `assetType` (*type:* `String.t`, *default:* `nil`) - The asset type of the AnalyzeOrgPolicyGovernedAssetsResponse.GovernedIamPolicy.attached_resource. Example: `cloudresourcemanager.googleapis.com/Project` See [Cloud Asset Inventory Supported Asset Types](https://cloud.google.com/asset-inventory/docs/supported-asset-types) for all supported asset types.\n*   `attachedResource` (*type:* `String.t`, *default:* `nil`) - The full resource name of the resource on which this IAM policy is set. Example: `//compute.googleapis.com/projects/my_project_123/zones/zone1/instances/instance1`. See [Cloud Asset Inventory Resource Name Format](https://cloud.google.com/asset-inventory/docs/resource-name-format) for more information.\n*   `folders` (*type:* `list(String.t)`, *default:* `nil`) - The folder(s) that this IAM policy belongs to, in the format of folders/{FOLDER_NUMBER}. This field is available when the IAM policy belongs (directly or cascadingly) to one or more folders.\n*   `organization` (*type:* `String.t`, *default:* `nil`) - The organization that this IAM policy belongs to, in the format of organizations/{ORGANIZATION_NUMBER}. This field is available when the IAM policy belongs (directly or cascadingly) to an organization.\n*   `policy` (*type:* `GoogleApi.CloudAsset.V1.Model.Policy.t`, *default:* `nil`) - The IAM policy directly set on the given resource.\n*   `project` (*type:* `String.t`, *default:* `nil`) - The project that this IAM policy belongs to, in the format of projects/{PROJECT_NUMBER}. This field is available when the IAM policy belongs to a project.","ref":"GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1AnalyzeOrgPolicyGovernedAssetsResponseGovernedIamPolicy.html#module-attributes"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1AnalyzeOrgPolicyGovernedAssetsResponseGovernedIamPolicy.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1AnalyzeOrgPolicyGovernedAssetsResponseGovernedIamPolicy.html#decode/2"},{"type":"type","title":"GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1AnalyzeOrgPolicyGovernedAssetsResponseGovernedIamPolicy.t/0","doc":"","ref":"GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1AnalyzeOrgPolicyGovernedAssetsResponseGovernedIamPolicy.html#t:t/0"},{"type":"module","title":"GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1AnalyzeOrgPolicyGovernedAssetsResponseGovernedResource","doc":"The Google Cloud resources governed by the organization policies of the AnalyzeOrgPolicyGovernedAssetsRequest.constraint.","ref":"GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1AnalyzeOrgPolicyGovernedAssetsResponseGovernedResource.html"},{"type":"module","title":"Attributes - GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1AnalyzeOrgPolicyGovernedAssetsResponseGovernedResource","doc":"*   `assetType` (*type:* `String.t`, *default:* `nil`) - The asset type of the AnalyzeOrgPolicyGovernedAssetsResponse.GovernedResource.full_resource_name Example: `cloudresourcemanager.googleapis.com/Project` See [Cloud Asset Inventory Supported Asset Types](https://cloud.google.com/asset-inventory/docs/supported-asset-types) for all supported asset types.\n*   `effectiveTags` (*type:* `list(GoogleApi.CloudAsset.V1.Model.EffectiveTagDetails.t)`, *default:* `nil`) - The effective tags on this resource.\n*   `folders` (*type:* `list(String.t)`, *default:* `nil`) - The folder(s) that this resource belongs to, in the format of folders/{FOLDER_NUMBER}. This field is available when the resource belongs (directly or cascadingly) to one or more folders.\n*   `fullResourceName` (*type:* `String.t`, *default:* `nil`) - The [full resource name] (https://cloud.google.com/asset-inventory/docs/resource-name-format) of the Google Cloud resource.\n*   `organization` (*type:* `String.t`, *default:* `nil`) - The organization that this resource belongs to, in the format of organizations/{ORGANIZATION_NUMBER}. This field is available when the resource belongs (directly or cascadingly) to an organization.\n*   `parent` (*type:* `String.t`, *default:* `nil`) - The [full resource name] (https://cloud.google.com/asset-inventory/docs/resource-name-format) of the parent of AnalyzeOrgPolicyGovernedAssetsResponse.GovernedResource.full_resource_name.\n*   `project` (*type:* `String.t`, *default:* `nil`) - The project that this resource belongs to, in the format of projects/{PROJECT_NUMBER}. This field is available when the resource belongs to a project.","ref":"GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1AnalyzeOrgPolicyGovernedAssetsResponseGovernedResource.html#module-attributes"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1AnalyzeOrgPolicyGovernedAssetsResponseGovernedResource.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1AnalyzeOrgPolicyGovernedAssetsResponseGovernedResource.html#decode/2"},{"type":"type","title":"GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1AnalyzeOrgPolicyGovernedAssetsResponseGovernedResource.t/0","doc":"","ref":"GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1AnalyzeOrgPolicyGovernedAssetsResponseGovernedResource.html#t:t/0"},{"type":"module","title":"GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1BigQueryDestination","doc":"A BigQuery destination.","ref":"GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1BigQueryDestination.html"},{"type":"module","title":"Attributes - GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1BigQueryDestination","doc":"*   `dataset` (*type:* `String.t`, *default:* `nil`) - Required. The BigQuery dataset in format \"projects/projectId/datasets/datasetId\", to which the analysis results should be exported. If this dataset does not exist, the export call will return an INVALID_ARGUMENT error.\n*   `partitionKey` (*type:* `String.t`, *default:* `nil`) - The partition key for BigQuery partitioned table.\n*   `tablePrefix` (*type:* `String.t`, *default:* `nil`) - Required. The prefix of the BigQuery tables to which the analysis results will be written. Tables will be created based on this table_prefix if not exist: * _analysis table will contain export operation's metadata. * _analysis_result will contain all the IamPolicyAnalysisResult. When [partition_key] is specified, both tables will be partitioned based on the [partition_key].\n*   `writeDisposition` (*type:* `String.t`, *default:* `nil`) - Optional. Specifies the action that occurs if the destination table or partition already exists. The following values are supported: * WRITE_TRUNCATE: If the table or partition already exists, BigQuery overwrites the entire table or all the partitions data. * WRITE_APPEND: If the table or partition already exists, BigQuery appends the data to the table or the latest partition. * WRITE_EMPTY: If the table already exists and contains data, an error is returned. The default value is WRITE_APPEND. Each action is atomic and only occurs if BigQuery is able to complete the job successfully. Details are at https://cloud.google.com/bigquery/docs/loading-data-local#appending_to_or_overwriting_a_table_using_a_local_file.","ref":"GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1BigQueryDestination.html#module-attributes"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1BigQueryDestination.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1BigQueryDestination.html#decode/2"},{"type":"type","title":"GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1BigQueryDestination.t/0","doc":"","ref":"GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1BigQueryDestination.html#t:t/0"},{"type":"module","title":"GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1BooleanConstraint","doc":"A `Constraint` that is either enforced or not. For example a constraint `constraints/compute.disableSerialPortAccess`. If it is enforced on a VM instance, serial port connections will not be opened to that instance.","ref":"GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1BooleanConstraint.html"},{"type":"module","title":"Attributes - GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1BooleanConstraint","doc":"","ref":"GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1BooleanConstraint.html#module-attributes"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1BooleanConstraint.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1BooleanConstraint.html#decode/2"},{"type":"type","title":"GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1BooleanConstraint.t/0","doc":"","ref":"GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1BooleanConstraint.html#t:t/0"},{"type":"module","title":"GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1Constraint","doc":"The definition of a constraint.","ref":"GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1Constraint.html"},{"type":"module","title":"Attributes - GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1Constraint","doc":"*   `booleanConstraint` (*type:* `GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1BooleanConstraint.t`, *default:* `nil`) - Defines this constraint as being a BooleanConstraint.\n*   `constraintDefault` (*type:* `String.t`, *default:* `nil`) - The evaluation behavior of this constraint in the absence of 'Policy'.\n*   `description` (*type:* `String.t`, *default:* `nil`) - Detailed description of what this `Constraint` controls as well as how and where it is enforced.\n*   `displayName` (*type:* `String.t`, *default:* `nil`) - The human readable name of the constraint.\n*   `listConstraint` (*type:* `GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1ListConstraint.t`, *default:* `nil`) - Defines this constraint as being a ListConstraint.\n*   `name` (*type:* `String.t`, *default:* `nil`) - The unique name of the constraint. Format of the name should be * `constraints/{constraint_name}` For example, `constraints/compute.disableSerialPortAccess`.","ref":"GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1Constraint.html#module-attributes"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1Constraint.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1Constraint.html#decode/2"},{"type":"type","title":"GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1Constraint.t/0","doc":"","ref":"GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1Constraint.html#t:t/0"},{"type":"module","title":"GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1CustomConstraint","doc":"The definition of a custom constraint.","ref":"GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1CustomConstraint.html"},{"type":"module","title":"Attributes - GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1CustomConstraint","doc":"*   `actionType` (*type:* `String.t`, *default:* `nil`) - Allow or deny type.\n*   `condition` (*type:* `String.t`, *default:* `nil`) - Organization Policy condition/expression. For example: `resource.instanceName.matches(\"[production|test]_.*_(\\d)+\")'` or, `resource.management.auto_upgrade == true`\n*   `description` (*type:* `String.t`, *default:* `nil`) - Detailed information about this custom policy constraint.\n*   `displayName` (*type:* `String.t`, *default:* `nil`) - One line display name for the UI.\n*   `methodTypes` (*type:* `list(String.t)`, *default:* `nil`) - All the operations being applied for this constraint.\n*   `name` (*type:* `String.t`, *default:* `nil`) - Name of the constraint. This is unique within the organization. Format of the name should be * `organizations/{organization_id}/customConstraints/{custom_constraint_id}` Example : \"organizations/123/customConstraints/custom.createOnlyE2TypeVms\"\n*   `resourceTypes` (*type:* `list(String.t)`, *default:* `nil`) - The Resource Instance type on which this policy applies to. Format will be of the form : \"/\" Example: * `compute.googleapis.com/Instance`.","ref":"GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1CustomConstraint.html#module-attributes"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1CustomConstraint.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1CustomConstraint.html#decode/2"},{"type":"type","title":"GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1CustomConstraint.t/0","doc":"","ref":"GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1CustomConstraint.html#t:t/0"},{"type":"module","title":"GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1Edge","doc":"A directional edge.","ref":"GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1Edge.html"},{"type":"module","title":"Attributes - GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1Edge","doc":"*   `sourceNode` (*type:* `String.t`, *default:* `nil`) - The source node of the edge. For example, it could be a full resource name for a resource node or an email of an identity.\n*   `targetNode` (*type:* `String.t`, *default:* `nil`) - The target node of the edge. For example, it could be a full resource name for a resource node or an email of an identity.","ref":"GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1Edge.html#module-attributes"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1Edge.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1Edge.html#decode/2"},{"type":"type","title":"GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1Edge.t/0","doc":"","ref":"GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1Edge.html#t:t/0"},{"type":"module","title":"GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1GcsDestination","doc":"A Cloud Storage location.","ref":"GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1GcsDestination.html"},{"type":"module","title":"Attributes - GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1GcsDestination","doc":"*   `uri` (*type:* `String.t`, *default:* `nil`) - Required. The URI of the Cloud Storage object. It's the same URI that is used by gsutil. Example: \"gs://bucket_name/object_name\". See [Viewing and Editing Object Metadata](https://cloud.google.com/storage/docs/viewing-editing-metadata) for more information. If the specified Cloud Storage object already exists and there is no [hold](https://cloud.google.com/storage/docs/object-holds), it will be overwritten with the analysis result.","ref":"GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1GcsDestination.html#module-attributes"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1GcsDestination.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1GcsDestination.html#decode/2"},{"type":"type","title":"GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1GcsDestination.t/0","doc":"","ref":"GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1GcsDestination.html#t:t/0"},{"type":"module","title":"GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1GovernedContainer","doc":"The organization/folder/project resource governed by organization policies of AnalyzeOrgPolicyGovernedContainersRequest.constraint.","ref":"GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1GovernedContainer.html"},{"type":"module","title":"Attributes - GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1GovernedContainer","doc":"*   `consolidatedPolicy` (*type:* `GoogleApi.CloudAsset.V1.Model.AnalyzerOrgPolicy.t`, *default:* `nil`) - The consolidated organization policy for the analyzed resource. The consolidated organization policy is computed by merging and evaluating AnalyzeOrgPolicyGovernedContainersResponse.GovernedContainer.policy_bundle. The evaluation will respect the organization policy [hierarchy rules](https://cloud.google.com/resource-manager/docs/organization-policy/understanding-hierarchy).\n*   `effectiveTags` (*type:* `list(GoogleApi.CloudAsset.V1.Model.EffectiveTagDetails.t)`, *default:* `nil`) - The effective tags on this resource.\n*   `folders` (*type:* `list(String.t)`, *default:* `nil`) - The folder(s) that this resource belongs to, in the format of folders/{FOLDER_NUMBER}. This field is available when the resource belongs (directly or cascadingly) to one or more folders.\n*   `fullResourceName` (*type:* `String.t`, *default:* `nil`) - The [full resource name] (https://cloud.google.com/asset-inventory/docs/resource-name-format) of an organization/folder/project resource.\n*   `organization` (*type:* `String.t`, *default:* `nil`) - The organization that this resource belongs to, in the format of organizations/{ORGANIZATION_NUMBER}. This field is available when the resource belongs (directly or cascadingly) to an organization.\n*   `parent` (*type:* `String.t`, *default:* `nil`) - The [full resource name] (https://cloud.google.com/asset-inventory/docs/resource-name-format) of the parent of AnalyzeOrgPolicyGovernedContainersResponse.GovernedContainer.full_resource_name.\n*   `policyBundle` (*type:* `list(GoogleApi.CloudAsset.V1.Model.AnalyzerOrgPolicy.t)`, *default:* `nil`) - The ordered list of all organization policies from the AnalyzeOrgPoliciesResponse.OrgPolicyResult.consolidated_policy.attached_resource. to the scope specified in the request. If the constraint is defined with default policy, it will also appear in the list.\n*   `project` (*type:* `String.t`, *default:* `nil`) - The project that this resource belongs to, in the format of projects/{PROJECT_NUMBER}. This field is available when the resource belongs to a project.","ref":"GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1GovernedContainer.html#module-attributes"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1GovernedContainer.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1GovernedContainer.html#decode/2"},{"type":"type","title":"GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1GovernedContainer.t/0","doc":"","ref":"GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1GovernedContainer.html#t:t/0"},{"type":"module","title":"GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1Identity","doc":"An identity under analysis.","ref":"GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1Identity.html"},{"type":"module","title":"Attributes - GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1Identity","doc":"*   `analysisState` (*type:* `GoogleApi.CloudAsset.V1.Model.IamPolicyAnalysisState.t`, *default:* `nil`) - The analysis state of this identity.\n*   `name` (*type:* `String.t`, *default:* `nil`) - The identity of members, formatted as appear in an [IAM policy binding](https://cloud.google.com/iam/reference/rest/v1/Binding). For example, they might be formatted like the following: - user:foo@google.com - group:group1@google.com - serviceAccount:s1@prj1.iam.gserviceaccount.com - projectOwner:some_project_id - domain:google.com - allUsers","ref":"GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1Identity.html#module-attributes"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1Identity.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1Identity.html#decode/2"},{"type":"type","title":"GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1Identity.t/0","doc":"","ref":"GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1Identity.html#t:t/0"},{"type":"module","title":"GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1IdentityList","doc":"The identities and group edges.","ref":"GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1IdentityList.html"},{"type":"module","title":"Attributes - GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1IdentityList","doc":"*   `groupEdges` (*type:* `list(GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1Edge.t)`, *default:* `nil`) - Group identity edges of the graph starting from the binding's group members to any node of the identities. The Edge.source_node contains a group, such as `group:parent@google.com`. The Edge.target_node contains a member of the group, such as `group:child@google.com` or `user:foo@google.com`. This field is present only if the output_group_edges option is enabled in request.\n*   `identities` (*type:* `list(GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1Identity.t)`, *default:* `nil`) - Only the identities that match one of the following conditions will be presented: - The identity_selector, if it is specified in request; - Otherwise, identities reachable from the policy binding's members.","ref":"GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1IdentityList.html#module-attributes"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1IdentityList.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1IdentityList.html#decode/2"},{"type":"type","title":"GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1IdentityList.t/0","doc":"","ref":"GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1IdentityList.html#t:t/0"},{"type":"module","title":"GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1ListConstraint","doc":"A `Constraint` that allows or disallows a list of string values, which are configured by an organization's policy administrator with a `Policy`.","ref":"GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1ListConstraint.html"},{"type":"module","title":"Attributes - GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1ListConstraint","doc":"*   `supportsIn` (*type:* `boolean()`, *default:* `nil`) - Indicates whether values grouped into categories can be used in `Policy.allowed_values` and `Policy.denied_values`. For example, `\"in:Python\"` would match any value in the 'Python' group.\n*   `supportsUnder` (*type:* `boolean()`, *default:* `nil`) - Indicates whether subtrees of Cloud Resource Manager resource hierarchy can be used in `Policy.allowed_values` and `Policy.denied_values`. For example, `\"under:folders/123\"` would match any resource under the 'folders/123' folder.","ref":"GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1ListConstraint.html#module-attributes"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1ListConstraint.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1ListConstraint.html#decode/2"},{"type":"type","title":"GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1ListConstraint.t/0","doc":"","ref":"GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1ListConstraint.html#t:t/0"},{"type":"module","title":"GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1QueryAssetsOutputConfigBigQueryDestination","doc":"BigQuery destination.","ref":"GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1QueryAssetsOutputConfigBigQueryDestination.html"},{"type":"module","title":"Attributes - GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1QueryAssetsOutputConfigBigQueryDestination","doc":"*   `dataset` (*type:* `String.t`, *default:* `nil`) - Required. The BigQuery dataset where the query results will be saved. It has the format of \"projects/{projectId}/datasets/{datasetId}\".\n*   `table` (*type:* `String.t`, *default:* `nil`) - Required. The BigQuery table where the query results will be saved. If this table does not exist, a new table with the given name will be created.\n*   `writeDisposition` (*type:* `String.t`, *default:* `nil`) - Specifies the action that occurs if the destination table or partition already exists. The following values are supported: * WRITE_TRUNCATE: If the table or partition already exists, BigQuery overwrites the entire table or all the partitions data. * WRITE_APPEND: If the table or partition already exists, BigQuery appends the data to the table or the latest partition. * WRITE_EMPTY: If the table already exists and contains data, a 'duplicate' error is returned in the job result. The default value is WRITE_EMPTY.","ref":"GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1QueryAssetsOutputConfigBigQueryDestination.html#module-attributes"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1QueryAssetsOutputConfigBigQueryDestination.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1QueryAssetsOutputConfigBigQueryDestination.html#decode/2"},{"type":"type","title":"GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1QueryAssetsOutputConfigBigQueryDestination.t/0","doc":"","ref":"GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1QueryAssetsOutputConfigBigQueryDestination.html#t:t/0"},{"type":"module","title":"GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1Resource","doc":"A Google Cloud resource under analysis.","ref":"GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1Resource.html"},{"type":"module","title":"Attributes - GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1Resource","doc":"*   `analysisState` (*type:* `GoogleApi.CloudAsset.V1.Model.IamPolicyAnalysisState.t`, *default:* `nil`) - The analysis state of this resource.\n*   `fullResourceName` (*type:* `String.t`, *default:* `nil`) - The [full resource name](https://cloud.google.com/asset-inventory/docs/resource-name-format)","ref":"GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1Resource.html#module-attributes"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1Resource.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1Resource.html#decode/2"},{"type":"type","title":"GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1Resource.t/0","doc":"","ref":"GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1Resource.html#t:t/0"},{"type":"module","title":"GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1Rule","doc":"This rule message is a customized version of the one defined in the Organization Policy system. In addition to the fields defined in the original organization policy, it contains additional field(s) under specific circumstances to support analysis results.","ref":"GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1Rule.html"},{"type":"module","title":"Attributes - GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1Rule","doc":"*   `allowAll` (*type:* `boolean()`, *default:* `nil`) - Setting this to true means that all values are allowed. This field can be set only in Policies for list constraints.\n*   `condition` (*type:* `GoogleApi.CloudAsset.V1.Model.Expr.t`, *default:* `nil`) - The evaluating condition for this rule.\n*   `conditionEvaluation` (*type:* `GoogleApi.CloudAsset.V1.Model.ConditionEvaluation.t`, *default:* `nil`) - The condition evaluation result for this rule. Only populated if it meets all the following criteria: * There is a condition defined for this rule. * This rule is within AnalyzeOrgPolicyGovernedContainersResponse.GovernedContainer.consolidated_policy, or AnalyzeOrgPolicyGovernedAssetsResponse.GovernedAsset.consolidated_policy when the AnalyzeOrgPolicyGovernedAssetsResponse.GovernedAsset has AnalyzeOrgPolicyGovernedAssetsResponse.GovernedAsset.governed_resource.\n*   `denyAll` (*type:* `boolean()`, *default:* `nil`) - Setting this to true means that all values are denied. This field can be set only in Policies for list constraints.\n*   `enforce` (*type:* `boolean()`, *default:* `nil`) - If `true`, then the `Policy` is enforced. If `false`, then any configuration is acceptable. This field can be set only in Policies for boolean constraints.\n*   `values` (*type:* `GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1StringValues.t`, *default:* `nil`) - List of values to be used for this policy rule. This field can be set only in policies for list constraints.","ref":"GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1Rule.html#module-attributes"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1Rule.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1Rule.html#decode/2"},{"type":"type","title":"GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1Rule.t/0","doc":"","ref":"GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1Rule.html#t:t/0"},{"type":"module","title":"GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1StringValues","doc":"The string values for the list constraints.","ref":"GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1StringValues.html"},{"type":"module","title":"Attributes - GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1StringValues","doc":"*   `allowedValues` (*type:* `list(String.t)`, *default:* `nil`) - List of values allowed at this resource.\n*   `deniedValues` (*type:* `list(String.t)`, *default:* `nil`) - List of values denied at this resource.","ref":"GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1StringValues.html#module-attributes"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1StringValues.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1StringValues.html#decode/2"},{"type":"type","title":"GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1StringValues.t/0","doc":"","ref":"GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1StringValues.html#t:t/0"},{"type":"module","title":"GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1p7beta1Asset","doc":"An asset in Google Cloud. An asset can be any resource in the Google Cloud [resource hierarchy](https://cloud.google.com/resource-manager/docs/cloud-platform-resource-hierarchy), a resource outside the Google Cloud resource hierarchy (such as Google Kubernetes Engine clusters and objects), or a policy (e.g. IAM policy). See [Supported asset types](https://cloud.google.com/asset-inventory/docs/supported-asset-types) for more information.","ref":"GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1p7beta1Asset.html"},{"type":"module","title":"Attributes - GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1p7beta1Asset","doc":"*   `accessLevel` (*type:* `GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1AccessLevel.t`, *default:* `nil`) - Please also refer to the [access level user guide](https://cloud.google.com/access-context-manager/docs/overview#access-levels).\n*   `accessPolicy` (*type:* `GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1AccessPolicy.t`, *default:* `nil`) - Please also refer to the [access policy user guide](https://cloud.google.com/access-context-manager/docs/overview#access-policies).\n*   `ancestors` (*type:* `list(String.t)`, *default:* `nil`) - The ancestry path of an asset in Google Cloud [resource hierarchy](https://cloud.google.com/resource-manager/docs/cloud-platform-resource-hierarchy), represented as a list of relative resource names. An ancestry path starts with the closest ancestor in the hierarchy and ends at root. If the asset is a project, folder, or organization, the ancestry path starts from the asset itself. Example: `[\"projects/123456789\", \"folders/5432\", \"organizations/1234\"]`\n*   `assetType` (*type:* `String.t`, *default:* `nil`) - The type of the asset. Example: `compute.googleapis.com/Disk` See [Supported asset types](https://cloud.google.com/asset-inventory/docs/supported-asset-types) for more information.\n*   `iamPolicy` (*type:* `GoogleApi.CloudAsset.V1.Model.Policy.t`, *default:* `nil`) - A representation of the IAM policy set on a Google Cloud resource. There can be a maximum of one IAM policy set on any given resource. In addition, IAM policies inherit their granted access scope from any policies set on parent resources in the resource hierarchy. Therefore, the effectively policy is the union of both the policy set on this resource and each policy set on all of the resource's ancestry resource levels in the hierarchy. See [this topic](https://cloud.google.com/iam/help/allow-policies/inheritance) for more information.\n*   `name` (*type:* `String.t`, *default:* `nil`) - The full name of the asset. Example: `//compute.googleapis.com/projects/my_project_123/zones/zone1/instances/instance1` See [Resource names](https://cloud.google.com/apis/design/resource_names#full_resource_name) for more information.\n*   `orgPolicy` (*type:* `list(GoogleApi.CloudAsset.V1.Model.GoogleCloudOrgpolicyV1Policy.t)`, *default:* `nil`) - A representation of an [organization policy](https://cloud.google.com/resource-manager/docs/organization-policy/overview#organization_policy). There can be more than one organization policy with different constraints set on a given resource.\n*   `relatedAssets` (*type:* `GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1p7beta1RelatedAssets.t`, *default:* `nil`) - The related assets of the asset of one relationship type. One asset only represents one type of relationship.\n*   `resource` (*type:* `GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1p7beta1Resource.t`, *default:* `nil`) - A representation of the resource.\n*   `servicePerimeter` (*type:* `GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1ServicePerimeter.t`, *default:* `nil`) - Please also refer to the [service perimeter user guide](https://cloud.google.com/vpc-service-controls/docs/overview).\n*   `updateTime` (*type:* `DateTime.t`, *default:* `nil`) - The last update timestamp of an asset. update_time is updated when create/update/delete operation is performed.","ref":"GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1p7beta1Asset.html#module-attributes"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1p7beta1Asset.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1p7beta1Asset.html#decode/2"},{"type":"type","title":"GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1p7beta1Asset.t/0","doc":"","ref":"GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1p7beta1Asset.html#t:t/0"},{"type":"module","title":"GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1p7beta1RelatedAsset","doc":"An asset identify in Google Cloud which contains its name, type and ancestors. An asset can be any resource in the Google Cloud [resource hierarchy](https://cloud.google.com/resource-manager/docs/cloud-platform-resource-hierarchy), a resource outside the Google Cloud resource hierarchy (such as Google Kubernetes Engine clusters and objects), or a policy (e.g. IAM policy). See [Supported asset types](https://cloud.google.com/asset-inventory/docs/supported-asset-types) for more information.","ref":"GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1p7beta1RelatedAsset.html"},{"type":"module","title":"Attributes - GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1p7beta1RelatedAsset","doc":"*   `ancestors` (*type:* `list(String.t)`, *default:* `nil`) - The ancestors of an asset in Google Cloud [resource hierarchy](https://cloud.google.com/resource-manager/docs/cloud-platform-resource-hierarchy), represented as a list of relative resource names. An ancestry path starts with the closest ancestor in the hierarchy and ends at root. Example: `[\"projects/123456789\", \"folders/5432\", \"organizations/1234\"]`\n*   `asset` (*type:* `String.t`, *default:* `nil`) - The full name of the asset. Example: `//compute.googleapis.com/projects/my_project_123/zones/zone1/instances/instance1` See [Resource names](https://cloud.google.com/apis/design/resource_names#full_resource_name) for more information.\n*   `assetType` (*type:* `String.t`, *default:* `nil`) - The type of the asset. Example: `compute.googleapis.com/Disk` See [Supported asset types](https://cloud.google.com/asset-inventory/docs/supported-asset-types) for more information.","ref":"GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1p7beta1RelatedAsset.html#module-attributes"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1p7beta1RelatedAsset.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1p7beta1RelatedAsset.html#decode/2"},{"type":"type","title":"GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1p7beta1RelatedAsset.t/0","doc":"","ref":"GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1p7beta1RelatedAsset.html#t:t/0"},{"type":"module","title":"GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1p7beta1RelatedAssets","doc":"The detailed related assets with the `relationship_type`.","ref":"GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1p7beta1RelatedAssets.html"},{"type":"module","title":"Attributes - GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1p7beta1RelatedAssets","doc":"*   `assets` (*type:* `list(GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1p7beta1RelatedAsset.t)`, *default:* `nil`) - The peer resources of the relationship.\n*   `relationshipAttributes` (*type:* `GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1p7beta1RelationshipAttributes.t`, *default:* `nil`) - The detailed relation attributes.","ref":"GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1p7beta1RelatedAssets.html#module-attributes"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1p7beta1RelatedAssets.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1p7beta1RelatedAssets.html#decode/2"},{"type":"type","title":"GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1p7beta1RelatedAssets.t/0","doc":"","ref":"GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1p7beta1RelatedAssets.html#t:t/0"},{"type":"module","title":"GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1p7beta1RelationshipAttributes","doc":"The relationship attributes which include `type`, `source_resource_type`, `target_resource_type` and `action`.","ref":"GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1p7beta1RelationshipAttributes.html"},{"type":"module","title":"Attributes - GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1p7beta1RelationshipAttributes","doc":"*   `action` (*type:* `String.t`, *default:* `nil`) - The detail of the relationship, e.g. `contains`, `attaches`\n*   `sourceResourceType` (*type:* `String.t`, *default:* `nil`) - The source asset type. Example: `compute.googleapis.com/Instance`\n*   `targetResourceType` (*type:* `String.t`, *default:* `nil`) - The target asset type. Example: `compute.googleapis.com/Disk`\n*   `type` (*type:* `String.t`, *default:* `nil`) - The unique identifier of the relationship type. Example: `INSTANCE_TO_INSTANCEGROUP`","ref":"GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1p7beta1RelationshipAttributes.html#module-attributes"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1p7beta1RelationshipAttributes.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1p7beta1RelationshipAttributes.html#decode/2"},{"type":"type","title":"GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1p7beta1RelationshipAttributes.t/0","doc":"","ref":"GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1p7beta1RelationshipAttributes.html#t:t/0"},{"type":"module","title":"GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1p7beta1Resource","doc":"A representation of a Google Cloud resource.","ref":"GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1p7beta1Resource.html"},{"type":"module","title":"Attributes - GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1p7beta1Resource","doc":"*   `data` (*type:* `map()`, *default:* `nil`) - The content of the resource, in which some sensitive fields are removed and may not be present.\n*   `discoveryDocumentUri` (*type:* `String.t`, *default:* `nil`) - The URL of the discovery document containing the resource's JSON schema. Example: `https://www.googleapis.com/discovery/v1/apis/compute/v1/rest` This value is unspecified for resources that do not have an API based on a discovery document, such as Cloud Bigtable.\n*   `discoveryName` (*type:* `String.t`, *default:* `nil`) - The JSON schema name listed in the discovery document. Example: `Project` This value is unspecified for resources that do not have an API based on a discovery document, such as Cloud Bigtable.\n*   `location` (*type:* `String.t`, *default:* `nil`) - The location of the resource in Google Cloud, such as its zone and region. For more information, see https://cloud.google.com/about/locations/.\n*   `parent` (*type:* `String.t`, *default:* `nil`) - The full name of the immediate parent of this resource. See [Resource Names](https://cloud.google.com/apis/design/resource_names#full_resource_name) for more information. For Google Cloud assets, this value is the parent resource defined in the [IAM policy hierarchy](https://cloud.google.com/iam/docs/overview#policy_hierarchy). Example: `//cloudresourcemanager.googleapis.com/projects/my_project_123` For third-party assets, this field may be set differently.\n*   `resourceUrl` (*type:* `String.t`, *default:* `nil`) - The REST URL for accessing the resource. An HTTP `GET` request using this URL returns the resource itself. Example: `https://cloudresourcemanager.googleapis.com/v1/projects/my-project-123` This value is unspecified for resources without a REST API.\n*   `version` (*type:* `String.t`, *default:* `nil`) - The API version. Example: `v1`","ref":"GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1p7beta1Resource.html#module-attributes"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1p7beta1Resource.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1p7beta1Resource.html#decode/2"},{"type":"type","title":"GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1p7beta1Resource.t/0","doc":"","ref":"GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1p7beta1Resource.html#t:t/0"},{"type":"module","title":"GoogleApi.CloudAsset.V1.Model.GoogleCloudOrgpolicyV1BooleanPolicy","doc":"Used in `policy_type` to specify how `boolean_policy` will behave at this resource.","ref":"GoogleApi.CloudAsset.V1.Model.GoogleCloudOrgpolicyV1BooleanPolicy.html"},{"type":"module","title":"Attributes - GoogleApi.CloudAsset.V1.Model.GoogleCloudOrgpolicyV1BooleanPolicy","doc":"*   `enforced` (*type:* `boolean()`, *default:* `nil`) - If `true`, then the `Policy` is enforced. If `false`, then any configuration is acceptable. Suppose you have a `Constraint` `constraints/compute.disableSerialPortAccess` with `constraint_default` set to `ALLOW`. A `Policy` for that `Constraint` exhibits the following behavior: - If the `Policy` at this resource has enforced set to `false`, serial port connection attempts will be allowed. - If the `Policy` at this resource has enforced set to `true`, serial port connection attempts will be refused. - If the `Policy` at this resource is `RestoreDefault`, serial port connection attempts will be allowed. - If no `Policy` is set at this resource or anywhere higher in the resource hierarchy, serial port connection attempts will be allowed. - If no `Policy` is set at this resource, but one exists higher in the resource hierarchy, the behavior is as if the`Policy` were set at this resource. The following examples demonstrate the different possible layerings: Example 1 (nearest `Constraint` wins): `organizations/foo` has a `Policy` with: {enforced: false} `projects/bar` has no `Policy` set. The constraint at `projects/bar` and `organizations/foo` will not be enforced. Example 2 (enforcement gets replaced): `organizations/foo` has a `Policy` with: {enforced: false} `projects/bar` has a `Policy` with: {enforced: true} The constraint at `organizations/foo` is not enforced. The constraint at `projects/bar` is enforced. Example 3 (RestoreDefault): `organizations/foo` has a `Policy` with: {enforced: true} `projects/bar` has a `Policy` with: {RestoreDefault: {}} The constraint at `organizations/foo` is enforced. The constraint at `projects/bar` is not enforced, because `constraint_default` for the `Constraint` is `ALLOW`.","ref":"GoogleApi.CloudAsset.V1.Model.GoogleCloudOrgpolicyV1BooleanPolicy.html#module-attributes"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Model.GoogleCloudOrgpolicyV1BooleanPolicy.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.CloudAsset.V1.Model.GoogleCloudOrgpolicyV1BooleanPolicy.html#decode/2"},{"type":"type","title":"GoogleApi.CloudAsset.V1.Model.GoogleCloudOrgpolicyV1BooleanPolicy.t/0","doc":"","ref":"GoogleApi.CloudAsset.V1.Model.GoogleCloudOrgpolicyV1BooleanPolicy.html#t:t/0"},{"type":"module","title":"GoogleApi.CloudAsset.V1.Model.GoogleCloudOrgpolicyV1ListPolicy","doc":"Used in `policy_type` to specify how `list_policy` behaves at this resource. `ListPolicy` can define specific values and subtrees of Cloud Resource Manager resource hierarchy (`Organizations`, `Folders`, `Projects`) that are allowed or denied by setting the `allowed_values` and `denied_values` fields. This is achieved by using the `under:` and optional `is:` prefixes. The `under:` prefix is used to denote resource subtree values. The `is:` prefix is used to denote specific values, and is required only if the value contains a \":\". Values prefixed with \"is:\" are treated the same as values with no prefix. Ancestry subtrees must be in one of the following formats: - \"projects/\", e.g. \"projects/tokyo-rain-123\" - \"folders/\", e.g. \"folders/1234\" - \"organizations/\", e.g. \"organizations/1234\" The `supports_under` field of the associated `Constraint` defines whether ancestry prefixes can be used. You can set `allowed_values` and `denied_values` in the same `Policy` if `all_values` is `ALL_VALUES_UNSPECIFIED`. `ALLOW` or `DENY` are used to allow or deny all values. If `all_values` is set to either `ALLOW` or `DENY`, `allowed_values` and `denied_values` must be unset.","ref":"GoogleApi.CloudAsset.V1.Model.GoogleCloudOrgpolicyV1ListPolicy.html"},{"type":"module","title":"Attributes - GoogleApi.CloudAsset.V1.Model.GoogleCloudOrgpolicyV1ListPolicy","doc":"*   `allValues` (*type:* `String.t`, *default:* `nil`) - The policy all_values state.\n*   `allowedValues` (*type:* `list(String.t)`, *default:* `nil`) - List of values allowed at this resource. Can only be set if `all_values` is set to `ALL_VALUES_UNSPECIFIED`.\n*   `deniedValues` (*type:* `list(String.t)`, *default:* `nil`) - List of values denied at this resource. Can only be set if `all_values` is set to `ALL_VALUES_UNSPECIFIED`.\n*   `inheritFromParent` (*type:* `boolean()`, *default:* `nil`) - Determines the inheritance behavior for this `Policy`. By default, a `ListPolicy` set at a resource supersedes any `Policy` set anywhere up the resource hierarchy. However, if `inherit_from_parent` is set to `true`, then the values from the effective `Policy` of the parent resource are inherited, meaning the values set in this `Policy` are added to the values inherited up the hierarchy. Setting `Policy` hierarchies that inherit both allowed values and denied values isn't recommended in most circumstances to keep the configuration simple and understandable. However, it is possible to set a `Policy` with `allowed_values` set that inherits a `Policy` with `denied_values` set. In this case, the values that are allowed must be in `allowed_values` and not present in `denied_values`. For example, suppose you have a `Constraint` `constraints/serviceuser.services`, which has a `constraint_type` of `list_constraint`, and with `constraint_default` set to `ALLOW`. Suppose that at the Organization level, a `Policy` is applied that restricts the allowed API activations to {`E1`, `E2`}. Then, if a `Policy` is applied to a project below the Organization that has `inherit_from_parent` set to `false` and field all_values set to DENY, then an attempt to activate any API will be denied. The following examples demonstrate different possible layerings for `projects/bar` parented by `organizations/foo`: Example 1 (no inherited values): `organizations/foo` has a `Policy` with values: {allowed_values: \"E1\" allowed_values:\"E2\"} `projects/bar` has `inherit_from_parent` `false` and values: {allowed_values: \"E3\" allowed_values: \"E4\"} The accepted values at `organizations/foo` are `E1`, `E2`. The accepted values at `projects/bar` are `E3`, and `E4`. Example 2 (inherited values): `organizations/foo` has a `Policy` with values: {allowed_values: \"E1\" allowed_values:\"E2\"} `projects/bar` has a `Policy` with values: {value: \"E3\" value: \"E4\" inherit_from_parent: true} The accepted values at `organizations/foo` are `E1`, `E2`. The accepted values at `projects/bar` are `E1`, `E2`, `E3`, and `E4`. Example 3 (inheriting both allowed and denied values): `organizations/foo` has a `Policy` with values: {allowed_values: \"E1\" allowed_values: \"E2\"} `projects/bar` has a `Policy` with: {denied_values: \"E1\"} The accepted values at `organizations/foo` are `E1`, `E2`. The value accepted at `projects/bar` is `E2`. Example 4 (RestoreDefault): `organizations/foo` has a `Policy` with values: {allowed_values: \"E1\" allowed_values:\"E2\"} `projects/bar` has a `Policy` with values: {RestoreDefault: {}} The accepted values at `organizations/foo` are `E1`, `E2`. The accepted values at `projects/bar` are either all or none depending on the value of `constraint_default` (if `ALLOW`, all; if `DENY`, none). Example 5 (no policy inherits parent policy): `organizations/foo` has no `Policy` set. `projects/bar` has no `Policy` set. The accepted values at both levels are either all or none depending on the value of `constraint_default` (if `ALLOW`, all; if `DENY`, none). Example 6 (ListConstraint allowing all): `organizations/foo` has a `Policy` with values: {allowed_values: \"E1\" allowed_values: \"E2\"} `projects/bar` has a `Policy` with: {all: ALLOW} The accepted values at `organizations/foo` are `E1`, E2`. Any value is accepted at `projects/bar`. Example 7 (ListConstraint allowing none): `organizations/foo` has a `Policy` with values: {allowed_values: \"E1\" allowed_values: \"E2\"} `projects/bar` has a `Policy` with: {all: DENY} The accepted values at `organizations/foo` are `E1`, E2`. No value is accepted at `projects/bar`. Example 10 (allowed and denied subtrees of Resource Manager hierarchy): Given the following resource hierarchy O1->{F1, F2}; F1->{P1}; F2->{P2, P3}, `organizations/foo` has a `Policy` with values: {allowed_values: \"under:organizations/O1\"} `projects/bar` has a `Policy` with: {allowed_values: \"under:projects/P3\"} {denied_values: \"under:folders/F2\"} The accepted values at `organizations/foo` are `organizations/O1`, `folders/F1`, `folders/F2`, `projects/P1`, `projects/P2`, `projects/P3`. The accepted values at `projects/bar` are `organizations/O1`, `folders/F1`, `projects/P1`.\n*   `suggestedValue` (*type:* `String.t`, *default:* `nil`) - Optional. The Google Cloud Console will try to default to a configuration that matches the value specified in this `Policy`. If `suggested_value` is not set, it will inherit the value specified higher in the hierarchy, unless `inherit_from_parent` is `false`.","ref":"GoogleApi.CloudAsset.V1.Model.GoogleCloudOrgpolicyV1ListPolicy.html#module-attributes"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Model.GoogleCloudOrgpolicyV1ListPolicy.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.CloudAsset.V1.Model.GoogleCloudOrgpolicyV1ListPolicy.html#decode/2"},{"type":"type","title":"GoogleApi.CloudAsset.V1.Model.GoogleCloudOrgpolicyV1ListPolicy.t/0","doc":"","ref":"GoogleApi.CloudAsset.V1.Model.GoogleCloudOrgpolicyV1ListPolicy.html#t:t/0"},{"type":"module","title":"GoogleApi.CloudAsset.V1.Model.GoogleCloudOrgpolicyV1Policy","doc":"Defines a Cloud Organization `Policy` which is used to specify `Constraints` for configurations of Cloud Platform resources.","ref":"GoogleApi.CloudAsset.V1.Model.GoogleCloudOrgpolicyV1Policy.html"},{"type":"module","title":"Attributes - GoogleApi.CloudAsset.V1.Model.GoogleCloudOrgpolicyV1Policy","doc":"*   `booleanPolicy` (*type:* `GoogleApi.CloudAsset.V1.Model.GoogleCloudOrgpolicyV1BooleanPolicy.t`, *default:* `nil`) - For boolean `Constraints`, whether to enforce the `Constraint` or not.\n*   `constraint` (*type:* `String.t`, *default:* `nil`) - The name of the `Constraint` the `Policy` is configuring, for example, `constraints/serviceuser.services`. A [list of available constraints](/resource-manager/docs/organization-policy/org-policy-constraints) is available. Immutable after creation.\n*   `etag` (*type:* `String.t`, *default:* `nil`) - An opaque tag indicating the current version of the `Policy`, used for concurrency control. When the `Policy` is returned from either a `GetPolicy` or a `ListOrgPolicy` request, this `etag` indicates the version of the current `Policy` to use when executing a read-modify-write loop. When the `Policy` is returned from a `GetEffectivePolicy` request, the `etag` will be unset. When the `Policy` is used in a `SetOrgPolicy` method, use the `etag` value that was returned from a `GetOrgPolicy` request as part of a read-modify-write loop for concurrency control. Not setting the `etag`in a `SetOrgPolicy` request will result in an unconditional write of the `Policy`.\n*   `listPolicy` (*type:* `GoogleApi.CloudAsset.V1.Model.GoogleCloudOrgpolicyV1ListPolicy.t`, *default:* `nil`) - List of values either allowed or disallowed.\n*   `restoreDefault` (*type:* `GoogleApi.CloudAsset.V1.Model.GoogleCloudOrgpolicyV1RestoreDefault.t`, *default:* `nil`) - Restores the default behavior of the constraint; independent of `Constraint` type.\n*   `updateTime` (*type:* `DateTime.t`, *default:* `nil`) - The time stamp the `Policy` was previously updated. This is set by the server, not specified by the caller, and represents the last time a call to `SetOrgPolicy` was made for that `Policy`. Any value set by the client will be ignored.\n*   `version` (*type:* `integer()`, *default:* `nil`) - Version of the `Policy`. Default version is 0;","ref":"GoogleApi.CloudAsset.V1.Model.GoogleCloudOrgpolicyV1Policy.html#module-attributes"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Model.GoogleCloudOrgpolicyV1Policy.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.CloudAsset.V1.Model.GoogleCloudOrgpolicyV1Policy.html#decode/2"},{"type":"type","title":"GoogleApi.CloudAsset.V1.Model.GoogleCloudOrgpolicyV1Policy.t/0","doc":"","ref":"GoogleApi.CloudAsset.V1.Model.GoogleCloudOrgpolicyV1Policy.html#t:t/0"},{"type":"module","title":"GoogleApi.CloudAsset.V1.Model.GoogleCloudOrgpolicyV1RestoreDefault","doc":"Ignores policies set above this resource and restores the `constraint_default` enforcement behavior of the specific `Constraint` at this resource. Suppose that `constraint_default` is set to `ALLOW` for the `Constraint` `constraints/serviceuser.services`. Suppose that organization foo.com sets a `Policy` at their Organization resource node that restricts the allowed service activations to deny all service activations. They could then set a `Policy` with the `policy_type` `restore_default` on several experimental projects, restoring the `constraint_default` enforcement of the `Constraint` for only those projects, allowing those projects to have all services activated.","ref":"GoogleApi.CloudAsset.V1.Model.GoogleCloudOrgpolicyV1RestoreDefault.html"},{"type":"module","title":"Attributes - GoogleApi.CloudAsset.V1.Model.GoogleCloudOrgpolicyV1RestoreDefault","doc":"","ref":"GoogleApi.CloudAsset.V1.Model.GoogleCloudOrgpolicyV1RestoreDefault.html#module-attributes"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Model.GoogleCloudOrgpolicyV1RestoreDefault.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.CloudAsset.V1.Model.GoogleCloudOrgpolicyV1RestoreDefault.html#decode/2"},{"type":"type","title":"GoogleApi.CloudAsset.V1.Model.GoogleCloudOrgpolicyV1RestoreDefault.t/0","doc":"","ref":"GoogleApi.CloudAsset.V1.Model.GoogleCloudOrgpolicyV1RestoreDefault.html#t:t/0"},{"type":"module","title":"GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1AccessLevel","doc":"An `AccessLevel` is a label that can be applied to requests to Google Cloud services, along with a list of requirements necessary for the label to be applied.","ref":"GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1AccessLevel.html"},{"type":"module","title":"Attributes - GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1AccessLevel","doc":"*   `basic` (*type:* `GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1BasicLevel.t`, *default:* `nil`) - A `BasicLevel` composed of `Conditions`.\n*   `custom` (*type:* `GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1CustomLevel.t`, *default:* `nil`) - A `CustomLevel` written in the Common Expression Language.\n*   `description` (*type:* `String.t`, *default:* `nil`) - Description of the `AccessLevel` and its use. Does not affect behavior.\n*   `name` (*type:* `String.t`, *default:* `nil`) - Identifier. Resource name for the `AccessLevel`. Format: `accessPolicies/{access_policy}/accessLevels/{access_level}`. The `access_level` component must begin with a letter, followed by alphanumeric characters or `_`. Its maximum length is 50 characters. After you create an `AccessLevel`, you cannot change its `name`.\n*   `title` (*type:* `String.t`, *default:* `nil`) - Human readable title. Must be unique within the Policy.","ref":"GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1AccessLevel.html#module-attributes"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1AccessLevel.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1AccessLevel.html#decode/2"},{"type":"type","title":"GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1AccessLevel.t/0","doc":"","ref":"GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1AccessLevel.html#t:t/0"},{"type":"module","title":"GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1AccessPolicy","doc":"`AccessPolicy` is a container for `AccessLevels` (which define the necessary attributes to use Google Cloud services) and `ServicePerimeters` (which define regions of services able to freely pass data within a perimeter). An access policy is globally visible within an organization, and the restrictions it specifies apply to all projects within an organization.","ref":"GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1AccessPolicy.html"},{"type":"module","title":"Attributes - GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1AccessPolicy","doc":"*   `etag` (*type:* `String.t`, *default:* `nil`) - Output only. An opaque identifier for the current version of the `AccessPolicy`. This will always be a strongly validated etag, meaning that two Access Policies will be identical if and only if their etags are identical. Clients should not expect this to be in any specific format.\n*   `name` (*type:* `String.t`, *default:* `nil`) - Output only. Identifier. Resource name of the `AccessPolicy`. Format: `accessPolicies/{access_policy}`\n*   `parent` (*type:* `String.t`, *default:* `nil`) - Required. The parent of this `AccessPolicy` in the Cloud Resource Hierarchy. Currently immutable once created. Format: `organizations/{organization_id}`\n*   `scopes` (*type:* `list(String.t)`, *default:* `nil`) - The scopes of the AccessPolicy. Scopes define which resources a policy can restrict and where its resources can be referenced. For example, policy A with `scopes=[\"folders/123\"]` has the following behavior: - ServicePerimeter can only restrict projects within `folders/123`. - ServicePerimeter within policy A can only reference access levels defined within policy A. - Only one policy can include a given scope; thus, attempting to create a second policy which includes `folders/123` will result in an error. If no scopes are provided, then any resource within the organization can be restricted. Scopes cannot be modified after a policy is created. Policies can only have a single scope. Format: list of `folders/{folder_number}` or `projects/{project_number}`\n*   `title` (*type:* `String.t`, *default:* `nil`) - Required. Human readable title. Does not affect behavior.","ref":"GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1AccessPolicy.html#module-attributes"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1AccessPolicy.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1AccessPolicy.html#decode/2"},{"type":"type","title":"GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1AccessPolicy.t/0","doc":"","ref":"GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1AccessPolicy.html#t:t/0"},{"type":"module","title":"GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1ApiOperation","doc":"Identification for an API Operation.","ref":"GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1ApiOperation.html"},{"type":"module","title":"Attributes - GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1ApiOperation","doc":"*   `methodSelectors` (*type:* `list(GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1MethodSelector.t)`, *default:* `nil`) - API methods or permissions to allow. Method or permission must belong to the service specified by `service_name` field. A single MethodSelector entry with `*` specified for the `method` field will allow all methods AND permissions for the service specified in `service_name`.\n*   `serviceName` (*type:* `String.t`, *default:* `nil`) - The name of the API whose methods or permissions the IngressPolicy or EgressPolicy want to allow. A single ApiOperation with `service_name` field set to `*` will allow all methods AND permissions for all services.","ref":"GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1ApiOperation.html#module-attributes"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1ApiOperation.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1ApiOperation.html#decode/2"},{"type":"type","title":"GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1ApiOperation.t/0","doc":"","ref":"GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1ApiOperation.html#t:t/0"},{"type":"module","title":"GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1BasicLevel","doc":"`BasicLevel` is an `AccessLevel` using a set of recommended features.","ref":"GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1BasicLevel.html"},{"type":"module","title":"Attributes - GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1BasicLevel","doc":"*   `combiningFunction` (*type:* `String.t`, *default:* `nil`) - How the `conditions` list should be combined to determine if a request is granted this `AccessLevel`. If AND is used, each `Condition` in `conditions` must be satisfied for the `AccessLevel` to be applied. If OR is used, at least one `Condition` in `conditions` must be satisfied for the `AccessLevel` to be applied. Default behavior is AND.\n*   `conditions` (*type:* `list(GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1Condition.t)`, *default:* `nil`) - Required. A list of requirements for the `AccessLevel` to be granted.","ref":"GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1BasicLevel.html#module-attributes"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1BasicLevel.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1BasicLevel.html#decode/2"},{"type":"type","title":"GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1BasicLevel.t/0","doc":"","ref":"GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1BasicLevel.html#t:t/0"},{"type":"module","title":"GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1Condition","doc":"A condition necessary for an `AccessLevel` to be granted. The Condition is an AND over its fields. So a Condition is true if: 1) the request IP is from one of the listed subnetworks AND 2) the originating device complies with the listed device policy AND 3) all listed access levels are granted AND 4) the request was sent at a time allowed by the DateTimeRestriction.","ref":"GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1Condition.html"},{"type":"module","title":"Attributes - GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1Condition","doc":"*   `devicePolicy` (*type:* `GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1DevicePolicy.t`, *default:* `nil`) - Device specific restrictions, all restrictions must hold for the Condition to be true. If not specified, all devices are allowed.\n*   `ipSubnetworks` (*type:* `list(String.t)`, *default:* `nil`) - CIDR block IP subnetwork specification. May be IPv4 or IPv6. Note that for a CIDR IP address block, the specified IP address portion must be properly truncated (i.e. all the host bits must be zero) or the input is considered malformed. For example, \"192.0.2.0/24\" is accepted but \"192.0.2.1/24\" is not. Similarly, for IPv6, \"2001:db8::/32\" is accepted whereas \"2001:db8::1/32\" is not. The originating IP of a request must be in one of the listed subnets in order for this Condition to be true. If empty, all IP addresses are allowed.\n*   `members` (*type:* `list(String.t)`, *default:* `nil`) - The request must be made by one of the provided user or service accounts. Groups are not supported. Syntax: `user:{emailid}` `serviceAccount:{emailid}` If not specified, a request may come from any user.\n*   `negate` (*type:* `boolean()`, *default:* `nil`) - Whether to negate the Condition. If true, the Condition becomes a NAND over its non-empty fields. Any non-empty field criteria evaluating to false will result in the Condition to be satisfied. Defaults to false.\n*   `regions` (*type:* `list(String.t)`, *default:* `nil`) - The request must originate from one of the provided countries/regions. Must be valid ISO 3166-1 alpha-2 codes.\n*   `requiredAccessLevels` (*type:* `list(String.t)`, *default:* `nil`) - A list of other access levels defined in the same `Policy`, referenced by resource name. Referencing an `AccessLevel` which does not exist is an error. All access levels listed must be granted for the Condition to be true. Example: \"`accessPolicies/MY_POLICY/accessLevels/LEVEL_NAME\"`\n*   `vpcNetworkSources` (*type:* `list(GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1VpcNetworkSource.t)`, *default:* `nil`) - The request must originate from one of the provided VPC networks in Google Cloud. Cannot specify this field together with `ip_subnetworks`.","ref":"GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1Condition.html#module-attributes"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1Condition.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1Condition.html#decode/2"},{"type":"type","title":"GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1Condition.t/0","doc":"","ref":"GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1Condition.html#t:t/0"},{"type":"module","title":"GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1CustomLevel","doc":"`CustomLevel` is an `AccessLevel` using the Cloud Common Expression Language to represent the necessary conditions for the level to apply to a request. See CEL spec at: https://github.com/google/cel-spec","ref":"GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1CustomLevel.html"},{"type":"module","title":"Attributes - GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1CustomLevel","doc":"*   `expr` (*type:* `GoogleApi.CloudAsset.V1.Model.Expr.t`, *default:* `nil`) - Required. A Cloud CEL expression evaluating to a boolean.","ref":"GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1CustomLevel.html#module-attributes"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1CustomLevel.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1CustomLevel.html#decode/2"},{"type":"type","title":"GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1CustomLevel.t/0","doc":"","ref":"GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1CustomLevel.html#t:t/0"},{"type":"module","title":"GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1DevicePolicy","doc":"`DevicePolicy` specifies device specific restrictions necessary to acquire a given access level. A `DevicePolicy` specifies requirements for requests from devices to be granted access levels, it does not do any enforcement on the device. `DevicePolicy` acts as an AND over all specified fields, and each repeated field is an OR over its elements. Any unset fields are ignored. For example, if the proto is { os_type : DESKTOP_WINDOWS, os_type : DESKTOP_LINUX, encryption_status: ENCRYPTED}, then the DevicePolicy will be true for requests originating from encrypted Linux desktops and encrypted Windows desktops.","ref":"GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1DevicePolicy.html"},{"type":"module","title":"Attributes - GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1DevicePolicy","doc":"*   `allowedDeviceManagementLevels` (*type:* `list(String.t)`, *default:* `nil`) - Allowed device management levels, an empty list allows all management levels.\n*   `allowedEncryptionStatuses` (*type:* `list(String.t)`, *default:* `nil`) - Allowed encryptions statuses, an empty list allows all statuses.\n*   `osConstraints` (*type:* `list(GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1OsConstraint.t)`, *default:* `nil`) - Allowed OS versions, an empty list allows all types and all versions.\n*   `requireAdminApproval` (*type:* `boolean()`, *default:* `nil`) - Whether the device needs to be approved by the customer admin.\n*   `requireCorpOwned` (*type:* `boolean()`, *default:* `nil`) - Whether the device needs to be corp owned.\n*   `requireScreenlock` (*type:* `boolean()`, *default:* `nil`) - Whether or not screenlock is required for the DevicePolicy to be true. Defaults to `false`.","ref":"GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1DevicePolicy.html#module-attributes"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1DevicePolicy.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1DevicePolicy.html#decode/2"},{"type":"type","title":"GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1DevicePolicy.t/0","doc":"","ref":"GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1DevicePolicy.html#t:t/0"},{"type":"module","title":"GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1EgressFrom","doc":"Defines the conditions under which an EgressPolicy matches a request. Conditions based on information about the source of the request. Note that if the destination of the request is also protected by a ServicePerimeter, then that ServicePerimeter must have an IngressPolicy which allows access in order for this request to succeed.","ref":"GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1EgressFrom.html"},{"type":"module","title":"Attributes - GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1EgressFrom","doc":"*   `identities` (*type:* `list(String.t)`, *default:* `nil`) - A list of identities that are allowed access through [EgressPolicy]. Identities can be an individual user, service account, Google group, or third-party identity. The `v1` identities that have the prefix `user`, `group`, `serviceAccount`, `principal`, and `principalSet` in https://cloud.google.com/iam/docs/principal-identifiers#v1 are supported.\n*   `identityType` (*type:* `String.t`, *default:* `nil`) - Specifies the type of identities that are allowed access to outside the perimeter. If left unspecified, then members of `identities` field will be allowed access.\n*   `sourceRestriction` (*type:* `String.t`, *default:* `nil`) - Whether to enforce traffic restrictions based on `sources` field. If the `sources` fields is non-empty, then this field must be set to `SOURCE_RESTRICTION_ENABLED`.\n*   `sources` (*type:* `list(GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1EgressSource.t)`, *default:* `nil`) - Sources that this EgressPolicy authorizes access from. If this field is not empty, then `source_restriction` must be set to `SOURCE_RESTRICTION_ENABLED`.","ref":"GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1EgressFrom.html#module-attributes"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1EgressFrom.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1EgressFrom.html#decode/2"},{"type":"type","title":"GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1EgressFrom.t/0","doc":"","ref":"GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1EgressFrom.html#t:t/0"},{"type":"module","title":"GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1EgressPolicy","doc":"Policy for egress from perimeter. EgressPolicies match requests based on `egress_from` and `egress_to` stanzas. For an EgressPolicy to match, both `egress_from` and `egress_to` stanzas must be matched. If an EgressPolicy matches a request, the request is allowed to span the ServicePerimeter boundary. For example, an EgressPolicy can be used to allow VMs on networks within the ServicePerimeter to access a defined set of projects outside the perimeter in certain contexts (e.g. to read data from a Cloud Storage bucket or query against a BigQuery dataset). EgressPolicies are concerned with the *resources* that a request relates as well as the API services and API actions being used. They do not related to the direction of data movement. More detailed documentation for this concept can be found in the descriptions of EgressFrom and EgressTo.","ref":"GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1EgressPolicy.html"},{"type":"module","title":"Attributes - GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1EgressPolicy","doc":"*   `egressFrom` (*type:* `GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1EgressFrom.t`, *default:* `nil`) - Defines conditions on the source of a request causing this EgressPolicy to apply.\n*   `egressTo` (*type:* `GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1EgressTo.t`, *default:* `nil`) - Defines the conditions on the ApiOperation and destination resources that cause this EgressPolicy to apply.","ref":"GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1EgressPolicy.html#module-attributes"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1EgressPolicy.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1EgressPolicy.html#decode/2"},{"type":"type","title":"GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1EgressPolicy.t/0","doc":"","ref":"GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1EgressPolicy.html#t:t/0"},{"type":"module","title":"GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1EgressSource","doc":"The source that EgressPolicy authorizes access from inside the ServicePerimeter to somewhere outside the ServicePerimeter boundaries.","ref":"GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1EgressSource.html"},{"type":"module","title":"Attributes - GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1EgressSource","doc":"*   `accessLevel` (*type:* `String.t`, *default:* `nil`) - An AccessLevel resource name that allows protected resources inside the ServicePerimeters to access outside the ServicePerimeter boundaries. AccessLevels listed must be in the same policy as this ServicePerimeter. Referencing a nonexistent AccessLevel will cause an error. If an AccessLevel name is not specified, only resources within the perimeter can be accessed through Google Cloud calls with request origins within the perimeter. Example: `accessPolicies/MY_POLICY/accessLevels/MY_LEVEL`. If a single `*` is specified for `access_level`, then all EgressSources will be allowed.","ref":"GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1EgressSource.html#module-attributes"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1EgressSource.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1EgressSource.html#decode/2"},{"type":"type","title":"GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1EgressSource.t/0","doc":"","ref":"GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1EgressSource.html#t:t/0"},{"type":"module","title":"GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1EgressTo","doc":"Defines the conditions under which an EgressPolicy matches a request. Conditions are based on information about the ApiOperation intended to be performed on the `resources` specified. Note that if the destination of the request is also protected by a ServicePerimeter, then that ServicePerimeter must have an IngressPolicy which allows access in order for this request to succeed. The request must match `operations` AND `resources` fields in order to be allowed egress out of the perimeter.","ref":"GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1EgressTo.html"},{"type":"module","title":"Attributes - GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1EgressTo","doc":"*   `externalResources` (*type:* `list(String.t)`, *default:* `nil`) - A list of external resources that are allowed to be accessed. Only AWS and Azure resources are supported. For Amazon S3, the supported formats are s3://BUCKET_NAME, s3a://BUCKET_NAME, and s3n://BUCKET_NAME. For Azure Storage, the supported format is azure://myaccount.blob.core.windows.net/CONTAINER_NAME. A request matches if it contains an external resource in this list (Example: s3://bucket/path). Currently '*' is not allowed.\n*   `operations` (*type:* `list(GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1ApiOperation.t)`, *default:* `nil`) - A list of ApiOperations allowed to be performed by the sources specified in the corresponding EgressFrom. A request matches if it uses an operation/service in this list.\n*   `resources` (*type:* `list(String.t)`, *default:* `nil`) - A list of resources, currently only projects in the form `projects/`, that are allowed to be accessed by sources defined in the corresponding EgressFrom. A request matches if it contains a resource in this list. If `*` is specified for `resources`, then this EgressTo rule will authorize access to all resources outside the perimeter.","ref":"GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1EgressTo.html#module-attributes"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1EgressTo.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1EgressTo.html#decode/2"},{"type":"type","title":"GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1EgressTo.t/0","doc":"","ref":"GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1EgressTo.html#t:t/0"},{"type":"module","title":"GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1IngressFrom","doc":"Defines the conditions under which an IngressPolicy matches a request. Conditions are based on information about the source of the request. The request must satisfy what is defined in `sources` AND identity related fields in order to match.","ref":"GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1IngressFrom.html"},{"type":"module","title":"Attributes - GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1IngressFrom","doc":"*   `identities` (*type:* `list(String.t)`, *default:* `nil`) - A list of identities that are allowed access through [IngressPolicy]. Identities can be an individual user, service account, Google group, or third-party identity. The `v1` identities that have the prefix `user`, `group`, `serviceAccount`, `principal`, and `principalSet` in https://cloud.google.com/iam/docs/principal-identifiers#v1 are supported.\n*   `identityType` (*type:* `String.t`, *default:* `nil`) - Specifies the type of identities that are allowed access from outside the perimeter. If left unspecified, then members of `identities` field will be allowed access.\n*   `sources` (*type:* `list(GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1IngressSource.t)`, *default:* `nil`) - Sources that this IngressPolicy authorizes access from.","ref":"GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1IngressFrom.html#module-attributes"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1IngressFrom.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1IngressFrom.html#decode/2"},{"type":"type","title":"GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1IngressFrom.t/0","doc":"","ref":"GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1IngressFrom.html#t:t/0"},{"type":"module","title":"GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1IngressPolicy","doc":"Policy for ingress into ServicePerimeter. IngressPolicies match requests based on `ingress_from` and `ingress_to` stanzas. For an ingress policy to match, both the `ingress_from` and `ingress_to` stanzas must be matched. If an IngressPolicy matches a request, the request is allowed through the perimeter boundary from outside the perimeter. For example, access from the internet can be allowed either based on an AccessLevel or, for traffic hosted on Google Cloud, the project of the source network. For access from private networks, using the project of the hosting network is required. Individual ingress policies can be limited by restricting which services and/or actions they match using the `ingress_to` field.","ref":"GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1IngressPolicy.html"},{"type":"module","title":"Attributes - GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1IngressPolicy","doc":"*   `ingressFrom` (*type:* `GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1IngressFrom.t`, *default:* `nil`) - Defines the conditions on the source of a request causing this IngressPolicy to apply.\n*   `ingressTo` (*type:* `GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1IngressTo.t`, *default:* `nil`) - Defines the conditions on the ApiOperation and request destination that cause this IngressPolicy to apply.","ref":"GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1IngressPolicy.html#module-attributes"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1IngressPolicy.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1IngressPolicy.html#decode/2"},{"type":"type","title":"GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1IngressPolicy.t/0","doc":"","ref":"GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1IngressPolicy.html#t:t/0"},{"type":"module","title":"GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1IngressSource","doc":"The source that IngressPolicy authorizes access from.","ref":"GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1IngressSource.html"},{"type":"module","title":"Attributes - GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1IngressSource","doc":"*   `accessLevel` (*type:* `String.t`, *default:* `nil`) - An AccessLevel resource name that allow resources within the ServicePerimeters to be accessed from the internet. AccessLevels listed must be in the same policy as this ServicePerimeter. Referencing a nonexistent AccessLevel will cause an error. If no AccessLevel names are listed, resources within the perimeter can only be accessed via Google Cloud calls with request origins within the perimeter. Example: `accessPolicies/MY_POLICY/accessLevels/MY_LEVEL`. If a single `*` is specified for `access_level`, then all IngressSources will be allowed.\n*   `resource` (*type:* `String.t`, *default:* `nil`) - A Google Cloud resource that is allowed to ingress the perimeter. Requests from these resources will be allowed to access perimeter data. Currently only projects and VPCs are allowed. Project format: `projects/{project_number}` VPC network format: `//compute.googleapis.com/projects/{PROJECT_ID}/global/networks/{NAME}`. The project may be in any Google Cloud organization, not just the organization that the perimeter is defined in. `*` is not allowed, the case of allowing all Google Cloud resources only is not supported.","ref":"GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1IngressSource.html#module-attributes"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1IngressSource.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1IngressSource.html#decode/2"},{"type":"type","title":"GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1IngressSource.t/0","doc":"","ref":"GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1IngressSource.html#t:t/0"},{"type":"module","title":"GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1IngressTo","doc":"Defines the conditions under which an IngressPolicy matches a request. Conditions are based on information about the ApiOperation intended to be performed on the target resource of the request. The request must satisfy what is defined in `operations` AND `resources` in order to match.","ref":"GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1IngressTo.html"},{"type":"module","title":"Attributes - GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1IngressTo","doc":"*   `operations` (*type:* `list(GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1ApiOperation.t)`, *default:* `nil`) - A list of ApiOperations allowed to be performed by the sources specified in corresponding IngressFrom in this ServicePerimeter.\n*   `resources` (*type:* `list(String.t)`, *default:* `nil`) - A list of resources, currently only projects in the form `projects/`, protected by this ServicePerimeter that are allowed to be accessed by sources defined in the corresponding IngressFrom. If a single `*` is specified, then access to all resources inside the perimeter are allowed.","ref":"GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1IngressTo.html#module-attributes"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1IngressTo.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1IngressTo.html#decode/2"},{"type":"type","title":"GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1IngressTo.t/0","doc":"","ref":"GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1IngressTo.html#t:t/0"},{"type":"module","title":"GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1MethodSelector","doc":"An allowed method or permission of a service specified in ApiOperation.","ref":"GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1MethodSelector.html"},{"type":"module","title":"Attributes - GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1MethodSelector","doc":"*   `method` (*type:* `String.t`, *default:* `nil`) - A valid method name for the corresponding `service_name` in ApiOperation. If `*` is used as the value for the `method`, then ALL methods and permissions are allowed.\n*   `permission` (*type:* `String.t`, *default:* `nil`) - A valid Cloud IAM permission for the corresponding `service_name` in ApiOperation.","ref":"GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1MethodSelector.html#module-attributes"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1MethodSelector.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1MethodSelector.html#decode/2"},{"type":"type","title":"GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1MethodSelector.t/0","doc":"","ref":"GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1MethodSelector.html#t:t/0"},{"type":"module","title":"GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1OsConstraint","doc":"A restriction on the OS type and version of devices making requests.","ref":"GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1OsConstraint.html"},{"type":"module","title":"Attributes - GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1OsConstraint","doc":"*   `minimumVersion` (*type:* `String.t`, *default:* `nil`) - The minimum allowed OS version. If not set, any version of this OS satisfies the constraint. Format: `\"major.minor.patch\"`. Examples: `\"10.5.301\"`, `\"9.2.1\"`.\n*   `osType` (*type:* `String.t`, *default:* `nil`) - Required. The allowed OS type.\n*   `requireVerifiedChromeOs` (*type:* `boolean()`, *default:* `nil`) - Only allows requests from devices with a verified Chrome OS. Verifications includes requirements that the device is enterprise-managed, conformant to domain policies, and the caller has permission to call the API targeted by the request.","ref":"GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1OsConstraint.html#module-attributes"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1OsConstraint.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1OsConstraint.html#decode/2"},{"type":"type","title":"GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1OsConstraint.t/0","doc":"","ref":"GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1OsConstraint.html#t:t/0"},{"type":"module","title":"GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1ServicePerimeter","doc":"`ServicePerimeter` describes a set of Google Cloud resources which can freely import and export data amongst themselves, but not export outside of the `ServicePerimeter`. If a request with a source within this `ServicePerimeter` has a target outside of the `ServicePerimeter`, the request will be blocked. Otherwise the request is allowed. There are two types of Service Perimeter - Regular and Bridge. Regular Service Perimeters cannot overlap, a single Google Cloud project or VPC network can only belong to a single regular Service Perimeter. Service Perimeter Bridges can contain only Google Cloud projects as members, a single Google Cloud project may belong to multiple Service Perimeter Bridges.","ref":"GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1ServicePerimeter.html"},{"type":"module","title":"Attributes - GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1ServicePerimeter","doc":"*   `description` (*type:* `String.t`, *default:* `nil`) - Description of the `ServicePerimeter` and its use. Does not affect behavior.\n*   `name` (*type:* `String.t`, *default:* `nil`) - Identifier. Resource name for the `ServicePerimeter`. Format: `accessPolicies/{access_policy}/servicePerimeters/{service_perimeter}`. The `service_perimeter` component must begin with a letter, followed by alphanumeric characters or `_`. After you create a `ServicePerimeter`, you cannot change its `name`.\n*   `perimeterType` (*type:* `String.t`, *default:* `nil`) - Perimeter type indicator. A single project or VPC network is allowed to be a member of single regular perimeter, but multiple service perimeter bridges. A project cannot be a included in a perimeter bridge without being included in regular perimeter. For perimeter bridges, the restricted service list as well as access level lists must be empty.\n*   `spec` (*type:* `GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1ServicePerimeterConfig.t`, *default:* `nil`) - Proposed (or dry run) ServicePerimeter configuration. This configuration allows to specify and test ServicePerimeter configuration without enforcing actual access restrictions. Only allowed to be set when the \"use_explicit_dry_run_spec\" flag is set.\n*   `status` (*type:* `GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1ServicePerimeterConfig.t`, *default:* `nil`) - Current ServicePerimeter configuration. Specifies sets of resources, restricted services and access levels that determine perimeter content and boundaries.\n*   `title` (*type:* `String.t`, *default:* `nil`) - Human readable title. Must be unique within the Policy.\n*   `useExplicitDryRunSpec` (*type:* `boolean()`, *default:* `nil`) - Use explicit dry run spec flag. Ordinarily, a dry-run spec implicitly exists for all Service Perimeters, and that spec is identical to the status for those Service Perimeters. When this flag is set, it inhibits the generation of the implicit spec, thereby allowing the user to explicitly provide a configuration (\"spec\") to use in a dry-run version of the Service Perimeter. This allows the user to test changes to the enforced config (\"status\") without actually enforcing them. This testing is done through analyzing the differences between currently enforced and suggested restrictions. use_explicit_dry_run_spec must bet set to True if any of the fields in the spec are set to non-default values.","ref":"GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1ServicePerimeter.html#module-attributes"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1ServicePerimeter.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1ServicePerimeter.html#decode/2"},{"type":"type","title":"GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1ServicePerimeter.t/0","doc":"","ref":"GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1ServicePerimeter.html#t:t/0"},{"type":"module","title":"GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1ServicePerimeterConfig","doc":"`ServicePerimeterConfig` specifies a set of Google Cloud resources that describe specific Service Perimeter configuration.","ref":"GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1ServicePerimeterConfig.html"},{"type":"module","title":"Attributes - GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1ServicePerimeterConfig","doc":"*   `accessLevels` (*type:* `list(String.t)`, *default:* `nil`) - A list of `AccessLevel` resource names that allow resources within the `ServicePerimeter` to be accessed from the internet. `AccessLevels` listed must be in the same policy as this `ServicePerimeter`. Referencing a nonexistent `AccessLevel` is a syntax error. If no `AccessLevel` names are listed, resources within the perimeter can only be accessed via Google Cloud calls with request origins within the perimeter. Example: `\"accessPolicies/MY_POLICY/accessLevels/MY_LEVEL\"`. For Service Perimeter Bridge, must be empty.\n*   `egressPolicies` (*type:* `list(GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1EgressPolicy.t)`, *default:* `nil`) - List of EgressPolicies to apply to the perimeter. A perimeter may have multiple EgressPolicies, each of which is evaluated separately. Access is granted if any EgressPolicy grants it. Must be empty for a perimeter bridge.\n*   `ingressPolicies` (*type:* `list(GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1IngressPolicy.t)`, *default:* `nil`) - List of IngressPolicies to apply to the perimeter. A perimeter may have multiple IngressPolicies, each of which is evaluated separately. Access is granted if any Ingress Policy grants it. Must be empty for a perimeter bridge.\n*   `resources` (*type:* `list(String.t)`, *default:* `nil`) - A list of Google Cloud resources that are inside of the service perimeter. Currently only projects and VPCs are allowed. Project format: `projects/{project_number}` VPC network format: `//compute.googleapis.com/projects/{PROJECT_ID}/global/networks/{NAME}`.\n*   `restrictedServices` (*type:* `list(String.t)`, *default:* `nil`) - Google Cloud services that are subject to the Service Perimeter restrictions. For example, if `storage.googleapis.com` is specified, access to the storage buckets inside the perimeter must meet the perimeter's access restrictions.\n*   `vpcAccessibleServices` (*type:* `GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1VpcAccessibleServices.t`, *default:* `nil`) - Configuration for APIs allowed within Perimeter.","ref":"GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1ServicePerimeterConfig.html#module-attributes"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1ServicePerimeterConfig.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1ServicePerimeterConfig.html#decode/2"},{"type":"type","title":"GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1ServicePerimeterConfig.t/0","doc":"","ref":"GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1ServicePerimeterConfig.html#t:t/0"},{"type":"module","title":"GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1VpcAccessibleServices","doc":"Specifies how APIs are allowed to communicate within the Service Perimeter.","ref":"GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1VpcAccessibleServices.html"},{"type":"module","title":"Attributes - GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1VpcAccessibleServices","doc":"*   `allowedServices` (*type:* `list(String.t)`, *default:* `nil`) - The list of APIs usable within the Service Perimeter. Must be empty unless 'enable_restriction' is True. You can specify a list of individual services, as well as include the 'RESTRICTED-SERVICES' value, which automatically includes all of the services protected by the perimeter.\n*   `enableRestriction` (*type:* `boolean()`, *default:* `nil`) - Whether to restrict API calls within the Service Perimeter to the list of APIs specified in 'allowed_services'.","ref":"GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1VpcAccessibleServices.html#module-attributes"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1VpcAccessibleServices.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1VpcAccessibleServices.html#decode/2"},{"type":"type","title":"GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1VpcAccessibleServices.t/0","doc":"","ref":"GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1VpcAccessibleServices.html#t:t/0"},{"type":"module","title":"GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1VpcNetworkSource","doc":"The originating network source in Google Cloud.","ref":"GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1VpcNetworkSource.html"},{"type":"module","title":"Attributes - GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1VpcNetworkSource","doc":"*   `vpcSubnetwork` (*type:* `GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1VpcSubNetwork.t`, *default:* `nil`) - Sub-segment ranges of a VPC network.","ref":"GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1VpcNetworkSource.html#module-attributes"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1VpcNetworkSource.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1VpcNetworkSource.html#decode/2"},{"type":"type","title":"GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1VpcNetworkSource.t/0","doc":"","ref":"GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1VpcNetworkSource.html#t:t/0"},{"type":"module","title":"GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1VpcSubNetwork","doc":"Sub-segment ranges inside of a VPC Network.","ref":"GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1VpcSubNetwork.html"},{"type":"module","title":"Attributes - GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1VpcSubNetwork","doc":"*   `network` (*type:* `String.t`, *default:* `nil`) - Required. Network name. If the network is not part of the organization, the `compute.network.get` permission must be granted to the caller. Format: `//compute.googleapis.com/projects/{PROJECT_ID}/global/networks/{NETWORK_NAME}` Example: `//compute.googleapis.com/projects/my-project/global/networks/network-1`\n*   `vpcIpSubnetworks` (*type:* `list(String.t)`, *default:* `nil`) - CIDR block IP subnetwork specification. The IP address must be an IPv4 address and can be a public or private IP address. Note that for a CIDR IP address block, the specified IP address portion must be properly truncated (i.e. all the host bits must be zero) or the input is considered malformed. For example, \"192.0.2.0/24\" is accepted but \"192.0.2.1/24\" is not. If empty, all IP addresses are allowed.","ref":"GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1VpcSubNetwork.html#module-attributes"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1VpcSubNetwork.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1VpcSubNetwork.html#decode/2"},{"type":"type","title":"GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1VpcSubNetwork.t/0","doc":"","ref":"GoogleApi.CloudAsset.V1.Model.GoogleIdentityAccesscontextmanagerV1VpcSubNetwork.html#t:t/0"},{"type":"module","title":"GoogleApi.CloudAsset.V1.Model.IamPolicyAnalysis","doc":"An analysis message to group the query and results.","ref":"GoogleApi.CloudAsset.V1.Model.IamPolicyAnalysis.html"},{"type":"module","title":"Attributes - GoogleApi.CloudAsset.V1.Model.IamPolicyAnalysis","doc":"*   `analysisQuery` (*type:* `GoogleApi.CloudAsset.V1.Model.IamPolicyAnalysisQuery.t`, *default:* `nil`) - The analysis query.\n*   `analysisResults` (*type:* `list(GoogleApi.CloudAsset.V1.Model.IamPolicyAnalysisResult.t)`, *default:* `nil`) - A list of IamPolicyAnalysisResult that matches the analysis query, or empty if no result is found.\n*   `fullyExplored` (*type:* `boolean()`, *default:* `nil`) - Represents whether all entries in the analysis_results have been fully explored to answer the query.\n*   `nonCriticalErrors` (*type:* `list(GoogleApi.CloudAsset.V1.Model.IamPolicyAnalysisState.t)`, *default:* `nil`) - A list of non-critical errors happened during the query handling.","ref":"GoogleApi.CloudAsset.V1.Model.IamPolicyAnalysis.html#module-attributes"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Model.IamPolicyAnalysis.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.CloudAsset.V1.Model.IamPolicyAnalysis.html#decode/2"},{"type":"type","title":"GoogleApi.CloudAsset.V1.Model.IamPolicyAnalysis.t/0","doc":"","ref":"GoogleApi.CloudAsset.V1.Model.IamPolicyAnalysis.html#t:t/0"},{"type":"module","title":"GoogleApi.CloudAsset.V1.Model.IamPolicyAnalysisOutputConfig","doc":"Output configuration for export IAM policy analysis destination.","ref":"GoogleApi.CloudAsset.V1.Model.IamPolicyAnalysisOutputConfig.html"},{"type":"module","title":"Attributes - GoogleApi.CloudAsset.V1.Model.IamPolicyAnalysisOutputConfig","doc":"*   `bigqueryDestination` (*type:* `GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1BigQueryDestination.t`, *default:* `nil`) - Destination on BigQuery.\n*   `gcsDestination` (*type:* `GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1GcsDestination.t`, *default:* `nil`) - Destination on Cloud Storage.","ref":"GoogleApi.CloudAsset.V1.Model.IamPolicyAnalysisOutputConfig.html#module-attributes"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Model.IamPolicyAnalysisOutputConfig.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.CloudAsset.V1.Model.IamPolicyAnalysisOutputConfig.html#decode/2"},{"type":"type","title":"GoogleApi.CloudAsset.V1.Model.IamPolicyAnalysisOutputConfig.t/0","doc":"","ref":"GoogleApi.CloudAsset.V1.Model.IamPolicyAnalysisOutputConfig.html#t:t/0"},{"type":"module","title":"GoogleApi.CloudAsset.V1.Model.IamPolicyAnalysisQuery","doc":"IAM policy analysis query message.","ref":"GoogleApi.CloudAsset.V1.Model.IamPolicyAnalysisQuery.html"},{"type":"module","title":"Attributes - GoogleApi.CloudAsset.V1.Model.IamPolicyAnalysisQuery","doc":"*   `accessSelector` (*type:* `GoogleApi.CloudAsset.V1.Model.AccessSelector.t`, *default:* `nil`) - Optional. Specifies roles or permissions for analysis. This is optional.\n*   `conditionContext` (*type:* `GoogleApi.CloudAsset.V1.Model.ConditionContext.t`, *default:* `nil`) - Optional. The hypothetical context for IAM conditions evaluation.\n*   `identitySelector` (*type:* `GoogleApi.CloudAsset.V1.Model.IdentitySelector.t`, *default:* `nil`) - Optional. Specifies an identity for analysis.\n*   `options` (*type:* `GoogleApi.CloudAsset.V1.Model.Options.t`, *default:* `nil`) - Optional. The query options.\n*   `resourceSelector` (*type:* `GoogleApi.CloudAsset.V1.Model.ResourceSelector.t`, *default:* `nil`) - Optional. Specifies a resource for analysis.\n*   `scope` (*type:* `String.t`, *default:* `nil`) - Required. The relative name of the root asset. Only resources and IAM policies within the scope will be analyzed. This can only be an organization number (such as \"organizations/123\"), a folder number (such as \"folders/123\"), a project ID (such as \"projects/my-project-id\"), or a project number (such as \"projects/12345\"). To know how to get organization ID, visit [here ](https://cloud.google.com/resource-manager/docs/creating-managing-organization#retrieving_your_organization_id). To know how to get folder or project ID, visit [here ](https://cloud.google.com/resource-manager/docs/creating-managing-folders#viewing_or_listing_folders_and_projects).","ref":"GoogleApi.CloudAsset.V1.Model.IamPolicyAnalysisQuery.html#module-attributes"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Model.IamPolicyAnalysisQuery.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.CloudAsset.V1.Model.IamPolicyAnalysisQuery.html#decode/2"},{"type":"type","title":"GoogleApi.CloudAsset.V1.Model.IamPolicyAnalysisQuery.t/0","doc":"","ref":"GoogleApi.CloudAsset.V1.Model.IamPolicyAnalysisQuery.html#t:t/0"},{"type":"module","title":"GoogleApi.CloudAsset.V1.Model.IamPolicyAnalysisResult","doc":"IAM Policy analysis result, consisting of one IAM policy binding and derived access control lists.","ref":"GoogleApi.CloudAsset.V1.Model.IamPolicyAnalysisResult.html"},{"type":"module","title":"Attributes - GoogleApi.CloudAsset.V1.Model.IamPolicyAnalysisResult","doc":"*   `accessControlLists` (*type:* `list(GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1AccessControlList.t)`, *default:* `nil`) - The access control lists derived from the iam_binding that match or potentially match resource and access selectors specified in the request.\n*   `attachedResourceFullName` (*type:* `String.t`, *default:* `nil`) - The [full resource name](https://cloud.google.com/asset-inventory/docs/resource-name-format) of the resource to which the iam_binding policy attaches.\n*   `fullyExplored` (*type:* `boolean()`, *default:* `nil`) - Represents whether all analyses on the iam_binding have successfully finished.\n*   `iamBinding` (*type:* `GoogleApi.CloudAsset.V1.Model.Binding.t`, *default:* `nil`) - The IAM policy binding under analysis.\n*   `identityList` (*type:* `GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1IdentityList.t`, *default:* `nil`) - The identity list derived from members of the iam_binding that match or potentially match identity selector specified in the request.","ref":"GoogleApi.CloudAsset.V1.Model.IamPolicyAnalysisResult.html#module-attributes"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Model.IamPolicyAnalysisResult.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.CloudAsset.V1.Model.IamPolicyAnalysisResult.html#decode/2"},{"type":"type","title":"GoogleApi.CloudAsset.V1.Model.IamPolicyAnalysisResult.t/0","doc":"","ref":"GoogleApi.CloudAsset.V1.Model.IamPolicyAnalysisResult.html#t:t/0"},{"type":"module","title":"GoogleApi.CloudAsset.V1.Model.IamPolicyAnalysisState","doc":"Represents the detailed state of an entity under analysis, such as a resource, an identity or an access.","ref":"GoogleApi.CloudAsset.V1.Model.IamPolicyAnalysisState.html"},{"type":"module","title":"Attributes - GoogleApi.CloudAsset.V1.Model.IamPolicyAnalysisState","doc":"*   `cause` (*type:* `String.t`, *default:* `nil`) - The human-readable description of the cause of failure.\n*   `code` (*type:* `String.t`, *default:* `nil`) - The Google standard error code that best describes the state. For example: - OK means the analysis on this entity has been successfully finished; - PERMISSION_DENIED means an access denied error is encountered; - DEADLINE_EXCEEDED means the analysis on this entity hasn't been started in time;","ref":"GoogleApi.CloudAsset.V1.Model.IamPolicyAnalysisState.html#module-attributes"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Model.IamPolicyAnalysisState.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.CloudAsset.V1.Model.IamPolicyAnalysisState.html#decode/2"},{"type":"type","title":"GoogleApi.CloudAsset.V1.Model.IamPolicyAnalysisState.t/0","doc":"","ref":"GoogleApi.CloudAsset.V1.Model.IamPolicyAnalysisState.html#t:t/0"},{"type":"module","title":"GoogleApi.CloudAsset.V1.Model.IamPolicySearchResult","doc":"A result of IAM Policy search, containing information of an IAM policy.","ref":"GoogleApi.CloudAsset.V1.Model.IamPolicySearchResult.html"},{"type":"module","title":"Attributes - GoogleApi.CloudAsset.V1.Model.IamPolicySearchResult","doc":"*   `assetType` (*type:* `String.t`, *default:* `nil`) - The type of the resource associated with this IAM policy. Example: `compute.googleapis.com/Disk`. To search against the `asset_type`: * specify the `asset_types` field in your search request.\n*   `explanation` (*type:* `GoogleApi.CloudAsset.V1.Model.Explanation.t`, *default:* `nil`) - Explanation about the IAM policy search result. It contains additional information to explain why the search result matches the query.\n*   `folders` (*type:* `list(String.t)`, *default:* `nil`) - The folder(s) that the IAM policy belongs to, in the form of folders/{FOLDER_NUMBER}. This field is available when the IAM policy belongs to one or more folders. To search against `folders`: * use a field query. Example: `folders:(123 OR 456)` * use a free text query. Example: `123` * specify the `scope` field as this folder in your search request.\n*   `organization` (*type:* `String.t`, *default:* `nil`) - The organization that the IAM policy belongs to, in the form of organizations/{ORGANIZATION_NUMBER}. This field is available when the IAM policy belongs to an organization. To search against `organization`: * use a field query. Example: `organization:123` * use a free text query. Example: `123` * specify the `scope` field as this organization in your search request.\n*   `policy` (*type:* `GoogleApi.CloudAsset.V1.Model.Policy.t`, *default:* `nil`) - The IAM policy directly set on the given resource. Note that the original IAM policy can contain multiple bindings. This only contains the bindings that match the given query. For queries that don't contain a constrain on policies (e.g., an empty query), this contains all the bindings. To search against the `policy` bindings: * use a field query: - query by the policy contained members. Example: `policy:amy@gmail.com` - query by the policy contained roles. Example: `policy:roles/compute.admin` - query by the policy contained roles' included permissions. Example: `policy.role.permissions:compute.instances.create`\n*   `project` (*type:* `String.t`, *default:* `nil`) - The project that the associated Google Cloud resource belongs to, in the form of projects/{PROJECT_NUMBER}. If an IAM policy is set on a resource (like VM instance, Cloud Storage bucket), the project field will indicate the project that contains the resource. If an IAM policy is set on a folder or orgnization, this field will be empty. To search against the `project`: * specify the `scope` field as this project in your search request.\n*   `resource` (*type:* `String.t`, *default:* `nil`) - The full resource name of the resource associated with this IAM policy. Example: `//compute.googleapis.com/projects/my_project_123/zones/zone1/instances/instance1`. See [Cloud Asset Inventory Resource Name Format](https://cloud.google.com/asset-inventory/docs/resource-name-format) for more information. To search against the `resource`: * use a field query. Example: `resource:organizations/123`","ref":"GoogleApi.CloudAsset.V1.Model.IamPolicySearchResult.html#module-attributes"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Model.IamPolicySearchResult.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.CloudAsset.V1.Model.IamPolicySearchResult.html#decode/2"},{"type":"type","title":"GoogleApi.CloudAsset.V1.Model.IamPolicySearchResult.t/0","doc":"","ref":"GoogleApi.CloudAsset.V1.Model.IamPolicySearchResult.html#t:t/0"},{"type":"module","title":"GoogleApi.CloudAsset.V1.Model.IdentitySelector","doc":"Specifies an identity for which to determine resource access, based on roles assigned either directly to them or to the groups they belong to, directly or indirectly.","ref":"GoogleApi.CloudAsset.V1.Model.IdentitySelector.html"},{"type":"module","title":"Attributes - GoogleApi.CloudAsset.V1.Model.IdentitySelector","doc":"*   `identity` (*type:* `String.t`, *default:* `nil`) - Required. The identity appear in the form of principals in [IAM policy binding](https://cloud.google.com/iam/reference/rest/v1/Binding). The examples of supported forms are: \"user:mike@example.com\", \"group:admins@example.com\", \"domain:google.com\", \"serviceAccount:my-project-id@appspot.gserviceaccount.com\". Notice that wildcard characters (such as * and ?) are not supported. You must give a specific identity.","ref":"GoogleApi.CloudAsset.V1.Model.IdentitySelector.html#module-attributes"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Model.IdentitySelector.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.CloudAsset.V1.Model.IdentitySelector.html#decode/2"},{"type":"type","title":"GoogleApi.CloudAsset.V1.Model.IdentitySelector.t/0","doc":"","ref":"GoogleApi.CloudAsset.V1.Model.IdentitySelector.html#t:t/0"},{"type":"module","title":"GoogleApi.CloudAsset.V1.Model.Inventory","doc":"This API resource represents the available inventory data for a Compute Engine virtual machine (VM) instance at a given point in time. You can use this API resource to determine the inventory data of your VM. For more information, see [Information provided by OS inventory management](https://cloud.google.com/compute/docs/instances/os-inventory-management#data-collected).","ref":"GoogleApi.CloudAsset.V1.Model.Inventory.html"},{"type":"module","title":"Attributes - GoogleApi.CloudAsset.V1.Model.Inventory","doc":"*   `items` (*type:* `%{optional(String.t) => GoogleApi.CloudAsset.V1.Model.Item.t}`, *default:* `nil`) - Inventory items related to the VM keyed by an opaque unique identifier for each inventory item. The identifier is unique to each distinct and addressable inventory item and will change, when there is a new package version.\n*   `name` (*type:* `String.t`, *default:* `nil`) - Output only. The `Inventory` API resource name. Format: `projects/{project_number}/locations/{location}/instances/{instance_id}/inventory`\n*   `osInfo` (*type:* `GoogleApi.CloudAsset.V1.Model.OsInfo.t`, *default:* `nil`) - Base level operating system information for the VM.\n*   `updateTime` (*type:* `DateTime.t`, *default:* `nil`) - Output only. Timestamp of the last reported inventory for the VM.","ref":"GoogleApi.CloudAsset.V1.Model.Inventory.html#module-attributes"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Model.Inventory.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.CloudAsset.V1.Model.Inventory.html#decode/2"},{"type":"type","title":"GoogleApi.CloudAsset.V1.Model.Inventory.t/0","doc":"","ref":"GoogleApi.CloudAsset.V1.Model.Inventory.html#t:t/0"},{"type":"module","title":"GoogleApi.CloudAsset.V1.Model.Item","doc":"A single piece of inventory on a VM.","ref":"GoogleApi.CloudAsset.V1.Model.Item.html"},{"type":"module","title":"Attributes - GoogleApi.CloudAsset.V1.Model.Item","doc":"*   `availablePackage` (*type:* `GoogleApi.CloudAsset.V1.Model.SoftwarePackage.t`, *default:* `nil`) - Software package available to be installed on the VM instance.\n*   `createTime` (*type:* `DateTime.t`, *default:* `nil`) - When this inventory item was first detected.\n*   `id` (*type:* `String.t`, *default:* `nil`) - Identifier for this item, unique across items for this VM.\n*   `installedPackage` (*type:* `GoogleApi.CloudAsset.V1.Model.SoftwarePackage.t`, *default:* `nil`) - Software package present on the VM instance.\n*   `originType` (*type:* `String.t`, *default:* `nil`) - The origin of this inventory item.\n*   `type` (*type:* `String.t`, *default:* `nil`) - The specific type of inventory, correlating to its specific details.\n*   `updateTime` (*type:* `DateTime.t`, *default:* `nil`) - When this inventory item was last modified.","ref":"GoogleApi.CloudAsset.V1.Model.Item.html#module-attributes"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Model.Item.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.CloudAsset.V1.Model.Item.html#decode/2"},{"type":"type","title":"GoogleApi.CloudAsset.V1.Model.Item.t/0","doc":"","ref":"GoogleApi.CloudAsset.V1.Model.Item.html#t:t/0"},{"type":"module","title":"GoogleApi.CloudAsset.V1.Model.ListAssetsResponse","doc":"ListAssets response.","ref":"GoogleApi.CloudAsset.V1.Model.ListAssetsResponse.html"},{"type":"module","title":"Attributes - GoogleApi.CloudAsset.V1.Model.ListAssetsResponse","doc":"*   `assets` (*type:* `list(GoogleApi.CloudAsset.V1.Model.Asset.t)`, *default:* `nil`) - Assets.\n*   `nextPageToken` (*type:* `String.t`, *default:* `nil`) - Token to retrieve the next page of results. It expires 72 hours after the page token for the first page is generated. Set to empty if there are no remaining results.\n*   `readTime` (*type:* `DateTime.t`, *default:* `nil`) - Time the snapshot was taken.","ref":"GoogleApi.CloudAsset.V1.Model.ListAssetsResponse.html#module-attributes"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Model.ListAssetsResponse.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.CloudAsset.V1.Model.ListAssetsResponse.html#decode/2"},{"type":"type","title":"GoogleApi.CloudAsset.V1.Model.ListAssetsResponse.t/0","doc":"","ref":"GoogleApi.CloudAsset.V1.Model.ListAssetsResponse.html#t:t/0"},{"type":"module","title":"GoogleApi.CloudAsset.V1.Model.ListFeedsResponse","doc":"","ref":"GoogleApi.CloudAsset.V1.Model.ListFeedsResponse.html"},{"type":"module","title":"Attributes - GoogleApi.CloudAsset.V1.Model.ListFeedsResponse","doc":"*   `feeds` (*type:* `list(GoogleApi.CloudAsset.V1.Model.Feed.t)`, *default:* `nil`) - A list of feeds.","ref":"GoogleApi.CloudAsset.V1.Model.ListFeedsResponse.html#module-attributes"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Model.ListFeedsResponse.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.CloudAsset.V1.Model.ListFeedsResponse.html#decode/2"},{"type":"type","title":"GoogleApi.CloudAsset.V1.Model.ListFeedsResponse.t/0","doc":"","ref":"GoogleApi.CloudAsset.V1.Model.ListFeedsResponse.html#t:t/0"},{"type":"module","title":"GoogleApi.CloudAsset.V1.Model.ListSavedQueriesResponse","doc":"Response of listing saved queries.","ref":"GoogleApi.CloudAsset.V1.Model.ListSavedQueriesResponse.html"},{"type":"module","title":"Attributes - GoogleApi.CloudAsset.V1.Model.ListSavedQueriesResponse","doc":"*   `nextPageToken` (*type:* `String.t`, *default:* `nil`) - A token, which can be sent as `page_token` to retrieve the next page. If this field is omitted, there are no subsequent pages.\n*   `savedQueries` (*type:* `list(GoogleApi.CloudAsset.V1.Model.SavedQuery.t)`, *default:* `nil`) - A list of savedQueries.","ref":"GoogleApi.CloudAsset.V1.Model.ListSavedQueriesResponse.html#module-attributes"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Model.ListSavedQueriesResponse.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.CloudAsset.V1.Model.ListSavedQueriesResponse.html#decode/2"},{"type":"type","title":"GoogleApi.CloudAsset.V1.Model.ListSavedQueriesResponse.t/0","doc":"","ref":"GoogleApi.CloudAsset.V1.Model.ListSavedQueriesResponse.html#t:t/0"},{"type":"module","title":"GoogleApi.CloudAsset.V1.Model.MoveAnalysis","doc":"A message to group the analysis information.","ref":"GoogleApi.CloudAsset.V1.Model.MoveAnalysis.html"},{"type":"module","title":"Attributes - GoogleApi.CloudAsset.V1.Model.MoveAnalysis","doc":"*   `analysis` (*type:* `GoogleApi.CloudAsset.V1.Model.MoveAnalysisResult.t`, *default:* `nil`) - Analysis result of moving the target resource.\n*   `displayName` (*type:* `String.t`, *default:* `nil`) - The user friendly display name of the analysis. E.g. IAM, organization policy etc.\n*   `error` (*type:* `GoogleApi.CloudAsset.V1.Model.Status.t`, *default:* `nil`) - Description of error encountered when performing the analysis.","ref":"GoogleApi.CloudAsset.V1.Model.MoveAnalysis.html#module-attributes"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Model.MoveAnalysis.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.CloudAsset.V1.Model.MoveAnalysis.html#decode/2"},{"type":"type","title":"GoogleApi.CloudAsset.V1.Model.MoveAnalysis.t/0","doc":"","ref":"GoogleApi.CloudAsset.V1.Model.MoveAnalysis.html#t:t/0"},{"type":"module","title":"GoogleApi.CloudAsset.V1.Model.MoveAnalysisResult","doc":"An analysis result including blockers and warnings.","ref":"GoogleApi.CloudAsset.V1.Model.MoveAnalysisResult.html"},{"type":"module","title":"Attributes - GoogleApi.CloudAsset.V1.Model.MoveAnalysisResult","doc":"*   `blockers` (*type:* `list(GoogleApi.CloudAsset.V1.Model.MoveImpact.t)`, *default:* `nil`) - Blocking information that would prevent the target resource from moving to the specified destination at runtime.\n*   `warnings` (*type:* `list(GoogleApi.CloudAsset.V1.Model.MoveImpact.t)`, *default:* `nil`) - Warning information indicating that moving the target resource to the specified destination might be unsafe. This can include important policy information and configuration changes, but will not block moves at runtime.","ref":"GoogleApi.CloudAsset.V1.Model.MoveAnalysisResult.html#module-attributes"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Model.MoveAnalysisResult.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.CloudAsset.V1.Model.MoveAnalysisResult.html#decode/2"},{"type":"type","title":"GoogleApi.CloudAsset.V1.Model.MoveAnalysisResult.t/0","doc":"","ref":"GoogleApi.CloudAsset.V1.Model.MoveAnalysisResult.html#t:t/0"},{"type":"module","title":"GoogleApi.CloudAsset.V1.Model.MoveImpact","doc":"A message to group impacts of moving the target resource.","ref":"GoogleApi.CloudAsset.V1.Model.MoveImpact.html"},{"type":"module","title":"Attributes - GoogleApi.CloudAsset.V1.Model.MoveImpact","doc":"*   `detail` (*type:* `String.t`, *default:* `nil`) - User friendly impact detail in a free form message.","ref":"GoogleApi.CloudAsset.V1.Model.MoveImpact.html#module-attributes"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Model.MoveImpact.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.CloudAsset.V1.Model.MoveImpact.html#decode/2"},{"type":"type","title":"GoogleApi.CloudAsset.V1.Model.MoveImpact.t/0","doc":"","ref":"GoogleApi.CloudAsset.V1.Model.MoveImpact.html#t:t/0"},{"type":"module","title":"GoogleApi.CloudAsset.V1.Model.Operation","doc":"This resource represents a long-running operation that is the result of a network API call.","ref":"GoogleApi.CloudAsset.V1.Model.Operation.html"},{"type":"module","title":"Attributes - GoogleApi.CloudAsset.V1.Model.Operation","doc":"*   `done` (*type:* `boolean()`, *default:* `nil`) - If the value is `false`, it means the operation is still in progress. If `true`, the operation is completed, and either `error` or `response` is available.\n*   `error` (*type:* `GoogleApi.CloudAsset.V1.Model.Status.t`, *default:* `nil`) - The error result of the operation in case of failure or cancellation.\n*   `metadata` (*type:* `map()`, *default:* `nil`) - Service-specific metadata associated with the operation. It typically contains progress information and common metadata such as create time. Some services might not provide such metadata. Any method that returns a long-running operation should document the metadata type, if any.\n*   `name` (*type:* `String.t`, *default:* `nil`) - The server-assigned name, which is only unique within the same service that originally returns it. If you use the default HTTP mapping, the `name` should be a resource name ending with `operations/{unique_id}`.\n*   `response` (*type:* `map()`, *default:* `nil`) - The normal, successful response of the operation. If the original method returns no data on success, such as `Delete`, the response is `google.protobuf.Empty`. If the original method is standard `Get`/`Create`/`Update`, the response should be the resource. For other methods, the response should have the type `XxxResponse`, where `Xxx` is the original method name. For example, if the original method name is `TakeSnapshot()`, the inferred response type is `TakeSnapshotResponse`.","ref":"GoogleApi.CloudAsset.V1.Model.Operation.html#module-attributes"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Model.Operation.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.CloudAsset.V1.Model.Operation.html#decode/2"},{"type":"type","title":"GoogleApi.CloudAsset.V1.Model.Operation.t/0","doc":"","ref":"GoogleApi.CloudAsset.V1.Model.Operation.html#t:t/0"},{"type":"module","title":"GoogleApi.CloudAsset.V1.Model.Options","doc":"Contains query options.","ref":"GoogleApi.CloudAsset.V1.Model.Options.html"},{"type":"module","title":"Attributes - GoogleApi.CloudAsset.V1.Model.Options","doc":"*   `analyzeServiceAccountImpersonation` (*type:* `boolean()`, *default:* `nil`) - Optional. If true, the response will include access analysis from identities to resources via service account impersonation. This is a very expensive operation, because many derived queries will be executed. We highly recommend you use AssetService.AnalyzeIamPolicyLongrunning RPC instead. For example, if the request analyzes for which resources user A has permission P, and there's an IAM policy states user A has iam.serviceAccounts.getAccessToken permission to a service account SA, and there's another IAM policy states service account SA has permission P to a Google Cloud folder F, then user A potentially has access to the Google Cloud folder F. And those advanced analysis results will be included in AnalyzeIamPolicyResponse.service_account_impersonation_analysis. Another example, if the request analyzes for who has permission P to a Google Cloud folder F, and there's an IAM policy states user A has iam.serviceAccounts.actAs permission to a service account SA, and there's another IAM policy states service account SA has permission P to the Google Cloud folder F, then user A potentially has access to the Google Cloud folder F. And those advanced analysis results will be included in AnalyzeIamPolicyResponse.service_account_impersonation_analysis. Only the following permissions are considered in this analysis: * `iam.serviceAccounts.actAs` * `iam.serviceAccounts.signBlob` * `iam.serviceAccounts.signJwt` * `iam.serviceAccounts.getAccessToken` * `iam.serviceAccounts.getOpenIdToken` * `iam.serviceAccounts.implicitDelegation` Default is false.\n*   `expandGroups` (*type:* `boolean()`, *default:* `nil`) - Optional. If true, the identities section of the result will expand any Google groups appearing in an IAM policy binding. If IamPolicyAnalysisQuery.identity_selector is specified, the identity in the result will be determined by the selector, and this flag is not allowed to set. If true, the default max expansion per group is 1000 for AssetService.AnalyzeIamPolicy][]. Default is false.\n*   `expandResources` (*type:* `boolean()`, *default:* `nil`) - Optional. If true and IamPolicyAnalysisQuery.resource_selector is not specified, the resource section of the result will expand any resource attached to an IAM policy to include resources lower in the resource hierarchy. For example, if the request analyzes for which resources user A has permission P, and the results include an IAM policy with P on a Google Cloud folder, the results will also include resources in that folder with permission P. If true and IamPolicyAnalysisQuery.resource_selector is specified, the resource section of the result will expand the specified resource to include resources lower in the resource hierarchy. Only project or lower resources are supported. Folder and organization resources cannot be used together with this option. For example, if the request analyzes for which users have permission P on a Google Cloud project with this option enabled, the results will include all users who have permission P on that project or any lower resource. If true, the default max expansion per resource is 1000 for AssetService.AnalyzeIamPolicy][] and 100000 for AssetService.AnalyzeIamPolicyLongrunning][]. Default is false.\n*   `expandRoles` (*type:* `boolean()`, *default:* `nil`) - Optional. If true, the access section of result will expand any roles appearing in IAM policy bindings to include their permissions. If IamPolicyAnalysisQuery.access_selector is specified, the access section of the result will be determined by the selector, and this flag is not allowed to set. Default is false.\n*   `outputGroupEdges` (*type:* `boolean()`, *default:* `nil`) - Optional. If true, the result will output the relevant membership relationships between groups and other groups, and between groups and principals. Default is false.\n*   `outputResourceEdges` (*type:* `boolean()`, *default:* `nil`) - Optional. If true, the result will output the relevant parent/child relationships between resources. Default is false.","ref":"GoogleApi.CloudAsset.V1.Model.Options.html#module-attributes"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Model.Options.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.CloudAsset.V1.Model.Options.html#decode/2"},{"type":"type","title":"GoogleApi.CloudAsset.V1.Model.Options.t/0","doc":"","ref":"GoogleApi.CloudAsset.V1.Model.Options.html#t:t/0"},{"type":"module","title":"GoogleApi.CloudAsset.V1.Model.OrgPolicyResult","doc":"The organization policy result to the query.","ref":"GoogleApi.CloudAsset.V1.Model.OrgPolicyResult.html"},{"type":"module","title":"Attributes - GoogleApi.CloudAsset.V1.Model.OrgPolicyResult","doc":"*   `consolidatedPolicy` (*type:* `GoogleApi.CloudAsset.V1.Model.AnalyzerOrgPolicy.t`, *default:* `nil`) - The consolidated organization policy for the analyzed resource. The consolidated organization policy is computed by merging and evaluating AnalyzeOrgPoliciesResponse.policy_bundle. The evaluation will respect the organization policy [hierarchy rules](https://cloud.google.com/resource-manager/docs/organization-policy/understanding-hierarchy).\n*   `folders` (*type:* `list(String.t)`, *default:* `nil`) - The folder(s) that this consolidated policy belongs to, in the format of folders/{FOLDER_NUMBER}. This field is available when the consolidated policy belongs (directly or cascadingly) to one or more folders.\n*   `organization` (*type:* `String.t`, *default:* `nil`) - The organization that this consolidated policy belongs to, in the format of organizations/{ORGANIZATION_NUMBER}. This field is available when the consolidated policy belongs (directly or cascadingly) to an organization.\n*   `policyBundle` (*type:* `list(GoogleApi.CloudAsset.V1.Model.AnalyzerOrgPolicy.t)`, *default:* `nil`) - The ordered list of all organization policies from the AnalyzeOrgPoliciesResponse.OrgPolicyResult.consolidated_policy.attached_resource. to the scope specified in the request. If the constraint is defined with default policy, it will also appear in the list.\n*   `project` (*type:* `String.t`, *default:* `nil`) - The project that this consolidated policy belongs to, in the format of projects/{PROJECT_NUMBER}. This field is available when the consolidated policy belongs to a project.","ref":"GoogleApi.CloudAsset.V1.Model.OrgPolicyResult.html#module-attributes"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Model.OrgPolicyResult.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.CloudAsset.V1.Model.OrgPolicyResult.html#decode/2"},{"type":"type","title":"GoogleApi.CloudAsset.V1.Model.OrgPolicyResult.t/0","doc":"","ref":"GoogleApi.CloudAsset.V1.Model.OrgPolicyResult.html#t:t/0"},{"type":"module","title":"GoogleApi.CloudAsset.V1.Model.OsInfo","doc":"Operating system information for the VM.","ref":"GoogleApi.CloudAsset.V1.Model.OsInfo.html"},{"type":"module","title":"Attributes - GoogleApi.CloudAsset.V1.Model.OsInfo","doc":"*   `architecture` (*type:* `String.t`, *default:* `nil`) - The system architecture of the operating system.\n*   `hostname` (*type:* `String.t`, *default:* `nil`) - The VM hostname.\n*   `kernelRelease` (*type:* `String.t`, *default:* `nil`) - The kernel release of the operating system.\n*   `kernelVersion` (*type:* `String.t`, *default:* `nil`) - The kernel version of the operating system.\n*   `longName` (*type:* `String.t`, *default:* `nil`) - The operating system long name. For example 'Debian GNU/Linux 9' or 'Microsoft Window Server 2019 Datacenter'.\n*   `osconfigAgentVersion` (*type:* `String.t`, *default:* `nil`) - The current version of the OS Config agent running on the VM.\n*   `shortName` (*type:* `String.t`, *default:* `nil`) - The operating system short name. For example, 'windows' or 'debian'.\n*   `version` (*type:* `String.t`, *default:* `nil`) - The version of the operating system.","ref":"GoogleApi.CloudAsset.V1.Model.OsInfo.html#module-attributes"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Model.OsInfo.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.CloudAsset.V1.Model.OsInfo.html#decode/2"},{"type":"type","title":"GoogleApi.CloudAsset.V1.Model.OsInfo.t/0","doc":"","ref":"GoogleApi.CloudAsset.V1.Model.OsInfo.html#t:t/0"},{"type":"module","title":"GoogleApi.CloudAsset.V1.Model.OutputConfig","doc":"Output configuration for export assets destination.","ref":"GoogleApi.CloudAsset.V1.Model.OutputConfig.html"},{"type":"module","title":"Attributes - GoogleApi.CloudAsset.V1.Model.OutputConfig","doc":"*   `bigqueryDestination` (*type:* `GoogleApi.CloudAsset.V1.Model.BigQueryDestination.t`, *default:* `nil`) - Destination on BigQuery. The output table stores the fields in asset Protobuf as columns in BigQuery.\n*   `gcsDestination` (*type:* `GoogleApi.CloudAsset.V1.Model.GcsDestination.t`, *default:* `nil`) - Destination on Cloud Storage.","ref":"GoogleApi.CloudAsset.V1.Model.OutputConfig.html#module-attributes"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Model.OutputConfig.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.CloudAsset.V1.Model.OutputConfig.html#decode/2"},{"type":"type","title":"GoogleApi.CloudAsset.V1.Model.OutputConfig.t/0","doc":"","ref":"GoogleApi.CloudAsset.V1.Model.OutputConfig.html#t:t/0"},{"type":"module","title":"GoogleApi.CloudAsset.V1.Model.PartitionSpec","doc":"Specifications of BigQuery partitioned table as export destination.","ref":"GoogleApi.CloudAsset.V1.Model.PartitionSpec.html"},{"type":"module","title":"Attributes - GoogleApi.CloudAsset.V1.Model.PartitionSpec","doc":"*   `partitionKey` (*type:* `String.t`, *default:* `nil`) - The partition key for BigQuery partitioned table.","ref":"GoogleApi.CloudAsset.V1.Model.PartitionSpec.html#module-attributes"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Model.PartitionSpec.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.CloudAsset.V1.Model.PartitionSpec.html#decode/2"},{"type":"type","title":"GoogleApi.CloudAsset.V1.Model.PartitionSpec.t/0","doc":"","ref":"GoogleApi.CloudAsset.V1.Model.PartitionSpec.html#t:t/0"},{"type":"module","title":"GoogleApi.CloudAsset.V1.Model.Permissions","doc":"IAM permissions","ref":"GoogleApi.CloudAsset.V1.Model.Permissions.html"},{"type":"module","title":"Attributes - GoogleApi.CloudAsset.V1.Model.Permissions","doc":"*   `permissions` (*type:* `list(String.t)`, *default:* `nil`) - A list of permissions. A sample permission string: `compute.disk.get`.","ref":"GoogleApi.CloudAsset.V1.Model.Permissions.html#module-attributes"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Model.Permissions.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.CloudAsset.V1.Model.Permissions.html#decode/2"},{"type":"type","title":"GoogleApi.CloudAsset.V1.Model.Permissions.t/0","doc":"","ref":"GoogleApi.CloudAsset.V1.Model.Permissions.html#t:t/0"},{"type":"module","title":"GoogleApi.CloudAsset.V1.Model.Policy","doc":"An Identity and Access Management (IAM) policy, which specifies access controls for Google Cloud resources. A `Policy` is a collection of `bindings`. A `binding` binds one or more `members`, or principals, to a single `role`. Principals can be user accounts, service accounts, Google groups, and domains (such as G Suite). A `role` is a named list of permissions; each `role` can be an IAM predefined role or a user-created custom role. For some types of Google Cloud resources, a `binding` can also specify a `condition`, which is a logical expression that allows access to a resource only if the expression evaluates to `true`. A condition can add constraints based on attributes of the request, the resource, or both. To learn which resources support conditions in their IAM policies, see the [IAM documentation](https://cloud.google.com/iam/help/conditions/resource-policies). **JSON example:** ``` { \"bindings\": [ { \"role\": \"roles/resourcemanager.organizationAdmin\", \"members\": [ \"user:mike@example.com\", \"group:admins@example.com\", \"domain:google.com\", \"serviceAccount:my-project-id@appspot.gserviceaccount.com\" ] }, { \"role\": \"roles/resourcemanager.organizationViewer\", \"members\": [ \"user:eve@example.com\" ], \"condition\": { \"title\": \"expirable access\", \"description\": \"Does not grant access after Sep 2020\", \"expression\": \"request.time < timestamp('2020-10-01T00:00:00.000Z')\", } } ], \"etag\": \"BwWWja0YfJA=\", \"version\": 3 } ``` **YAML example:** ``` bindings: - members: - user:mike@example.com - group:admins@example.com - domain:google.com - serviceAccount:my-project-id@appspot.gserviceaccount.com role: roles/resourcemanager.organizationAdmin - members: - user:eve@example.com role: roles/resourcemanager.organizationViewer condition: title: expirable access description: Does not grant access after Sep 2020 expression: request.time < timestamp('2020-10-01T00:00:00.000Z') etag: BwWWja0YfJA= version: 3 ``` For a description of IAM and its features, see the [IAM documentation](https://cloud.google.com/iam/docs/).","ref":"GoogleApi.CloudAsset.V1.Model.Policy.html"},{"type":"module","title":"Attributes - GoogleApi.CloudAsset.V1.Model.Policy","doc":"*   `auditConfigs` (*type:* `list(GoogleApi.CloudAsset.V1.Model.AuditConfig.t)`, *default:* `nil`) - Specifies cloud audit logging configuration for this policy.\n*   `bindings` (*type:* `list(GoogleApi.CloudAsset.V1.Model.Binding.t)`, *default:* `nil`) - Associates a list of `members`, or principals, with a `role`. Optionally, may specify a `condition` that determines how and when the `bindings` are applied. Each of the `bindings` must contain at least one principal. The `bindings` in a `Policy` can refer to up to 1,500 principals; up to 250 of these principals can be Google groups. Each occurrence of a principal counts towards these limits. For example, if the `bindings` grant 50 different roles to `user:alice@example.com`, and not to any other principal, then you can add another 1,450 principals to the `bindings` in the `Policy`.\n*   `etag` (*type:* `String.t`, *default:* `nil`) - `etag` is used for optimistic concurrency control as a way to help prevent simultaneous updates of a policy from overwriting each other. It is strongly suggested that systems make use of the `etag` in the read-modify-write cycle to perform policy updates in order to avoid race conditions: An `etag` is returned in the response to `getIamPolicy`, and systems are expected to put that etag in the request to `setIamPolicy` to ensure that their change will be applied to the same version of the policy. **Important:** If you use IAM Conditions, you must include the `etag` field whenever you call `setIamPolicy`. If you omit this field, then IAM allows you to overwrite a version `3` policy with a version `1` policy, and all of the conditions in the version `3` policy are lost.\n*   `version` (*type:* `integer()`, *default:* `nil`) - Specifies the format of the policy. Valid values are `0`, `1`, and `3`. Requests that specify an invalid value are rejected. Any operation that affects conditional role bindings must specify version `3`. This requirement applies to the following operations: * Getting a policy that includes a conditional role binding * Adding a conditional role binding to a policy * Changing a conditional role binding in a policy * Removing any role binding, with or without a condition, from a policy that includes conditions **Important:** If you use IAM Conditions, you must include the `etag` field whenever you call `setIamPolicy`. If you omit this field, then IAM allows you to overwrite a version `3` policy with a version `1` policy, and all of the conditions in the version `3` policy are lost. If a policy does not include any conditions, operations on that policy may specify any valid version or leave the field unset. To learn which resources support conditions in their IAM policies, see the [IAM documentation](https://cloud.google.com/iam/help/conditions/resource-policies).","ref":"GoogleApi.CloudAsset.V1.Model.Policy.html#module-attributes"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Model.Policy.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.CloudAsset.V1.Model.Policy.html#decode/2"},{"type":"type","title":"GoogleApi.CloudAsset.V1.Model.Policy.t/0","doc":"","ref":"GoogleApi.CloudAsset.V1.Model.Policy.html#t:t/0"},{"type":"module","title":"GoogleApi.CloudAsset.V1.Model.PolicyInfo","doc":"The IAM policy and its attached resource.","ref":"GoogleApi.CloudAsset.V1.Model.PolicyInfo.html"},{"type":"module","title":"Attributes - GoogleApi.CloudAsset.V1.Model.PolicyInfo","doc":"*   `attachedResource` (*type:* `String.t`, *default:* `nil`) - The full resource name the policy is directly attached to.\n*   `policy` (*type:* `GoogleApi.CloudAsset.V1.Model.Policy.t`, *default:* `nil`) - The IAM policy that's directly attached to the attached_resource.","ref":"GoogleApi.CloudAsset.V1.Model.PolicyInfo.html#module-attributes"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Model.PolicyInfo.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.CloudAsset.V1.Model.PolicyInfo.html#decode/2"},{"type":"type","title":"GoogleApi.CloudAsset.V1.Model.PolicyInfo.t/0","doc":"","ref":"GoogleApi.CloudAsset.V1.Model.PolicyInfo.html#t:t/0"},{"type":"module","title":"GoogleApi.CloudAsset.V1.Model.PubsubDestination","doc":"A Pub/Sub destination.","ref":"GoogleApi.CloudAsset.V1.Model.PubsubDestination.html"},{"type":"module","title":"Attributes - GoogleApi.CloudAsset.V1.Model.PubsubDestination","doc":"*   `topic` (*type:* `String.t`, *default:* `nil`) - The name of the Pub/Sub topic to publish to. Example: `projects/PROJECT_ID/topics/TOPIC_ID`.","ref":"GoogleApi.CloudAsset.V1.Model.PubsubDestination.html#module-attributes"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Model.PubsubDestination.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.CloudAsset.V1.Model.PubsubDestination.html#decode/2"},{"type":"type","title":"GoogleApi.CloudAsset.V1.Model.PubsubDestination.t/0","doc":"","ref":"GoogleApi.CloudAsset.V1.Model.PubsubDestination.html#t:t/0"},{"type":"module","title":"GoogleApi.CloudAsset.V1.Model.QueryAssetsOutputConfig","doc":"Output configuration query assets.","ref":"GoogleApi.CloudAsset.V1.Model.QueryAssetsOutputConfig.html"},{"type":"module","title":"Attributes - GoogleApi.CloudAsset.V1.Model.QueryAssetsOutputConfig","doc":"*   `bigqueryDestination` (*type:* `GoogleApi.CloudAsset.V1.Model.GoogleCloudAssetV1QueryAssetsOutputConfigBigQueryDestination.t`, *default:* `nil`) - BigQuery destination where the query results will be saved.","ref":"GoogleApi.CloudAsset.V1.Model.QueryAssetsOutputConfig.html#module-attributes"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Model.QueryAssetsOutputConfig.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.CloudAsset.V1.Model.QueryAssetsOutputConfig.html#decode/2"},{"type":"type","title":"GoogleApi.CloudAsset.V1.Model.QueryAssetsOutputConfig.t/0","doc":"","ref":"GoogleApi.CloudAsset.V1.Model.QueryAssetsOutputConfig.html#t:t/0"},{"type":"module","title":"GoogleApi.CloudAsset.V1.Model.QueryAssetsRequest","doc":"QueryAssets request.","ref":"GoogleApi.CloudAsset.V1.Model.QueryAssetsRequest.html"},{"type":"module","title":"Attributes - GoogleApi.CloudAsset.V1.Model.QueryAssetsRequest","doc":"*   `jobReference` (*type:* `String.t`, *default:* `nil`) - Optional. Reference to the query job, which is from the `QueryAssetsResponse` of previous `QueryAssets` call.\n*   `outputConfig` (*type:* `GoogleApi.CloudAsset.V1.Model.QueryAssetsOutputConfig.t`, *default:* `nil`) - Optional. Destination where the query results will be saved. When this field is specified, the query results won't be saved in the [QueryAssetsResponse.query_result]. Instead [QueryAssetsResponse.output_config] will be set. Meanwhile, [QueryAssetsResponse.job_reference] will be set and can be used to check the status of the query job when passed to a following [QueryAssets] API call.\n*   `pageSize` (*type:* `integer()`, *default:* `nil`) - Optional. The maximum number of rows to return in the results. Responses are limited to 10 MB and 1000 rows. By default, the maximum row count is 1000. When the byte or row count limit is reached, the rest of the query results will be paginated. The field will be ignored when [output_config] is specified.\n*   `pageToken` (*type:* `String.t`, *default:* `nil`) - Optional. A page token received from previous `QueryAssets`. The field will be ignored when [output_config] is specified.\n*   `readTime` (*type:* `DateTime.t`, *default:* `nil`) - Optional. Queries cloud assets as they appeared at the specified point in time.\n*   `readTimeWindow` (*type:* `GoogleApi.CloudAsset.V1.Model.TimeWindow.t`, *default:* `nil`) - Optional. [start_time] is required. [start_time] must be less than [end_time] Defaults [end_time] to now if [start_time] is set and [end_time] isn't. Maximum permitted time range is 7 days.\n*   `statement` (*type:* `String.t`, *default:* `nil`) - Optional. A SQL statement that's compatible with [BigQuery SQL](https://cloud.google.com/bigquery/docs/introduction-sql).\n*   `timeout` (*type:* `String.t`, *default:* `nil`) - Optional. Specifies the maximum amount of time that the client is willing to wait for the query to complete. By default, this limit is 5 min for the first query, and 1 minute for the following queries. If the query is complete, the `done` field in the `QueryAssetsResponse` is true, otherwise false. Like BigQuery [jobs.query API](https://cloud.google.com/bigquery/docs/reference/rest/v2/jobs/query#queryrequest) The call is not guaranteed to wait for the specified timeout; it typically returns after around 200 seconds (200,000 milliseconds), even if the query is not complete. The field will be ignored when [output_config] is specified.","ref":"GoogleApi.CloudAsset.V1.Model.QueryAssetsRequest.html#module-attributes"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Model.QueryAssetsRequest.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.CloudAsset.V1.Model.QueryAssetsRequest.html#decode/2"},{"type":"type","title":"GoogleApi.CloudAsset.V1.Model.QueryAssetsRequest.t/0","doc":"","ref":"GoogleApi.CloudAsset.V1.Model.QueryAssetsRequest.html#t:t/0"},{"type":"module","title":"GoogleApi.CloudAsset.V1.Model.QueryAssetsResponse","doc":"QueryAssets response.","ref":"GoogleApi.CloudAsset.V1.Model.QueryAssetsResponse.html"},{"type":"module","title":"Attributes - GoogleApi.CloudAsset.V1.Model.QueryAssetsResponse","doc":"*   `done` (*type:* `boolean()`, *default:* `nil`) - The query response, which can be either an `error` or a valid `response`. If `done` == `false` and the query result is being saved in a output, the output_config field will be set. If `done` == `true`, exactly one of `error`, `query_result` or `output_config` will be set.\n*   `error` (*type:* `GoogleApi.CloudAsset.V1.Model.Status.t`, *default:* `nil`) - Error status.\n*   `jobReference` (*type:* `String.t`, *default:* `nil`) - Reference to a query job.\n*   `outputConfig` (*type:* `GoogleApi.CloudAsset.V1.Model.QueryAssetsOutputConfig.t`, *default:* `nil`) - Output configuration which indicates instead of being returned in API response on the fly, the query result will be saved in a specific output.\n*   `queryResult` (*type:* `GoogleApi.CloudAsset.V1.Model.QueryResult.t`, *default:* `nil`) - Result of the query.","ref":"GoogleApi.CloudAsset.V1.Model.QueryAssetsResponse.html#module-attributes"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Model.QueryAssetsResponse.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.CloudAsset.V1.Model.QueryAssetsResponse.html#decode/2"},{"type":"type","title":"GoogleApi.CloudAsset.V1.Model.QueryAssetsResponse.t/0","doc":"","ref":"GoogleApi.CloudAsset.V1.Model.QueryAssetsResponse.html#t:t/0"},{"type":"module","title":"GoogleApi.CloudAsset.V1.Model.QueryContent","doc":"The query content.","ref":"GoogleApi.CloudAsset.V1.Model.QueryContent.html"},{"type":"module","title":"Attributes - GoogleApi.CloudAsset.V1.Model.QueryContent","doc":"*   `iamPolicyAnalysisQuery` (*type:* `GoogleApi.CloudAsset.V1.Model.IamPolicyAnalysisQuery.t`, *default:* `nil`) - An IAM Policy Analysis query, which could be used in the AssetService.AnalyzeIamPolicy RPC or the AssetService.AnalyzeIamPolicyLongrunning RPC.","ref":"GoogleApi.CloudAsset.V1.Model.QueryContent.html#module-attributes"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Model.QueryContent.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.CloudAsset.V1.Model.QueryContent.html#decode/2"},{"type":"type","title":"GoogleApi.CloudAsset.V1.Model.QueryContent.t/0","doc":"","ref":"GoogleApi.CloudAsset.V1.Model.QueryContent.html#t:t/0"},{"type":"module","title":"GoogleApi.CloudAsset.V1.Model.QueryResult","doc":"Execution results of the query. The result is formatted as rows represented by BigQuery compatible [schema]. When pagination is necessary, it will contains the page token to retrieve the results of following pages.","ref":"GoogleApi.CloudAsset.V1.Model.QueryResult.html"},{"type":"module","title":"Attributes - GoogleApi.CloudAsset.V1.Model.QueryResult","doc":"*   `nextPageToken` (*type:* `String.t`, *default:* `nil`) - Token to retrieve the next page of the results.\n*   `rows` (*type:* `list(map())`, *default:* `nil`) - Each row hold a query result in the format of `Struct`.\n*   `schema` (*type:* `GoogleApi.CloudAsset.V1.Model.TableSchema.t`, *default:* `nil`) - Describes the format of the [rows].\n*   `totalRows` (*type:* `String.t`, *default:* `nil`) - Total rows of the whole query results.","ref":"GoogleApi.CloudAsset.V1.Model.QueryResult.html#module-attributes"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Model.QueryResult.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.CloudAsset.V1.Model.QueryResult.html#decode/2"},{"type":"type","title":"GoogleApi.CloudAsset.V1.Model.QueryResult.t/0","doc":"","ref":"GoogleApi.CloudAsset.V1.Model.QueryResult.html#t:t/0"},{"type":"module","title":"GoogleApi.CloudAsset.V1.Model.RelatedAsset","doc":"An asset identifier in Google Cloud which contains its name, type and ancestors. An asset can be any resource in the Google Cloud [resource hierarchy](https://cloud.google.com/resource-manager/docs/cloud-platform-resource-hierarchy), a resource outside the Google Cloud resource hierarchy (such as Google Kubernetes Engine clusters and objects), or a policy (e.g. IAM policy). See [Supported asset types](https://cloud.google.com/asset-inventory/docs/supported-asset-types) for more information.","ref":"GoogleApi.CloudAsset.V1.Model.RelatedAsset.html"},{"type":"module","title":"Attributes - GoogleApi.CloudAsset.V1.Model.RelatedAsset","doc":"*   `ancestors` (*type:* `list(String.t)`, *default:* `nil`) - The ancestors of an asset in Google Cloud [resource hierarchy](https://cloud.google.com/resource-manager/docs/cloud-platform-resource-hierarchy), represented as a list of relative resource names. An ancestry path starts with the closest ancestor in the hierarchy and ends at root. Example: `[\"projects/123456789\", \"folders/5432\", \"organizations/1234\"]`\n*   `asset` (*type:* `String.t`, *default:* `nil`) - The full name of the asset. Example: `//compute.googleapis.com/projects/my_project_123/zones/zone1/instances/instance1` See [Resource names](https://cloud.google.com/apis/design/resource_names#full_resource_name) for more information.\n*   `assetType` (*type:* `String.t`, *default:* `nil`) - The type of the asset. Example: `compute.googleapis.com/Disk` See [Supported asset types](https://cloud.google.com/asset-inventory/docs/supported-asset-types) for more information.\n*   `relationshipType` (*type:* `String.t`, *default:* `nil`) - The unique identifier of the relationship type. Example: `INSTANCE_TO_INSTANCEGROUP`","ref":"GoogleApi.CloudAsset.V1.Model.RelatedAsset.html#module-attributes"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Model.RelatedAsset.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.CloudAsset.V1.Model.RelatedAsset.html#decode/2"},{"type":"type","title":"GoogleApi.CloudAsset.V1.Model.RelatedAsset.t/0","doc":"","ref":"GoogleApi.CloudAsset.V1.Model.RelatedAsset.html#t:t/0"},{"type":"module","title":"GoogleApi.CloudAsset.V1.Model.RelatedAssets","doc":"DEPRECATED. This message only presents for the purpose of backward-compatibility. The server will never populate this message in responses. The detailed related assets with the `relationship_type`.","ref":"GoogleApi.CloudAsset.V1.Model.RelatedAssets.html"},{"type":"module","title":"Attributes - GoogleApi.CloudAsset.V1.Model.RelatedAssets","doc":"*   `assets` (*type:* `list(GoogleApi.CloudAsset.V1.Model.RelatedAsset.t)`, *default:* `nil`) - The peer resources of the relationship.\n*   `relationshipAttributes` (*type:* `GoogleApi.CloudAsset.V1.Model.RelationshipAttributes.t`, *default:* `nil`) - The detailed relationship attributes.","ref":"GoogleApi.CloudAsset.V1.Model.RelatedAssets.html#module-attributes"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Model.RelatedAssets.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.CloudAsset.V1.Model.RelatedAssets.html#decode/2"},{"type":"type","title":"GoogleApi.CloudAsset.V1.Model.RelatedAssets.t/0","doc":"","ref":"GoogleApi.CloudAsset.V1.Model.RelatedAssets.html#t:t/0"},{"type":"module","title":"GoogleApi.CloudAsset.V1.Model.RelatedResource","doc":"The detailed related resource.","ref":"GoogleApi.CloudAsset.V1.Model.RelatedResource.html"},{"type":"module","title":"Attributes - GoogleApi.CloudAsset.V1.Model.RelatedResource","doc":"*   `assetType` (*type:* `String.t`, *default:* `nil`) - The type of the asset. Example: `compute.googleapis.com/Instance`\n*   `fullResourceName` (*type:* `String.t`, *default:* `nil`) - The full resource name of the related resource. Example: `//compute.googleapis.com/projects/my_proj_123/zones/instance/instance123`","ref":"GoogleApi.CloudAsset.V1.Model.RelatedResource.html#module-attributes"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Model.RelatedResource.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.CloudAsset.V1.Model.RelatedResource.html#decode/2"},{"type":"type","title":"GoogleApi.CloudAsset.V1.Model.RelatedResource.t/0","doc":"","ref":"GoogleApi.CloudAsset.V1.Model.RelatedResource.html#t:t/0"},{"type":"module","title":"GoogleApi.CloudAsset.V1.Model.RelatedResources","doc":"The related resources of the primary resource.","ref":"GoogleApi.CloudAsset.V1.Model.RelatedResources.html"},{"type":"module","title":"Attributes - GoogleApi.CloudAsset.V1.Model.RelatedResources","doc":"*   `relatedResources` (*type:* `list(GoogleApi.CloudAsset.V1.Model.RelatedResource.t)`, *default:* `nil`) - The detailed related resources of the primary resource.","ref":"GoogleApi.CloudAsset.V1.Model.RelatedResources.html#module-attributes"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Model.RelatedResources.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.CloudAsset.V1.Model.RelatedResources.html#decode/2"},{"type":"type","title":"GoogleApi.CloudAsset.V1.Model.RelatedResources.t/0","doc":"","ref":"GoogleApi.CloudAsset.V1.Model.RelatedResources.html#t:t/0"},{"type":"module","title":"GoogleApi.CloudAsset.V1.Model.RelationshipAttributes","doc":"DEPRECATED. This message only presents for the purpose of backward-compatibility. The server will never populate this message in responses. The relationship attributes which include `type`, `source_resource_type`, `target_resource_type` and `action`.","ref":"GoogleApi.CloudAsset.V1.Model.RelationshipAttributes.html"},{"type":"module","title":"Attributes - GoogleApi.CloudAsset.V1.Model.RelationshipAttributes","doc":"*   `action` (*type:* `String.t`, *default:* `nil`) - The detail of the relationship, e.g. `contains`, `attaches`\n*   `sourceResourceType` (*type:* `String.t`, *default:* `nil`) - The source asset type. Example: `compute.googleapis.com/Instance`\n*   `targetResourceType` (*type:* `String.t`, *default:* `nil`) - The target asset type. Example: `compute.googleapis.com/Disk`\n*   `type` (*type:* `String.t`, *default:* `nil`) - The unique identifier of the relationship type. Example: `INSTANCE_TO_INSTANCEGROUP`","ref":"GoogleApi.CloudAsset.V1.Model.RelationshipAttributes.html#module-attributes"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Model.RelationshipAttributes.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.CloudAsset.V1.Model.RelationshipAttributes.html#decode/2"},{"type":"type","title":"GoogleApi.CloudAsset.V1.Model.RelationshipAttributes.t/0","doc":"","ref":"GoogleApi.CloudAsset.V1.Model.RelationshipAttributes.html#t:t/0"},{"type":"module","title":"GoogleApi.CloudAsset.V1.Model.Resource","doc":"A representation of a Google Cloud resource.","ref":"GoogleApi.CloudAsset.V1.Model.Resource.html"},{"type":"module","title":"Attributes - GoogleApi.CloudAsset.V1.Model.Resource","doc":"*   `data` (*type:* `map()`, *default:* `nil`) - The content of the resource, in which some sensitive fields are removed and may not be present.\n*   `discoveryDocumentUri` (*type:* `String.t`, *default:* `nil`) - The URL of the discovery document containing the resource's JSON schema. Example: `https://www.googleapis.com/discovery/v1/apis/compute/v1/rest` This value is unspecified for resources that do not have an API based on a discovery document, such as Cloud Bigtable.\n*   `discoveryName` (*type:* `String.t`, *default:* `nil`) - The JSON schema name listed in the discovery document. Example: `Project` This value is unspecified for resources that do not have an API based on a discovery document, such as Cloud Bigtable.\n*   `location` (*type:* `String.t`, *default:* `nil`) - The location of the resource in Google Cloud, such as its zone and region. For more information, see https://cloud.google.com/about/locations/.\n*   `parent` (*type:* `String.t`, *default:* `nil`) - The full name of the immediate parent of this resource. See [Resource Names](https://cloud.google.com/apis/design/resource_names#full_resource_name) for more information. For Google Cloud assets, this value is the parent resource defined in the [IAM policy hierarchy](https://cloud.google.com/iam/docs/overview#policy_hierarchy). Example: `//cloudresourcemanager.googleapis.com/projects/my_project_123`\n*   `resourceUrl` (*type:* `String.t`, *default:* `nil`) - The REST URL for accessing the resource. An HTTP `GET` request using this URL returns the resource itself. Example: `https://cloudresourcemanager.googleapis.com/v1/projects/my-project-123` This value is unspecified for resources without a REST API.\n*   `version` (*type:* `String.t`, *default:* `nil`) - The API version. Example: `v1`","ref":"GoogleApi.CloudAsset.V1.Model.Resource.html#module-attributes"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Model.Resource.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.CloudAsset.V1.Model.Resource.html#decode/2"},{"type":"type","title":"GoogleApi.CloudAsset.V1.Model.Resource.t/0","doc":"","ref":"GoogleApi.CloudAsset.V1.Model.Resource.html#t:t/0"},{"type":"module","title":"GoogleApi.CloudAsset.V1.Model.ResourceSearchResult","doc":"A result of Resource Search, containing information of a cloud resource.","ref":"GoogleApi.CloudAsset.V1.Model.ResourceSearchResult.html"},{"type":"module","title":"Attributes - GoogleApi.CloudAsset.V1.Model.ResourceSearchResult","doc":"*   `additionalAttributes` (*type:* `map()`, *default:* `nil`) - The additional searchable attributes of this resource. The attributes may vary from one resource type to another. Examples: `projectId` for Project, `dnsName` for DNS ManagedZone. This field contains a subset of the resource metadata fields that are returned by the List or Get APIs provided by the corresponding Google Cloud service (e.g., Compute Engine). see [API references and supported searchable attributes](https://cloud.google.com/asset-inventory/docs/supported-asset-types) to see which fields are included. You can search values of these fields through free text search. However, you should not consume the field programically as the field names and values may change as the Google Cloud service updates to a new incompatible API version. To search against the `additional_attributes`: * Use a free text query to match the attributes values. Example: to search `additional_attributes = { dnsName: \"foobar\" }`, you can issue a query `foobar`.\n*   `assetType` (*type:* `String.t`, *default:* `nil`) - The type of this resource. Example: `compute.googleapis.com/Disk`. To search against the `asset_type`: * Specify the `asset_type` field in your search request.\n*   `attachedResources` (*type:* `list(GoogleApi.CloudAsset.V1.Model.AttachedResource.t)`, *default:* `nil`) - Attached resources of this resource. For example, an OSConfig Inventory is an attached resource of a Compute Instance. This field is repeated because a resource could have multiple attached resources. This `attached_resources` field is not searchable. Some attributes of the attached resources are exposed in `additional_attributes` field, so as to allow users to search on them.\n*   `createTime` (*type:* `DateTime.t`, *default:* `nil`) - The create timestamp of this resource, at which the resource was created. The granularity is in seconds. Timestamp.nanos will always be 0. This field is available only when the resource's Protobuf contains it. To search against `create_time`: * Use a field query. - value in seconds since unix epoch. Example: `createTime > 1609459200` - value in date string. Example: `createTime > 2021-01-01` - value in date-time string (must be quoted). Example: `createTime > \"2021-01-01T00:00:00\"`\n*   `description` (*type:* `String.t`, *default:* `nil`) - One or more paragraphs of text description of this resource. Maximum length could be up to 1M bytes. This field is available only when the resource's Protobuf contains it. To search against the `description`: * Use a field query. Example: `description:\"important instance\"` * Use a free text query. Example: `\"important instance\"`\n*   `displayName` (*type:* `String.t`, *default:* `nil`) - The display name of this resource. This field is available only when the resource's Protobuf contains it. To search against the `display_name`: * Use a field query. Example: `displayName:\"My Instance\"` * Use a free text query. Example: `\"My Instance\"`\n*   `effectiveTags` (*type:* `list(GoogleApi.CloudAsset.V1.Model.EffectiveTagDetails.t)`, *default:* `nil`) - The effective tags on this resource. All of the tags that are both attached to and inherited by a resource are collectively called the effective tags. For more information, see [tag inheritance](https://cloud.google.com/resource-manager/docs/tags/tags-overview#inheritance). To search against the `effective_tags`: * Use a field query. Example: - `effectiveTagKeys:\"123456789/env*\"` - `effectiveTagKeys=\"123456789/env\"` - `effectiveTagKeys:\"env\"` - `effectiveTagKeyIds=\"tagKeys/123\"` - `effectiveTagValues:\"env\"` - `effectiveTagValues:\"env/prod\"` - `effectiveTagValues:\"123456789/env/prod*\"` - `effectiveTagValues=\"123456789/env/prod\"` - `effectiveTagValueIds=\"tagValues/456\"`\n*   `folders` (*type:* `list(String.t)`, *default:* `nil`) - The folder(s) that this resource belongs to, in the form of folders/{FOLDER_NUMBER}. This field is available when the resource belongs to one or more folders. To search against `folders`: * Use a field query. Example: `folders:(123 OR 456)` * Use a free text query. Example: `123` * Specify the `scope` field as this folder in your search request.\n*   `kmsKey` (*type:* `String.t`, *default:* `nil`) - The Cloud KMS [CryptoKey](https://cloud.google.com/kms/docs/reference/rest/v1/projects.locations.keyRings.cryptoKeys) name or [CryptoKeyVersion](https://cloud.google.com/kms/docs/reference/rest/v1/projects.locations.keyRings.cryptoKeys.cryptoKeyVersions) name. This field only presents for the purpose of backward compatibility. Use the `kms_keys` field to retrieve Cloud KMS key information. This field is available only when the resource's Protobuf contains it and will only be populated for [these resource types](https://cloud.google.com/asset-inventory/docs/legacy-field-names#resource_types_with_the_to_be_deprecated_kmskey_field) for backward compatible purposes. To search against the `kms_key`: * Use a field query. Example: `kmsKey:key` * Use a free text query. Example: `key`\n*   `kmsKeys` (*type:* `list(String.t)`, *default:* `nil`) - The Cloud KMS [CryptoKey](https://cloud.google.com/kms/docs/reference/rest/v1/projects.locations.keyRings.cryptoKeys) names or [CryptoKeyVersion](https://cloud.google.com/kms/docs/reference/rest/v1/projects.locations.keyRings.cryptoKeys.cryptoKeyVersions) names. This field is available only when the resource's Protobuf contains it. To search against the `kms_keys`: * Use a field query. Example: `kmsKeys:key` * Use a free text query. Example: `key`\n*   `labels` (*type:* `map()`, *default:* `nil`) - User labels associated with this resource. See [Labelling and grouping Google Cloud resources](https://cloud.google.com/blog/products/gcp/labelling-and-grouping-your-google-cloud-platform-resources) for more information. This field is available only when the resource's Protobuf contains it. To search against the `labels`: * Use a field query: - query on any label's key or value. Example: `labels:prod` - query by a given label. Example: `labels.env:prod` - query by a given label's existence. Example: `labels.env:*` * Use a free text query. Example: `prod`\n*   `location` (*type:* `String.t`, *default:* `nil`) - Location can be `global`, regional like `us-east1`, or zonal like `us-west1-b`. This field is available only when the resource's Protobuf contains it. To search against the `location`: * Use a field query. Example: `location:us-west*` * Use a free text query. Example: `us-west*`\n*   `name` (*type:* `String.t`, *default:* `nil`) - The full resource name of this resource. Example: `//compute.googleapis.com/projects/my_project_123/zones/zone1/instances/instance1`. See [Cloud Asset Inventory Resource Name Format](https://cloud.google.com/asset-inventory/docs/resource-name-format) for more information. To search against the `name`: * Use a field query. Example: `name:instance1` * Use a free text query. Example: `instance1`\n*   `networkTags` (*type:* `list(String.t)`, *default:* `nil`) - Network tags associated with this resource. Like labels, network tags are a type of annotations used to group Google Cloud resources. See [Labelling Google Cloud resources](https://cloud.google.com/blog/products/gcp/labelling-and-grouping-your-google-cloud-platform-resources) for more information. This field is available only when the resource's Protobuf contains it. To search against the `network_tags`: * Use a field query. Example: `networkTags:internal` * Use a free text query. Example: `internal`\n*   `organization` (*type:* `String.t`, *default:* `nil`) - The organization that this resource belongs to, in the form of organizations/{ORGANIZATION_NUMBER}. This field is available when the resource belongs to an organization. To search against `organization`: * Use a field query. Example: `organization:123` * Use a free text query. Example: `123` * Specify the `scope` field as this organization in your search request.\n*   `parentAssetType` (*type:* `String.t`, *default:* `nil`) - The type of this resource's immediate parent, if there is one. To search against the `parent_asset_type`: * Use a field query. Example: `parentAssetType:\"cloudresourcemanager.googleapis.com/Project\"` * Use a free text query. Example: `cloudresourcemanager.googleapis.com/Project`\n*   `parentFullResourceName` (*type:* `String.t`, *default:* `nil`) - The full resource name of this resource's parent, if it has one. To search against the `parent_full_resource_name`: * Use a field query. Example: `parentFullResourceName:\"project-name\"` * Use a free text query. Example: `project-name`\n*   `project` (*type:* `String.t`, *default:* `nil`) - The project that this resource belongs to, in the form of projects/{PROJECT_NUMBER}. This field is available when the resource belongs to a project. To search against `project`: * Use a field query. Example: `project:12345` * Use a free text query. Example: `12345` * Specify the `scope` field as this project in your search request.\n*   `relationships` (*type:* `%{optional(String.t) => GoogleApi.CloudAsset.V1.Model.RelatedResources.t}`, *default:* `nil`) - A map of related resources of this resource, keyed by the relationship type. A relationship type is in the format of {SourceType}_{ACTION}_{DestType}. Example: `DISK_TO_INSTANCE`, `DISK_TO_NETWORK`, `INSTANCE_TO_INSTANCEGROUP`. See [supported relationship types](https://cloud.google.com/asset-inventory/docs/supported-asset-types#supported_relationship_types).\n*   `sccSecurityMarks` (*type:* `map()`, *default:* `nil`) - The actual content of Security Command Center security marks associated with the asset. To search against SCC SecurityMarks field: * Use a field query: - query by a given key value pair. Example: `sccSecurityMarks.foo=bar` - query by a given key's existence. Example: `sccSecurityMarks.foo:*`\n*   `state` (*type:* `String.t`, *default:* `nil`) - The state of this resource. Different resources types have different state definitions that are mapped from various fields of different resource types. This field is available only when the resource's Protobuf contains it. Example: If the resource is an instance provided by Compute Engine, its state will include PROVISIONING, STAGING, RUNNING, STOPPING, SUSPENDING, SUSPENDED, REPAIRING, and TERMINATED. See `status` definition in [API Reference](https://cloud.google.com/compute/docs/reference/rest/v1/instances). If the resource is a project provided by Resource Manager, its state will include LIFECYCLE_STATE_UNSPECIFIED, ACTIVE, DELETE_REQUESTED and DELETE_IN_PROGRESS. See `lifecycleState` definition in [API Reference](https://cloud.google.com/resource-manager/reference/rest/v1/projects). To search against the `state`: * Use a field query. Example: `state:RUNNING` * Use a free text query. Example: `RUNNING`\n*   `tagKeys` (*type:* `list(String.t)`, *default:* `nil`) - This field is only present for the purpose of backward compatibility. Use the `tags` field instead. TagKey namespaced names, in the format of {ORG_ID}/{TAG_KEY_SHORT_NAME}. To search against the `tagKeys`: * Use a field query. Example: - `tagKeys:\"123456789/env*\"` - `tagKeys=\"123456789/env\"` - `tagKeys:\"env\"` * Use a free text query. Example: - `env`\n*   `tagValueIds` (*type:* `list(String.t)`, *default:* `nil`) - This field is only present for the purpose of backward compatibility. Use the `tags` field instead. TagValue IDs, in the format of tagValues/{TAG_VALUE_ID}. To search against the `tagValueIds`: * Use a field query. Example: - `tagValueIds=\"tagValues/456\"` * Use a free text query. Example: - `456`\n*   `tagValues` (*type:* `list(String.t)`, *default:* `nil`) - This field is only present for the purpose of backward compatibility. Use the `tags` field instead. TagValue namespaced names, in the format of {ORG_ID}/{TAG_KEY_SHORT_NAME}/{TAG_VALUE_SHORT_NAME}. To search against the `tagValues`: * Use a field query. Example: - `tagValues:\"env\"` - `tagValues:\"env/prod\"` - `tagValues:\"123456789/env/prod*\"` - `tagValues=\"123456789/env/prod\"` * Use a free text query. Example: - `prod`\n*   `tags` (*type:* `list(GoogleApi.CloudAsset.V1.Model.Tag.t)`, *default:* `nil`) - The tags directly attached to this resource. To search against the `tags`: * Use a field query. Example: - `tagKeys:\"123456789/env*\"` - `tagKeys=\"123456789/env\"` - `tagKeys:\"env\"` - `tagKeyIds=\"tagKeys/123\"` - `tagValues:\"env\"` - `tagValues:\"env/prod\"` - `tagValues:\"123456789/env/prod*\"` - `tagValues=\"123456789/env/prod\"` - `tagValueIds=\"tagValues/456\"` * Use a free text query. Example: - `env/prod`\n*   `updateTime` (*type:* `DateTime.t`, *default:* `nil`) - The last update timestamp of this resource, at which the resource was last modified or deleted. The granularity is in seconds. Timestamp.nanos will always be 0. This field is available only when the resource's Protobuf contains it. To search against `update_time`: * Use a field query. - value in seconds since unix epoch. Example: `updateTime < 1609459200` - value in date string. Example: `updateTime < 2021-01-01` - value in date-time string (must be quoted). Example: `updateTime < \"2021-01-01T00:00:00\"`\n*   `versionedResources` (*type:* `list(GoogleApi.CloudAsset.V1.Model.VersionedResource.t)`, *default:* `nil`) - Versioned resource representations of this resource. This is repeated because there could be multiple versions of resource representations during version migration. This `versioned_resources` field is not searchable. Some attributes of the resource representations are exposed in `additional_attributes` field, so as to allow users to search on them.","ref":"GoogleApi.CloudAsset.V1.Model.ResourceSearchResult.html#module-attributes"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Model.ResourceSearchResult.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.CloudAsset.V1.Model.ResourceSearchResult.html#decode/2"},{"type":"type","title":"GoogleApi.CloudAsset.V1.Model.ResourceSearchResult.t/0","doc":"","ref":"GoogleApi.CloudAsset.V1.Model.ResourceSearchResult.html#t:t/0"},{"type":"module","title":"GoogleApi.CloudAsset.V1.Model.ResourceSelector","doc":"Specifies the resource to analyze for access policies, which may be set directly on the resource, or on ancestors such as organizations, folders or projects.","ref":"GoogleApi.CloudAsset.V1.Model.ResourceSelector.html"},{"type":"module","title":"Attributes - GoogleApi.CloudAsset.V1.Model.ResourceSelector","doc":"*   `fullResourceName` (*type:* `String.t`, *default:* `nil`) - Required. The [full resource name] (https://cloud.google.com/asset-inventory/docs/resource-name-format) of a resource of [supported resource types](https://cloud.google.com/asset-inventory/docs/supported-asset-types#analyzable_asset_types).","ref":"GoogleApi.CloudAsset.V1.Model.ResourceSelector.html#module-attributes"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Model.ResourceSelector.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.CloudAsset.V1.Model.ResourceSelector.html#decode/2"},{"type":"type","title":"GoogleApi.CloudAsset.V1.Model.ResourceSelector.t/0","doc":"","ref":"GoogleApi.CloudAsset.V1.Model.ResourceSelector.html#t:t/0"},{"type":"module","title":"GoogleApi.CloudAsset.V1.Model.SavedQuery","doc":"A saved query which can be shared with others or used later.","ref":"GoogleApi.CloudAsset.V1.Model.SavedQuery.html"},{"type":"module","title":"Attributes - GoogleApi.CloudAsset.V1.Model.SavedQuery","doc":"*   `content` (*type:* `GoogleApi.CloudAsset.V1.Model.QueryContent.t`, *default:* `nil`) - The query content.\n*   `createTime` (*type:* `DateTime.t`, *default:* `nil`) - Output only. The create time of this saved query.\n*   `creator` (*type:* `String.t`, *default:* `nil`) - Output only. The account's email address who has created this saved query.\n*   `description` (*type:* `String.t`, *default:* `nil`) - The description of this saved query. This value should be fewer than 255 characters.\n*   `labels` (*type:* `map()`, *default:* `nil`) - Labels applied on the resource. This value should not contain more than 10 entries. The key and value of each entry must be non-empty and fewer than 64 characters.\n*   `lastUpdateTime` (*type:* `DateTime.t`, *default:* `nil`) - Output only. The last update time of this saved query.\n*   `lastUpdater` (*type:* `String.t`, *default:* `nil`) - Output only. The account's email address who has updated this saved query most recently.\n*   `name` (*type:* `String.t`, *default:* `nil`) - The resource name of the saved query. The format must be: * projects/project_number/savedQueries/saved_query_id * folders/folder_number/savedQueries/saved_query_id * organizations/organization_number/savedQueries/saved_query_id","ref":"GoogleApi.CloudAsset.V1.Model.SavedQuery.html#module-attributes"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Model.SavedQuery.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.CloudAsset.V1.Model.SavedQuery.html#decode/2"},{"type":"type","title":"GoogleApi.CloudAsset.V1.Model.SavedQuery.t/0","doc":"","ref":"GoogleApi.CloudAsset.V1.Model.SavedQuery.html#t:t/0"},{"type":"module","title":"GoogleApi.CloudAsset.V1.Model.SearchAllIamPoliciesResponse","doc":"Search all IAM policies response.","ref":"GoogleApi.CloudAsset.V1.Model.SearchAllIamPoliciesResponse.html"},{"type":"module","title":"Attributes - GoogleApi.CloudAsset.V1.Model.SearchAllIamPoliciesResponse","doc":"*   `nextPageToken` (*type:* `String.t`, *default:* `nil`) - Set if there are more results than those appearing in this response; to get the next set of results, call this method again, using this value as the `page_token`.\n*   `results` (*type:* `list(GoogleApi.CloudAsset.V1.Model.IamPolicySearchResult.t)`, *default:* `nil`) - A list of IAM policies that match the search query. Related information such as the associated resource is returned along with the policy.","ref":"GoogleApi.CloudAsset.V1.Model.SearchAllIamPoliciesResponse.html#module-attributes"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Model.SearchAllIamPoliciesResponse.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.CloudAsset.V1.Model.SearchAllIamPoliciesResponse.html#decode/2"},{"type":"type","title":"GoogleApi.CloudAsset.V1.Model.SearchAllIamPoliciesResponse.t/0","doc":"","ref":"GoogleApi.CloudAsset.V1.Model.SearchAllIamPoliciesResponse.html#t:t/0"},{"type":"module","title":"GoogleApi.CloudAsset.V1.Model.SearchAllResourcesResponse","doc":"Search all resources response.","ref":"GoogleApi.CloudAsset.V1.Model.SearchAllResourcesResponse.html"},{"type":"module","title":"Attributes - GoogleApi.CloudAsset.V1.Model.SearchAllResourcesResponse","doc":"*   `nextPageToken` (*type:* `String.t`, *default:* `nil`) - If there are more results than those appearing in this response, then `next_page_token` is included. To get the next set of results, call this method again using the value of `next_page_token` as `page_token`.\n*   `results` (*type:* `list(GoogleApi.CloudAsset.V1.Model.ResourceSearchResult.t)`, *default:* `nil`) - A list of Resources that match the search query. It contains the resource standard metadata information.","ref":"GoogleApi.CloudAsset.V1.Model.SearchAllResourcesResponse.html#module-attributes"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Model.SearchAllResourcesResponse.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.CloudAsset.V1.Model.SearchAllResourcesResponse.html#decode/2"},{"type":"type","title":"GoogleApi.CloudAsset.V1.Model.SearchAllResourcesResponse.t/0","doc":"","ref":"GoogleApi.CloudAsset.V1.Model.SearchAllResourcesResponse.html#t:t/0"},{"type":"module","title":"GoogleApi.CloudAsset.V1.Model.SoftwarePackage","doc":"Software package information of the operating system.","ref":"GoogleApi.CloudAsset.V1.Model.SoftwarePackage.html"},{"type":"module","title":"Attributes - GoogleApi.CloudAsset.V1.Model.SoftwarePackage","doc":"*   `aptPackage` (*type:* `GoogleApi.CloudAsset.V1.Model.VersionedPackage.t`, *default:* `nil`) - Details of an APT package. For details about the apt package manager, see https://wiki.debian.org/Apt.\n*   `cosPackage` (*type:* `GoogleApi.CloudAsset.V1.Model.VersionedPackage.t`, *default:* `nil`) - Details of a COS package.\n*   `googetPackage` (*type:* `GoogleApi.CloudAsset.V1.Model.VersionedPackage.t`, *default:* `nil`) - Details of a Googet package. For details about the googet package manager, see https://github.com/google/googet.\n*   `qfePackage` (*type:* `GoogleApi.CloudAsset.V1.Model.WindowsQuickFixEngineeringPackage.t`, *default:* `nil`) - Details of a Windows Quick Fix engineering package. See https://docs.microsoft.com/en-us/windows/win32/cimwin32prov/win32-quickfixengineering for info in Windows Quick Fix Engineering.\n*   `windowsApplication` (*type:* `GoogleApi.CloudAsset.V1.Model.WindowsApplication.t`, *default:* `nil`) - Details of Windows Application.\n*   `wuaPackage` (*type:* `GoogleApi.CloudAsset.V1.Model.WindowsUpdatePackage.t`, *default:* `nil`) - Details of a Windows Update package. See https://docs.microsoft.com/en-us/windows/win32/api/_wua/ for information about Windows Update.\n*   `yumPackage` (*type:* `GoogleApi.CloudAsset.V1.Model.VersionedPackage.t`, *default:* `nil`) - Yum package info. For details about the yum package manager, see https://access.redhat.com/documentation/en-us/red_hat_enterprise_linux/6/html/deployment_guide/ch-yum.\n*   `zypperPackage` (*type:* `GoogleApi.CloudAsset.V1.Model.VersionedPackage.t`, *default:* `nil`) - Details of a Zypper package. For details about the Zypper package manager, see https://en.opensuse.org/SDB:Zypper_manual.\n*   `zypperPatch` (*type:* `GoogleApi.CloudAsset.V1.Model.ZypperPatch.t`, *default:* `nil`) - Details of a Zypper patch. For details about the Zypper package manager, see https://en.opensuse.org/SDB:Zypper_manual.","ref":"GoogleApi.CloudAsset.V1.Model.SoftwarePackage.html#module-attributes"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Model.SoftwarePackage.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.CloudAsset.V1.Model.SoftwarePackage.html#decode/2"},{"type":"type","title":"GoogleApi.CloudAsset.V1.Model.SoftwarePackage.t/0","doc":"","ref":"GoogleApi.CloudAsset.V1.Model.SoftwarePackage.html#t:t/0"},{"type":"module","title":"GoogleApi.CloudAsset.V1.Model.Status","doc":"The `Status` type defines a logical error model that is suitable for different programming environments, including REST APIs and RPC APIs. It is used by [gRPC](https://github.com/grpc). Each `Status` message contains three pieces of data: error code, error message, and error details. You can find out more about this error model and how to work with it in the [API Design Guide](https://cloud.google.com/apis/design/errors).","ref":"GoogleApi.CloudAsset.V1.Model.Status.html"},{"type":"module","title":"Attributes - GoogleApi.CloudAsset.V1.Model.Status","doc":"*   `code` (*type:* `integer()`, *default:* `nil`) - The status code, which should be an enum value of google.rpc.Code.\n*   `details` (*type:* `list(map())`, *default:* `nil`) - A list of messages that carry the error details. There is a common set of message types for APIs to use.\n*   `message` (*type:* `String.t`, *default:* `nil`) - A developer-facing error message, which should be in English. Any user-facing error message should be localized and sent in the google.rpc.Status.details field, or localized by the client.","ref":"GoogleApi.CloudAsset.V1.Model.Status.html#module-attributes"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Model.Status.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.CloudAsset.V1.Model.Status.html#decode/2"},{"type":"type","title":"GoogleApi.CloudAsset.V1.Model.Status.t/0","doc":"","ref":"GoogleApi.CloudAsset.V1.Model.Status.html#t:t/0"},{"type":"module","title":"GoogleApi.CloudAsset.V1.Model.TableFieldSchema","doc":"A field in TableSchema.","ref":"GoogleApi.CloudAsset.V1.Model.TableFieldSchema.html"},{"type":"module","title":"Attributes - GoogleApi.CloudAsset.V1.Model.TableFieldSchema","doc":"*   `field` (*type:* `String.t`, *default:* `nil`) - The field name. The name must contain only letters (a-z, A-Z), numbers (0-9), or underscores (_), and must start with a letter or underscore. The maximum length is 128 characters.\n*   `fields` (*type:* `list(GoogleApi.CloudAsset.V1.Model.TableFieldSchema.t)`, *default:* `nil`) - Describes the nested schema fields if the type property is set to RECORD.\n*   `mode` (*type:* `String.t`, *default:* `nil`) - The field mode. Possible values include NULLABLE, REQUIRED and REPEATED. The default value is NULLABLE.\n*   `type` (*type:* `String.t`, *default:* `nil`) - The field data type. Possible values include * STRING * BYTES * INTEGER * FLOAT * BOOLEAN * TIMESTAMP * DATE * TIME * DATETIME * GEOGRAPHY, * NUMERIC, * BIGNUMERIC, * RECORD (where RECORD indicates that the field contains a nested schema).","ref":"GoogleApi.CloudAsset.V1.Model.TableFieldSchema.html#module-attributes"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Model.TableFieldSchema.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.CloudAsset.V1.Model.TableFieldSchema.html#decode/2"},{"type":"type","title":"GoogleApi.CloudAsset.V1.Model.TableFieldSchema.t/0","doc":"","ref":"GoogleApi.CloudAsset.V1.Model.TableFieldSchema.html#t:t/0"},{"type":"module","title":"GoogleApi.CloudAsset.V1.Model.TableSchema","doc":"BigQuery Compatible table schema.","ref":"GoogleApi.CloudAsset.V1.Model.TableSchema.html"},{"type":"module","title":"Attributes - GoogleApi.CloudAsset.V1.Model.TableSchema","doc":"*   `fields` (*type:* `list(GoogleApi.CloudAsset.V1.Model.TableFieldSchema.t)`, *default:* `nil`) - Describes the fields in a table.","ref":"GoogleApi.CloudAsset.V1.Model.TableSchema.html#module-attributes"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Model.TableSchema.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.CloudAsset.V1.Model.TableSchema.html#decode/2"},{"type":"type","title":"GoogleApi.CloudAsset.V1.Model.TableSchema.t/0","doc":"","ref":"GoogleApi.CloudAsset.V1.Model.TableSchema.html#t:t/0"},{"type":"module","title":"GoogleApi.CloudAsset.V1.Model.Tag","doc":"The key and value for a [tag](https://cloud.google.com/resource-manager/docs/tags/tags-overview).","ref":"GoogleApi.CloudAsset.V1.Model.Tag.html"},{"type":"module","title":"Attributes - GoogleApi.CloudAsset.V1.Model.Tag","doc":"*   `tagKey` (*type:* `String.t`, *default:* `nil`) - TagKey namespaced name, in the format of {ORG_ID}/{TAG_KEY_SHORT_NAME}.\n*   `tagKeyId` (*type:* `String.t`, *default:* `nil`) - TagKey ID, in the format of tagKeys/{TAG_KEY_ID}.\n*   `tagValue` (*type:* `String.t`, *default:* `nil`) - TagValue namespaced name, in the format of {ORG_ID}/{TAG_KEY_SHORT_NAME}/{TAG_VALUE_SHORT_NAME}.\n*   `tagValueId` (*type:* `String.t`, *default:* `nil`) - TagValue ID, in the format of tagValues/{TAG_VALUE_ID}.","ref":"GoogleApi.CloudAsset.V1.Model.Tag.html#module-attributes"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Model.Tag.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.CloudAsset.V1.Model.Tag.html#decode/2"},{"type":"type","title":"GoogleApi.CloudAsset.V1.Model.Tag.t/0","doc":"","ref":"GoogleApi.CloudAsset.V1.Model.Tag.html#t:t/0"},{"type":"module","title":"GoogleApi.CloudAsset.V1.Model.TemporalAsset","doc":"An asset in Google Cloud and its temporal metadata, including the time window when it was observed and its status during that window.","ref":"GoogleApi.CloudAsset.V1.Model.TemporalAsset.html"},{"type":"module","title":"Attributes - GoogleApi.CloudAsset.V1.Model.TemporalAsset","doc":"*   `asset` (*type:* `GoogleApi.CloudAsset.V1.Model.Asset.t`, *default:* `nil`) - An asset in Google Cloud.\n*   `deleted` (*type:* `boolean()`, *default:* `nil`) - Whether the asset has been deleted or not.\n*   `priorAsset` (*type:* `GoogleApi.CloudAsset.V1.Model.Asset.t`, *default:* `nil`) - Prior copy of the asset. Populated if prior_asset_state is PRESENT. Currently this is only set for responses in Real-Time Feed.\n*   `priorAssetState` (*type:* `String.t`, *default:* `nil`) - State of prior_asset.\n*   `window` (*type:* `GoogleApi.CloudAsset.V1.Model.TimeWindow.t`, *default:* `nil`) - The time window when the asset data and state was observed.","ref":"GoogleApi.CloudAsset.V1.Model.TemporalAsset.html#module-attributes"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Model.TemporalAsset.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.CloudAsset.V1.Model.TemporalAsset.html#decode/2"},{"type":"type","title":"GoogleApi.CloudAsset.V1.Model.TemporalAsset.t/0","doc":"","ref":"GoogleApi.CloudAsset.V1.Model.TemporalAsset.html#t:t/0"},{"type":"module","title":"GoogleApi.CloudAsset.V1.Model.TimeWindow","doc":"A time window specified by its `start_time` and `end_time`.","ref":"GoogleApi.CloudAsset.V1.Model.TimeWindow.html"},{"type":"module","title":"Attributes - GoogleApi.CloudAsset.V1.Model.TimeWindow","doc":"*   `endTime` (*type:* `DateTime.t`, *default:* `nil`) - End time of the time window (inclusive). If not specified, the current timestamp is used instead.\n*   `startTime` (*type:* `DateTime.t`, *default:* `nil`) - Start time of the time window (exclusive).","ref":"GoogleApi.CloudAsset.V1.Model.TimeWindow.html#module-attributes"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Model.TimeWindow.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.CloudAsset.V1.Model.TimeWindow.html#decode/2"},{"type":"type","title":"GoogleApi.CloudAsset.V1.Model.TimeWindow.t/0","doc":"","ref":"GoogleApi.CloudAsset.V1.Model.TimeWindow.html#t:t/0"},{"type":"module","title":"GoogleApi.CloudAsset.V1.Model.UpdateFeedRequest","doc":"Update asset feed request.","ref":"GoogleApi.CloudAsset.V1.Model.UpdateFeedRequest.html"},{"type":"module","title":"Attributes - GoogleApi.CloudAsset.V1.Model.UpdateFeedRequest","doc":"*   `feed` (*type:* `GoogleApi.CloudAsset.V1.Model.Feed.t`, *default:* `nil`) - Required. The new values of feed details. It must match an existing feed and the field `name` must be in the format of: projects/project_number/feeds/feed_id or folders/folder_number/feeds/feed_id or organizations/organization_number/feeds/feed_id.\n*   `updateMask` (*type:* `String.t`, *default:* `nil`) - Required. Only updates the `feed` fields indicated by this mask. The field mask must not be empty, and it must not contain fields that are immutable or only set by the server.","ref":"GoogleApi.CloudAsset.V1.Model.UpdateFeedRequest.html#module-attributes"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Model.UpdateFeedRequest.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.CloudAsset.V1.Model.UpdateFeedRequest.html#decode/2"},{"type":"type","title":"GoogleApi.CloudAsset.V1.Model.UpdateFeedRequest.t/0","doc":"","ref":"GoogleApi.CloudAsset.V1.Model.UpdateFeedRequest.html#t:t/0"},{"type":"module","title":"GoogleApi.CloudAsset.V1.Model.VersionedPackage","doc":"Information related to the a standard versioned package. This includes package info for APT, Yum, Zypper, and Googet package managers.","ref":"GoogleApi.CloudAsset.V1.Model.VersionedPackage.html"},{"type":"module","title":"Attributes - GoogleApi.CloudAsset.V1.Model.VersionedPackage","doc":"*   `architecture` (*type:* `String.t`, *default:* `nil`) - The system architecture this package is intended for.\n*   `packageName` (*type:* `String.t`, *default:* `nil`) - The name of the package.\n*   `version` (*type:* `String.t`, *default:* `nil`) - The version of the package.","ref":"GoogleApi.CloudAsset.V1.Model.VersionedPackage.html#module-attributes"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Model.VersionedPackage.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.CloudAsset.V1.Model.VersionedPackage.html#decode/2"},{"type":"type","title":"GoogleApi.CloudAsset.V1.Model.VersionedPackage.t/0","doc":"","ref":"GoogleApi.CloudAsset.V1.Model.VersionedPackage.html#t:t/0"},{"type":"module","title":"GoogleApi.CloudAsset.V1.Model.VersionedResource","doc":"Resource representation as defined by the corresponding service providing the resource for a given API version.","ref":"GoogleApi.CloudAsset.V1.Model.VersionedResource.html"},{"type":"module","title":"Attributes - GoogleApi.CloudAsset.V1.Model.VersionedResource","doc":"*   `resource` (*type:* `map()`, *default:* `nil`) - JSON representation of the resource as defined by the corresponding service providing this resource. Example: If the resource is an instance provided by Compute Engine, this field will contain the JSON representation of the instance as defined by Compute Engine: `https://cloud.google.com/compute/docs/reference/rest/v1/instances`. You can find the resource definition for each supported resource type in this table: `https://cloud.google.com/asset-inventory/docs/supported-asset-types`\n*   `version` (*type:* `String.t`, *default:* `nil`) - API version of the resource. Example: If the resource is an instance provided by Compute Engine v1 API as defined in `https://cloud.google.com/compute/docs/reference/rest/v1/instances`, version will be \"v1\".","ref":"GoogleApi.CloudAsset.V1.Model.VersionedResource.html#module-attributes"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Model.VersionedResource.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.CloudAsset.V1.Model.VersionedResource.html#decode/2"},{"type":"type","title":"GoogleApi.CloudAsset.V1.Model.VersionedResource.t/0","doc":"","ref":"GoogleApi.CloudAsset.V1.Model.VersionedResource.html#t:t/0"},{"type":"module","title":"GoogleApi.CloudAsset.V1.Model.WindowsApplication","doc":"Contains information about a Windows application that is retrieved from the Windows Registry. For more information about these fields, see: https://docs.microsoft.com/en-us/windows/win32/msi/uninstall-registry-key","ref":"GoogleApi.CloudAsset.V1.Model.WindowsApplication.html"},{"type":"module","title":"Attributes - GoogleApi.CloudAsset.V1.Model.WindowsApplication","doc":"*   `displayName` (*type:* `String.t`, *default:* `nil`) - The name of the application or product.\n*   `displayVersion` (*type:* `String.t`, *default:* `nil`) - The version of the product or application in string format.\n*   `helpLink` (*type:* `String.t`, *default:* `nil`) - The internet address for technical support.\n*   `installDate` (*type:* `GoogleApi.CloudAsset.V1.Model.Date.t`, *default:* `nil`) - The last time this product received service. The value of this property is replaced each time a patch is applied or removed from the product or the command-line option is used to repair the product.\n*   `publisher` (*type:* `String.t`, *default:* `nil`) - The name of the manufacturer for the product or application.","ref":"GoogleApi.CloudAsset.V1.Model.WindowsApplication.html#module-attributes"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Model.WindowsApplication.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.CloudAsset.V1.Model.WindowsApplication.html#decode/2"},{"type":"type","title":"GoogleApi.CloudAsset.V1.Model.WindowsApplication.t/0","doc":"","ref":"GoogleApi.CloudAsset.V1.Model.WindowsApplication.html#t:t/0"},{"type":"module","title":"GoogleApi.CloudAsset.V1.Model.WindowsQuickFixEngineeringPackage","doc":"Information related to a Quick Fix Engineering package. Fields are taken from Windows QuickFixEngineering Interface and match the source names: https://docs.microsoft.com/en-us/windows/win32/cimwin32prov/win32-quickfixengineering","ref":"GoogleApi.CloudAsset.V1.Model.WindowsQuickFixEngineeringPackage.html"},{"type":"module","title":"Attributes - GoogleApi.CloudAsset.V1.Model.WindowsQuickFixEngineeringPackage","doc":"*   `caption` (*type:* `String.t`, *default:* `nil`) - A short textual description of the QFE update.\n*   `description` (*type:* `String.t`, *default:* `nil`) - A textual description of the QFE update.\n*   `hotFixId` (*type:* `String.t`, *default:* `nil`) - Unique identifier associated with a particular QFE update.\n*   `installTime` (*type:* `DateTime.t`, *default:* `nil`) - Date that the QFE update was installed. Mapped from installed_on field.","ref":"GoogleApi.CloudAsset.V1.Model.WindowsQuickFixEngineeringPackage.html#module-attributes"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Model.WindowsQuickFixEngineeringPackage.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.CloudAsset.V1.Model.WindowsQuickFixEngineeringPackage.html#decode/2"},{"type":"type","title":"GoogleApi.CloudAsset.V1.Model.WindowsQuickFixEngineeringPackage.t/0","doc":"","ref":"GoogleApi.CloudAsset.V1.Model.WindowsQuickFixEngineeringPackage.html#t:t/0"},{"type":"module","title":"GoogleApi.CloudAsset.V1.Model.WindowsUpdateCategory","doc":"Categories specified by the Windows Update.","ref":"GoogleApi.CloudAsset.V1.Model.WindowsUpdateCategory.html"},{"type":"module","title":"Attributes - GoogleApi.CloudAsset.V1.Model.WindowsUpdateCategory","doc":"*   `id` (*type:* `String.t`, *default:* `nil`) - The identifier of the windows update category.\n*   `name` (*type:* `String.t`, *default:* `nil`) - The name of the windows update category.","ref":"GoogleApi.CloudAsset.V1.Model.WindowsUpdateCategory.html#module-attributes"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Model.WindowsUpdateCategory.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.CloudAsset.V1.Model.WindowsUpdateCategory.html#decode/2"},{"type":"type","title":"GoogleApi.CloudAsset.V1.Model.WindowsUpdateCategory.t/0","doc":"","ref":"GoogleApi.CloudAsset.V1.Model.WindowsUpdateCategory.html#t:t/0"},{"type":"module","title":"GoogleApi.CloudAsset.V1.Model.WindowsUpdatePackage","doc":"Details related to a Windows Update package. Field data and names are taken from Windows Update API IUpdate Interface: https://docs.microsoft.com/en-us/windows/win32/api/_wua/ Descriptive fields like title, and description are localized based on the locale of the VM being updated.","ref":"GoogleApi.CloudAsset.V1.Model.WindowsUpdatePackage.html"},{"type":"module","title":"Attributes - GoogleApi.CloudAsset.V1.Model.WindowsUpdatePackage","doc":"*   `categories` (*type:* `list(GoogleApi.CloudAsset.V1.Model.WindowsUpdateCategory.t)`, *default:* `nil`) - The categories that are associated with this update package.\n*   `description` (*type:* `String.t`, *default:* `nil`) - The localized description of the update package.\n*   `kbArticleIds` (*type:* `list(String.t)`, *default:* `nil`) - A collection of Microsoft Knowledge Base article IDs that are associated with the update package.\n*   `lastDeploymentChangeTime` (*type:* `DateTime.t`, *default:* `nil`) - The last published date of the update, in (UTC) date and time.\n*   `moreInfoUrls` (*type:* `list(String.t)`, *default:* `nil`) - A collection of URLs that provide more information about the update package.\n*   `revisionNumber` (*type:* `integer()`, *default:* `nil`) - The revision number of this update package.\n*   `supportUrl` (*type:* `String.t`, *default:* `nil`) - A hyperlink to the language-specific support information for the update.\n*   `title` (*type:* `String.t`, *default:* `nil`) - The localized title of the update package.\n*   `updateId` (*type:* `String.t`, *default:* `nil`) - Gets the identifier of an update package. Stays the same across revisions.","ref":"GoogleApi.CloudAsset.V1.Model.WindowsUpdatePackage.html#module-attributes"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Model.WindowsUpdatePackage.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.CloudAsset.V1.Model.WindowsUpdatePackage.html#decode/2"},{"type":"type","title":"GoogleApi.CloudAsset.V1.Model.WindowsUpdatePackage.t/0","doc":"","ref":"GoogleApi.CloudAsset.V1.Model.WindowsUpdatePackage.html#t:t/0"},{"type":"module","title":"GoogleApi.CloudAsset.V1.Model.ZypperPatch","doc":"Details related to a Zypper Patch.","ref":"GoogleApi.CloudAsset.V1.Model.ZypperPatch.html"},{"type":"module","title":"Attributes - GoogleApi.CloudAsset.V1.Model.ZypperPatch","doc":"*   `category` (*type:* `String.t`, *default:* `nil`) - The category of the patch.\n*   `patchName` (*type:* `String.t`, *default:* `nil`) - The name of the patch.\n*   `severity` (*type:* `String.t`, *default:* `nil`) - The severity specified for this patch\n*   `summary` (*type:* `String.t`, *default:* `nil`) - Any summary information provided about this patch.","ref":"GoogleApi.CloudAsset.V1.Model.ZypperPatch.html#module-attributes"},{"type":"function","title":"GoogleApi.CloudAsset.V1.Model.ZypperPatch.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.CloudAsset.V1.Model.ZypperPatch.html#decode/2"},{"type":"type","title":"GoogleApi.CloudAsset.V1.Model.ZypperPatch.t/0","doc":"","ref":"GoogleApi.CloudAsset.V1.Model.ZypperPatch.html#t:t/0"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,52,46,50]}}